<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3GUIField extends wm3GUI
  {
   // Arrays
   private $_VALIDATION,$_ERROR_MESSAGES,$_PARAMETERS;
   private $_WIDTHS;

   // Variables
   protected $value,$label;
   protected $hidden,$separator;
   protected $visible,$enabled;
   protected $extra_content_before,$extra_content_after;
   protected $id,$tr_id; // $id its the field id, $tr_id its the id of the <tr> element that contain the field
   protected $javascript,$inactive;
   protected $color;
   private   $error,$error_message;
   private   $label_width;
   private   $span;

   function __construct($name,$value = '',$label = '',$data = array())
    {
	 parent::__construct(null,$data,'',$name);
	 $this->value                = $value;
     $this->label                = $label;
     $this->hidden               = false;
     $this->separator            = false;
	 $this->error                = false;
	 $this->id                   = '';
	 $this->javascript           = '';
	 $this->enabled              = true; // Rend the field only if enabled
	 $this->visible              = true; // Make a field visible/invisible (using css)
	 $this->inactive             = false;
	 $this->extra_content_before = '';
	 $this->extra_content_after  = '';
	 $this->color                = -1; // No color
	 $this->span                 = 0;
	 $this->label_width          = '';
	 $this->_VALIDATION     = array(); // Array used for field validation test
	 $this->_ERROR_MESSAGES = array();
	 $this->_PARAMETERS     = array(); // Parameters (used when needed) for validation test
	 $this->_WIDTHS         = array();
    }

   public function validate()
    {
	 $i = 0;
	 if(!$this->getEnabled()) return true; // Do not check validation for disabled field
	 foreach($this->_VALIDATION as $value)
	  {
       switch($value)
        {
         case WM3_cVALIDATE_NOT_NULL:
          {
		   if($this->value == '') $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_EMAIL:
          {
		   if(!wm3Util::isEmail($this->value)) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_IS_URL:
          {
           if($this->value == '') break; // Can be null
           if(!wm3Util::isUrlRelative($this->value) &&
              !wm3Util::isUrl        ($this->value)) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_IS_URL_ABSOLUTE:
          {
           if($this->value == '') break; // Can be null
           if(!wm3Util::isUrl($this->value)) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_IS_URL_RELATIVE:
          {
           if($this->value == '') break; // Can be null
           if(!wm3Util::isUrlRelative($this->value)) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_IS_INTEGER:
          {
           if($this->value == '') break; // Can be null
           if(!wm3Util::isInteger($this->value)) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_IS_ALPHANUMERIC:
          {
           if(!wm3Util::isAlphanumeric($this->value,$this->_PARAMETERS[$i])) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_IS_DATE:
          {
           if($this->value == '') break; // Can be null
           if(!wm3Util::isDate($this->value,$this->_PARAMETERS[$i])) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_IS_LOGIN:
          {
           if(!wm3Util::isLogin($this->value)) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_GREATER_EQUAL_THAN:
          {
           if(!($this->value >= $this->_PARAMETERS[$i])) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_LESS_EQUAL_THAN:
          {
           if(!($this->value <= $this->_PARAMETERS[$i])) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_FIELDS_EQUAL:
          {
           if(!($this->value == $this->_PARAMETERS[$i]->value))
            {
             $this->error = true;
             $this->_PARAMETERS[$i]->error = true;
		    }
           break;
		  }
         case WM3_cVALIDATE_IS_FORUM_DISCUSSION:
          {
           if(!wm3Forum::isForumDiscussion($this->_PARAMETERS[$i],$this->value)) $this->error = true; // _PARAMETERS[$i] is $w3 (a webmatic3 instance) _PARAMETERS[$i][1] is an userID
           break;
		  }
         case WM3_cVALIDATE_USER_PASSWORD_MATCH:
          {
           if(md5($this->value) != wm3User::getUserPassword($this->_PARAMETERS[$i][1],wm3User::getUserLogin($this->_PARAMETERS[$i][1],$this->_PARAMETERS[$i][0]))) $this->error = true; // _PARAMETERS[$i][0] is an userID, _PARAMETERS[$i][1] is $w3 (a webmatic3 instance)
           break;
		  }
         case WM3_cVALIDATE_EXISTS_EMAIL:
          {
           if(is_array($this->_PARAMETERS[$i]))
            {
             // Check if email exists among users
             if(wm3User::emailExists($this->_PARAMETERS[$i][0],$this->value,$this->_PARAMETERS[$i][1])) $this->error = true; // _PARAMETERS[$i][0] is $w3 (a webmatic3 instance) _PARAMETERS[$i][1] is an userID
		    }
		   else
		    {
             // Check if email exists among newsletter items
		     if(wm3Newsletter::emailExists($this->_PARAMETERS[$i],$this->value)) $this->error = true; // _PARAMETERS[$i] is $w3 (a webmatic3 instance)
            }
           break;
		  }
         case WM3_cVALIDATE_EXISTS_CATEGORY:
          {
           if(!$this->_PARAMETERS[$i]->getSectionObj()->existsCategory($this->_PARAMETERS[$i],$this->value)) $this->error = true; // _PARAMETERS[$i] is $w3 (a webmatic3 instance)
           break;
		  }
         case WM3_cVALIDATE_EXISTS_SUBCATEGORY:
          {
           if(!$this->_PARAMETERS[$i]->getSectionObj()->existsSubcategory($this->_PARAMETERS[$i],$this->value)) $this->error = true; // _PARAMETERS[$i] is $w3 (a webmatic3 instance)
           break;
		  }
         case WM3_cVALIDATE_EXISTS_SURVEY:
          {
           if(!wm3Survey::existsSurvey($this->_PARAMETERS[$i],$this->value)) $this->error = true; // _PARAMETERS[$i] is $w3 (a webmatic3 instance)
           break;
		  }
         case WM3_cVALIDATE_EXISTS_FORUM:
          {
           if(!wm3Forum::existsForum($this->_PARAMETERS[$i],$this->value)) $this->error = true; // _PARAMETERS[$i] is $w3 (a webmatic3 instance)
           break;
		  }
         case WM3_cVALIDATE_EXISTS_FORUM_DISCUSSION:
          {
           if(!wm3Forum::existsForumDiscussion($this->_PARAMETERS[$i][1],$this->_PARAMETERS[$i][0]->value,$this->value)) $this->error = true; // _PARAMETERS[$i][1] is $w3 (a webmatic3 instance)
           break;
		  }
         case WM3_cVALIDATE_EXISTS_FORUM_DISCUSSION_OR_REPLY:
          {
           $postID  = $this->value;
           $forumID = $this->_PARAMETERS[$i][0];
           $quoteID = $this->_PARAMETERS[$i][1];
           if($postID == $quoteID) $postID = 0; // Try to quote a discussion
	       if(!wm3Forum::existsForumReply($this->_PARAMETERS[$i][2],$forumID,$postID,$quoteID)) $this->error = true; // _PARAMETERS[$i][2] is $w3 (a webmatic3 instance)
           break;
		  }
         case WM3_cVALIDATE_EXISTS_DIRECTORY:
          {
           if(!wm3Directory::existsDirectory($this->_PARAMETERS[$i],$this->value)) $this->error = true; // _PARAMETERS[$i] is $w3 (a webmatic3 instance)
           break;
		  }
         case WM3_cVALIDATE_EXISTS_URL:
          {
           if($this->_PARAMETERS[$i][1]->getDBObj()->existValue(WM3_cCONFIG_DB_PREFIX.'_search_engines_items','url',$this->value,'search_engine_itemID',$this->_PARAMETERS[$i][0])) $this->error = true; // _PARAMETERS[$i][0] is a search_engine_itemID, _PARAMETERS[$i][1] is $w3 (a webmatic3 instance)
           break;
		  }
         case WM3_cVALIDATE_EXISTS_LOGIN:
          {
           if(wm3User::loginExists($this->_PARAMETERS[$i],$this->value)) $this->error = true; // _PARAMETERS[$i] is $w3 (a webmatic3 instance)
           break;
		  }
         case WM3_cVALIDATE_EXISTS_PAGE:
          {
		   if(!wm3Page::existsPage($this->_PARAMETERS[$i],$this->value) && $this->value != 0) $this->error = true; // _PARAMETERS[$i] is $w3 (a webmatic3 instance)
           break;
		  }
         case WM3_cVALIDATE_EXISTS_MENU:
          {
		   if(!wm3Menu::existsMenu($this->_PARAMETERS[$i],$this->value) && $this->value != 0) $this->error = true; // _PARAMETERS[$i] is $w3 (a webmatic3 instance)
           break;
		  }
         case WM3_cVALIDATE_EXISTS_MENU_ITEM_PAGE:
          {
           if($this->_PARAMETERS[$i]->value == WM3_cMENU_ITEM_CATEGORY_CUSTOM && !$this->value) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_EXISTS_MENU_ITEM_SUBCHANNEL:
          {
           if($this->_PARAMETERS[$i]->value == WM3_cMENU_ITEM_CATEGORY_CHANNEL && !$this->value) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_EXISTS_PANEL_SURVEY:
          {
           if($this->_PARAMETERS[$i]->value == WM3_cPANEL_CATEGORY_SURVEY && !$this->value) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_EXISTS_PANEL_MENU:
          {
           if($this->_PARAMETERS[$i]->value == WM3_cPANEL_CATEGORY_MENU && !$this->value) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_EXISTS_EXPANSION_PAGE:
          {
		   if($this->_PARAMETERS[$i]->value == WM3_cPAGE_CATEGORY_EXPANSION && !isset($this->value)) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_EXISTS_EXPANSION_PANEL:
          {
           if($this->_PARAMETERS[$i]->value == WM3_cPANEL_CATEGORY_EXPANSION && !isset($this->value)) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_CAPTCHA:
          {
           if(wm3Captcha::canUseCaptcha())
            if(!wm3Captcha::testPassedCaptcha($this->_PARAMETERS[$i],$this->name)) $this->error = true; // _PARAMETERS[$i] is $w3 (a webmatic3 instance)
           break;
		  }
         case WM3_cVALIDATE_MENU_ITEM_EXTERNAL_NOT_NULL:
          {
           if($this->_PARAMETERS[$i]->value == WM3_cMENU_ITEM_CATEGORY_EXTERNAL && !$this->value) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_DIRECTORY_HOME_IS_URL:
          {
		   if($this->_PARAMETERS[$i]->value == WM3_cFILE_EXTERNAL)
            if(!wm3Util::isUrlRelative($this->value) &&
               !wm3Util::isUrl        ($this->value)) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_DIRECTORY_DOWNLOAD_IS_URL:
          {
		   if($this->_PARAMETERS[$i]->value == WM3_cFILE_EXTERNAL)
		    if($this->value)
             if(!wm3Util::isUrlRelative($this->value) &&
                !wm3Util::isUrl        ($this->value)) $this->error = true;
           break;
		  }
         case WM3_cVALIDATE_HOME_DIRECTORY_DOWNLOAD_IS_URL:
          {
           if($this->value)
            if(!wm3Util::isUrl($this->value)) $this->error = true;
           break;
		  }
         default: return true;
		}
       if($this->error) // An error as occurred
        {
         $this->error_message = $this->_ERROR_MESSAGES[$i];
         return false;
        }
       $i++;
	  }
	 return true;
	}

   public function addValidation($type,$message,$parameters = '')
    {
     array_push($this->_VALIDATION,$type);
     array_push($this->_ERROR_MESSAGES,$message);
     array_push($this->_PARAMETERS,$parameters);
	}

   public function isHidden()    { return $this->hidden; }
   
   public function isSeparator() { return $this->separator; }

   public function setValue($value)            { $this->value = $value; }
   
   public function setVisible($visible)        { $this->visible = $visible; }
   
   public function setEnabled($enabled)        { $this->enabled = $enabled; }
   
   public function setID($id)                  { $this->id = $id; }
   
   public function setTrID($tr_id)             { $this->tr_id = $tr_id; }

   public function setJavascript($js)          { $this->javascript = $js; }

   public function setInactive($inactive)      { $this->inactive = $inactive; }

   public function setColor($color)            { $this->color = $color; }
   
   public function setSpan($span)              { $this->span = $span; }

   public function setLabelWidth($label_width) { $this->label_width = $label_width; }

   public function setWidths($widths)          { $this->_WIDTHS = $widths; }

   public function setError($error)            { $this->error = $error; }

   public function setExtraContentBefore($extra_content_before) { $this->extra_content_before = $extra_content_before; }

   public function setExtraContentAfter($extra_content_after)   { $this->extra_content_after  = $extra_content_after; }

   public function getValue()        { return $this->value; }

   public function getEnabled()      { return $this->enabled; }
   
   public function getVisible()      { return $this->visible; }

   public function getID()           { return $this->id; }
   
   public function getTrID()         { return $this->tr_id; }

   public function getLabel()        { return $this->label; }

   public function getError()        { return $this->error; }
   
   public function getErrorMessage() { return $this->error_message; }
   
   public function getColor()        { return $this->color; }

   public function getSpan()         { return $this->span; }
   
   public function getLabelWidth()   { return $this->label_width; }

   public function getWidths()       { return $this->_WIDTHS; }

   public function getJavascript()   { return $this->javascript; }

  }

?>
