<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3GUIForm extends wm3GUI
  {
   // Arrays

   // Variables
   private $action,$method;
   private $upload; // True for file upload form
   private $error;
   private $submit_label,$reset_label;
   private $extra_content_bottom_before,$extra_content_bottom_after;
   private $javascript_submit_button;
   private $use_colors,$invert_colors;
   private $render_form_tag,$render_header,$render_bottom;
   private $render_submit_button,$render_reset_button;
   private $simple_render;
   private $was_submit,$use_was_submit;
   private $fields_columns; // Max columns for fields

   function __construct($w3,$action,$title = '',$name = '',$data = array())
    {
     // $data must be an array of wm3GUIField objects
	 parent::__construct($w3,$data,$title,$name);
	 $this->method                      = "post";
	 $this->action                      = $action;
	 $this->upload                      = false;
	 $this->error                       = false;
	 $this->submit_label                = $w3->getWord(191);
	 $this->reset_label                 = $w3->getWord(192);
	 $this->use_colors                  = true;
	 $this->invert_colors               = false;
	 $this->render_form_tag             = true;
	 $this->render_header               = true;
	 $this->render_bottom               = true;
     $this->render_submit_button        = true;
	 $this->render_reset_button         = true;
	 $this->simple_render               = false;
	 $this->fields_columns              = 1;
     $this->use_was_submit              = true;
     $this->javascript_submit_button    = '';
	 $this->extra_content_bottom_before = '';
	 $this->extra_content_bottom_after  = '';
	 if($w3->getVariable('wm3_was_submit','post')) $this->was_submit = true;
	 else                                          $this->was_submit = false;
    }

   public function render()
    {
	 $str = '';

	 // Render open form tag
	 if($this->render_form_tag) $str = $this->renderOpen();

	 // Render form header
     if($this->render_header)   $str .= $this->renderHeader();

     // Render form body
     $str .= $this->renderBody();

     // Render form bottom
     $str .= $this->renderBottom();

	 // Render close form tag
	 if($this->render_form_tag) $str .= $this->renderClose();

	 return $str;
	}

   public function renderOpen()
    {
     // Render open form tag
     if($this->upload) $upload = 'enctype="multipart/form-data"'; else $upload = '';
     return "<form name=\"".$this->name."\" method=\"".$this->method."\" action=\"".$this->action."\" $upload>";
    }

   public function renderHeader()
    {
     // Render a generic header for a form
     if($this->title) $empty = false; else $empty = true;
     if($this->error) return $this->makeHeader(WM3_cSKIN_ERROR,1 + $this->fields_columns,$empty);
     else             return $this->makeHeader(0,1 + $this->fields_columns,$empty);
    }

   public function renderBody()
    {
     // Render the form body (all fields but hidden fields)
     $str = ''; $p = 0;
     $field = current($this->_DATA);
     while($field)
      {
       if(!$field->isHidden())
        {
		 if($field->getEnabled())
		  {
	       if(!$field->isSeparator())
	        {
             if($field->getSpan() > 0)
              {
               $_CONTENTS = array();
               array_push($_CONTENTS,$field->render());
	           for($i = 1; $i < $field->getSpan(); $i++) array_push($_CONTENTS,next($this->_DATA)->render());
		      }
		     else $_CONTENTS = $field->render();
            }
		   if(!$field->getVisible()) $extra = 'style="display:none"'; else $extra = '';
           if($field->getError()) $str .= $this->makeItem(WM3_cSKIN_ERROR,$field->getLabel(),$_CONTENTS,$this->fields_columns,$field->getTrID(),$extra,$field->getLabelWidth(),$field->getWidths());
           else                   {
                                   if($field->isSeparator()) $str .= $this->makeSeparator(1 + $this->fields_columns,$field->getLabel(),$field->getWidths());
                                   else
                                    {
                                     if($this->use_colors)
			                          {
									   if($field->getColor() >= 0) $c = $field->getColor();
			                           else                        $c = $p%2;
								      }
								     else $c = 0;
			                         $str .= $this->makeItem($c,$field->getLabel(),$_CONTENTS,$this->fields_columns,$field->getTrID(),$extra,$field->getLabelWidth(),$field->getWidths());
								    }
							      }
           $p++;
	      }
        }
       $field = next($this->_DATA);
      }

     // Add hidden field for wasSubmit() control
     if(count($this->_DATA) > 0 && $this->use_was_submit)
      $this->addField(new wm3GUIHiddenField('wm3_was_submit','1'));

     return $str;
    }

   public function renderBottom()
    {
	 // Render the form bottom
	 if($this->render_bottom)
	  {
       if($this->render_submit_button)
        {
		 $field = new wm3GUIButton('send',$this->submit_label);
		 $field->setJavascript($this->javascript_submit_button);
		 $input_submit = $field->render();
        }
       else $input_submit = '';
	   if($this->render_reset_button)
	    {
         $field = new wm3GUIButton('reset',$this->reset_label);
         $field->setTypeReset();
         $input_reset = ' '.$field->render();
        }
       else $input_reset = '';
	   if(!$this->render_submit_button && !$this->render_reset_button) $empty = true; else $empty = false;
       $str = $this->makeBottom($this->extra_content_bottom_before.$input_submit.$input_reset.$this->extra_content_bottom_after,1 + $this->fields_columns,$empty);
      }
     else $str = '';
     // Render hidden fields
     foreach($this->_DATA as $field)
      if($field->isHidden()) if($field->getEnabled()) $str .= $field->render();
     return $str;
    }

   public function renderClose()
    {
     // Render close form tag
     return "</form>";
    }

   public function makeHeader($p,$colspan,$empty = false)
    {
	 $title = $this->title;
     ob_start();
	 if($p == WM3_cSKIN_ERROR) $error = true; else $error = false;
	 if($colspan) $colspan = "colspan=\"$colspan\"";
     require($this->_skin->getFormTitle($error,$empty));
     $str = ob_get_contents();
     ob_end_clean();
	 return $str;
	}

   public function makeItem($p,$label,$_CONTENTS,$colspan=0,$id='',$extra='',$label_width='',$_WIDTHS='')
    {
     // Create a generic item field for a form
     ob_start();
     if($this->simple_render) return $_CONTENTS." "; // Render fields without using skin
	 if($p == WM3_cSKIN_ERROR) $error = true; else { $error = false; if($this->invert_colors) $p++; }
	 if($id) $id = "id=\"$id\"";
	 if(is_array($_CONTENTS))
	  {
       $colspan = '';
       if($label_width) $width = "width=\"$label_width%\""; else $width = '';
       require($this->_skin->getFormItemStart($p,$error));
       for($i = 0; $i<count($_CONTENTS); $i++)
	    {
		 $content = $_CONTENTS[$i];
		 if(count($_WIDTHS) > 0) $width = "width=\"".$_WIDTHS[$i]."%\""; else $width = '';
		 require($this->_skin->getFormItem($p,$error));
		}
	   require($this->_skin->getFormItemEnd($p,$error));
	  }
	 else
	  {
       if($colspan > 1) $colspan = "colspan=\"$colspan\""; else $colspan = '';
	   $content = $_CONTENTS; $width = '';
	   require($this->_skin->getFormItemStart($p,$error));
	   require($this->_skin->getFormItem($p,$error));
       require($this->_skin->getFormItemEnd($p,$error));
      }
     $str = ob_get_contents();
     ob_end_clean();
	 return $str;
	}

   public function makeSeparator($colspan,$_CONTENTS='',$_WIDTHS='')
    {
     ob_start();
	 if(is_array($_CONTENTS))
	  {
	   $colspan = '';
       $title = $_CONTENTS[0]; if(isset($_WIDTHS[0])) $width = "width=\"".$_WIDTHS[0]."%\""; else $width = '';
       require($this->_skin->getFormSeparatorStart());
       for($i = 1; $i < count($_CONTENTS); $i++)
	    {
		 $title = $_CONTENTS[$i]; if(isset($_WIDTHS[$i])) $width = "width=\"".$_WIDTHS[$i]."%\""; else $width = '';
		 require($this->_skin->getFormSeparator($title));
		}
	   require($this->_skin->getFormSeparatorEnd());
	  }
	 else
	  {
       if($colspan) $colspan = "colspan=\"$colspan\"";
       $title = $_CONTENTS; $width = '';
	   if($title) require($this->_skin->getFormSeparatorStart());
	   else       require($this->_skin->getFormSeparator($title));
	   require($this->_skin->getFormSeparatorEnd());
      }
     $str = ob_get_contents();
     ob_end_clean();
	 return $str;
	}

   public function makeBottom($content,$colspan,$empty = false)
    {
     ob_start();
	 if($colspan) $colspan = "colspan=\"$colspan\"";
     require($this->_skin->getFormBottom($empty));
     $str = ob_get_contents();
     ob_end_clean();
	 return $str;
	}

   public function wasSubmit()
    {
	 if(!$this->use_was_submit) return false;
	 else                       return $this->was_submit;
	}

   public function validate()
    {
     $aux = $this->_DATA; // Work on a copy due to foreach array pointer modifications
	 foreach($aux as $field)
	  {
       if(!$field->validate())
        {
		 $this->error = true;
		 $this->title = $field->getErrorMessage();
		 return false;
		}
      }
     return true;
	}

   public function addField($field)
    {
     array_push($this->_DATA,$field);
	}

   public function setFieldsValues($array,$search_fields = false)
    {//TODO commentare questa funzione
	 foreach($array as $key => $value)
	  {
	   if($search_fields)
	    {
	     foreach($this->_DATA as $field)
	      {
		   if($field->name == $key) { $field->setValue($value); break; }
		  }
		}
       else if(isset($this->_DATA[$key])) $this->_DATA[$key]->setValue($value); //uso i nomi dei campi per l'assegnazione
	  }
	}

   public function setRenderSubmitButton($render_submit_button)              { $this->render_submit_button = $render_submit_button; }

   public function setJavascriptSubmitButton($javascript_submit_button)      { $this->javascript_submit_button = $javascript_submit_button; }

   public function setRenderResetButton($render_reset_button)                { $this->render_reset_button = $render_reset_button; }

   public function setSimpleRender($simple_render)                           { $this->simple_render = $simple_render; }

   public function setRenderFormTag($render_form_tag)                        { $this->render_form_tag = $render_form_tag; }
   
   public function setRenderHeader($render_header)                           { $this->render_header = $render_header; }

   public function setRenderBottom($render_bottom)                           { $this->render_bottom = $render_bottom; }

   public function setSubmitLabel($label)                                    { $this->submit_label = $label; }

   public function setResetLabel($label)                                     { $this->reset_label = $label; }

   public function setFieldsColumns($fields_columns)                         { $this->fields_columns = $fields_columns; }

   public function setUpload($upload)                                        { $this->upload = $upload; }

   public function setError($error)                                          { $this->error = $error; }

   public function setUseWasSubmit($use_was_submit)                          { $this->use_was_submit = $use_was_submit; }

   public function setInvertColors($invert_colors)                           { $this->invert_colors = $invert_colors; }

   public function setExtraContentBottomBefore($extra_content_bottom_before) { $this->extra_content_bottom_before = $extra_content_bottom_before; }

   public function setExtraContentBottomAfter($extra_content_bottom_after)   { $this->extra_content_bottom_after  = $extra_content_bottom_after; }

  }

?>
