<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Directory
  {

   function __construct() { }

   public static function getDirectoryFieldsArray()
    {
     return array('directoryID','name','description','directory_type','enabled','languageID','parentID','icon','ts');
    }

   public static function getDirectoryItemFieldsArray()
    {
     return array('directory_itemID','title','render_mode','description','userID','source',
	              'pageID','hits','home_url','download_url',
				  'enabled','languageID','icon','directoryID','votes_counts','votes_sum','votes_average','directory_item_ts','ts');
    }

   public static function executeHomeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_DIRECTORY_ITEM:
        {
		 if(wm3Directory::isDirectoryCanHaveFile($w3,$w3->getVariable('directoryID'),false) &&
		    wm3Directory::canAddDirectoryItem($w3))
          return wm3Directory::addDirectoryItem($w3,true);
		 else
		   return wm3Directory::getDirectoryList($w3,0,false,false);
         break;
        }
       case WM3_cACTION_SHOW_DIRECTORY_ITEM:
        {
         return wm3Directory::getDirectoryItemList($w3,0,false);
         break;
        }
       case WM3_cACTION_SHOW_SINGLE_DIRECTORY_ITEM:
        {
         wm3Directory::hitDirectoryItem($w3);
         return wm3Directory::renderDirectoryItem($w3);
         break;
        }
       case WM3_cACTION_RATE_DIRECTORY_ITEM:
        {
         wm3Directory::rateDirectoryItem($w3);
         return wm3Directory::renderDirectoryItem($w3);
         break;
        }
       case WM3_cACTION_SHOW_DIRECTORY_ITEM_TOP_RATING:
        {
         return wm3Directory::renderDirectoryItemTopRating($w3,"ORDER BY votes_average DESC",1219,true,false,false)."<br><br>".
		        wm3Directory::renderDirectoryItemTopRating($w3,"ORDER BY hits DESC"         ,1220,false,true,false)."<br><br>".
				wm3Directory::renderDirectoryItemTopRating($w3,"ORDER BY votes_counts DESC" ,1221,false,false,true);
         break;
        }
       case WM3_cACTION_SHOW_DIRECTORY_ITEM_LAST_INSERTED:
        {
         return wm3Directory::renderDirectoryItemLastInserted($w3,"ORDER BY ts DESC",1218,30);
         break;
        }
       default:
        {
         return wm3Directory::getDirectoryList($w3,0,false);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_DIRECTORY:
        {
		 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories WRITE");
         wm3Directory::disableDirectory($w3,$w3->getVariable('directoryID','get'));
		 $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Directory::getDirectoryList($w3,$w3->getVariable('directoryID','get'),true,false);
         break;
        }
       case WM3_cACTION_ENABLE_DIRECTORY:
        {
		 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories WRITE");
         wm3Directory::enableDirectory($w3,$w3->getVariable('directoryID','get'));
		 $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Directory::getDirectoryList($w3,$w3->getVariable('directoryID','get'),true,false);
         break;
        }
       case WM3_cACTION_DELETE_DIRECTORY:
        {
		 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories       WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_directories_items WRITE");
         wm3Directory::enableDirectory($w3,$w3->getVariable('directoryID','get'));
         wm3Directory::deleteDirectory($w3,$w3->getVariable('directoryID','get'));
		 $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Directory::getDirectoryList($w3,0,true,false);
         break;
        }
       case WM3_cACTION_ADD_DIRECTORY:
        {
         return wm3Directory::addDirectory($w3);
         break;
        }
       case WM3_cACTION_EDIT_DIRECTORY:
        {
         return wm3Directory::editDirectory($w3);
         break;
        }
       /*case WM3_cACTION_DUPLICATE_DIRECTORY:
        {//TODO LOCK TABLE
         $lastID = wm3Directory::duplicateDirectory($w3);
         // $msg= message duplicated...//TODO
         return wm3Directory::getDirectoryList($w3,$lastID);
         break;
        }*/
       case WM3_cACTION_DISABLE_DIRECTORY_ITEM:
        {
         wm3Directory::disableDirectoryItem($w3,$w3->getVariable('directory_itemID','get'));
         return wm3Directory::getDirectoryItemList($w3,$w3->getVariable('directory_itemID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_DIRECTORY_ITEM:
        {
         wm3Directory::enableDirectoryItem($w3,$w3->getVariable('directory_itemID','get'));
         return wm3Directory::getDirectoryItemList($w3,$w3->getVariable('directory_itemID','get'));
         break;
        }
       case WM3_cACTION_DELETE_DIRECTORY_ITEM:
        {
         wm3Directory::deleteDirectoryItem($w3,$w3->getVariable('directory_itemID','get'));
         return wm3Directory::getDirectoryItemList($w3);
         break;
        }
       case WM3_cACTION_ADD_DIRECTORY_ITEM:
        {
		 if(wm3Directory::isDirectoryCanHaveFile($w3,$w3->getVariable('directoryID')))
          return wm3Directory::addDirectoryItem($w3);
		 else
		  return wm3Directory::getDirectoryList($w3,0,true,false);
         break;
        }
       case WM3_cACTION_EDIT_DIRECTORY_ITEM:
        {
         return wm3Directory::editDirectoryItem($w3);
         break;
        }
       case WM3_cACTION_DUPLICATE_DIRECTORY_ITEM:
        {
         $lastID = wm3Directory::duplicateDirectoryItem($w3);
         // $msg= directory duplicated...//TODO
         return wm3Directory::getDirectoryItemList($w3,$lastID);
         break;
        }
       case WM3_cACTION_SHOW_DIRECTORY_ITEM:
        {
         return wm3Directory::getDirectoryItemList($w3);
         break;
        }
       default:
        {
         return wm3Directory::getDirectoryList($w3);
        }
      }
    }

   public static function getDirectoryList($w3,$currentID = 0,$admin = true,$flag_directory = true)
    {
     // Get current directory subfolder list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DIRECTORIES); // Used to enable admin buttons in home stage
     // Fix directory delete bug
	 if($flag_directory) $directoryID = $w3->getVariable('directoryID');
	 else                $directoryID = $w3->getVariable('parentID');
     $pg = $w3->getVariable('pg');
     $filter       = $w3->getVariable('filter'); // Search fields
	 $filter_check = $w3->getVariable('filter_check');
     $query_filter = " WHERE parentID='$directoryID'";
     if($admin)
      {
	   $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_DIRECTORY_ITEM;
      }
     else
      {
       $pageID = $w3->getVariable('pageID','get');
       $page_link  = "&pageID=$pageID";
	   $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DIRECTORY_ITEM."$page_link";
       $query_filter .= " AND enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'";
      }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DIRECTORIES;
     $id_link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY name";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_directories $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'directoryID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     if($admin) $pic_folder = "<img src=\"".WM3_cPATH_DATA."misc_folder.png\" width=\"16\" height=\"16\" border=\"0\" align=\"absmiddle\"> ";
	 else       $pic_folder = "<img src=\"".WM3_cPATH_DATA."misc_folder.png\" width=\"36\" height=\"36\" border=\"0\" align=\"absmiddle\"> ";
	 $pic_total_folders = "<img src=\"".WM3_cPATH_DATA."misc_folder_mini.png\" width=\"10\" height=\"8\" border=\"0\" align=\"absmiddle\">";
	 $pic_total_files   = "<img src=\"".WM3_cPATH_DATA."misc_file_mini.png\" width=\"7\" height=\"9\" border=\"0\" align=\"absmiddle\">";
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&directoryID=$row->directoryID";
       if($allowed) $allowed_link = $base_allowed_link."&directoryID=$row->directoryID";

       $total_folders = wm3Directory::countDirectoryFolders($w3,$row->directoryID);
       $total_files   = wm3Directory::countDirectoryFiles($w3,$row->directoryID);
       if($admin) $name = "<a href=\"$link\">$pic_folder$row->name</a><br><i>$row->description</i>";
	   else       {
                   if($allowed) $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DIRECTORY,"action_edit.png",$w3->getWord(178)); else $button = "";
			       $picture_content     = "<a href=\"$link$page_link\">".$pic_folder."</a>";
				   $button_show = wm3Util::actionButton("$link$page_link&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM,"action_show.png",$w3->getWord(648),"","",0,16,16);
				   if($row->directory_type == WM3_cDIRECTORY_FILE &&
	                  wm3Directory::canAddDirectoryItem($w3))
                    $button_add = wm3Util::actionButton("$link$page_link&action=".WM3_cACTION_ADD_DIRECTORY_ITEM,"action_add.png",$w3->getWord(836),"","",0,16,16); else $button_add = "";
				   $title_content       = "<nobr><a href=\"$link$page_link\">$row->name</a> $button_show $button_add $button</nobr><br><nobr>($pic_total_folders=$total_folders, $pic_total_files=$total_files)</nobr>";
				   $description_content = wm3Directory::renderDirectorySubfoldersPreview($w3,$row->directoryID,$base_link.$id_link.$extra_link.$page_link);
                   ob_start();
                   require($w3->getSkinObj()->getFrameDirectory());
                   $item_content = ob_get_contents();
                   ob_end_clean();
                   $_DATA[$p]->name = $item_content;
				  }
       if($admin) {
		           $_DATA[$p]->name = $name;
                   $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
                   $info = $lang_flag." ($pic_total_folders=$total_folders, $pic_total_files=$total_files)<br>";
		           if($row->directory_type == WM3_cDIRECTORY_FILE) $info .= $w3->getWord(1165); else $info .= $w3->getWord(1166);
                   $_DATA[$p]->info = $info;

                   // Buttons
                   if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link&parentID=$row->parentID&action=".WM3_cACTION_DISABLE_DIRECTORY,"action_disable.png",$w3->getWord(180));
                   else              $_DATA[$p]->b1 = wm3Util::actionButton("$link&parentID=$row->parentID&action=".WM3_cACTION_ENABLE_DIRECTORY,"action_enable.png",$w3->getWord(181));
                   $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_ADD_DIRECTORY,"action_add_directory.png",$w3->getWord(1163));
                   $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM,"action_show_file.png",$w3->getWord(648));
                   if($row->directory_type == WM3_cDIRECTORY_FILE) $_DATA[$p]->b4 = wm3Util::actionButton("$link&action=".WM3_cACTION_ADD_DIRECTORY_ITEM,"action_add_file.png",$w3->getWord(836));
				   else                                            $_DATA[$p]->b4 = wm3Util::renderImg("action_add_file_inactive.png",'',24,24);
                   $_DATA[$p]->b5 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_DIRECTORY,"action_edit.png",$w3->getWord(178));
                   $_DATA[$p]->b6 = wm3Util::actionButton("$link&parentID=$row->parentID&action=".WM3_cACTION_DELETE_DIRECTORY,"action_delete.png",$w3->getWord(179),$w3->getWord(774));
                  }
       if($admin) if($row->directoryID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1160));
     $list->setTotalItems($total_items);
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE.'admin_directory_search_form.inc');
     $list->setSearchForm($search_form);
	 if($admin) {
		         $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&directoryID=$directoryID&action=".WM3_cACTION_ADD_DIRECTORY,"action_add.png","","",$w3->getWord(1163),0,16,16));
	             $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&directoryID=$directoryID&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM,"action_show.png","","",$w3->getWord(648),0,16,16));
				 $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&directoryID=$directoryID&action=".WM3_cACTION_ADD_DIRECTORY_ITEM,"action_add.png","","",$w3->getWord(836),0,16,16));
				}
	 else       {
		         $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
				 $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_LAST_INSERTED,"action_up.png","","",$w3->getWord(1218),0,16,16));
			    }
     if($admin) $list->setTitle($list->getTitle()."<br>".wm3Directory::makeDirectoryPath($w3,$directoryID,$base_link,$admin));
	 else       $list->setTitle($list->getTitle()."<br>".wm3Directory::makeDirectoryPath($w3,$directoryID,$base_link.$page_link,$admin));
     $list->setTitle($list->getTitle()."<br><i>".wm3Directory::getDirectoryDescription($w3,$directoryID)."</i>");
	 if($found) $list->setCurrentID($currentID);
	 $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     if($admin) {
                 $list->setPagesNavigatorLink($base_link.$id_link);
                 $list->setCaptionLabels(array($w3->getWord(1156),$w3->getWord(1671)));
                 $list->setCaptionWidths(array(70,30));
                 $list->setCaptionColspan(array(1,1,6));
                 $list->setWidths(array(70,30));
			    }
     else       {
		         $list->setRenderCaption(false);
                 $list->setPagesNavigatorLink($base_link.$page_link.$id_link);
                 $list->setWidths(array(25,25,25,25));
                 $list->setObjectsPerRow(4);
                 $list->setUseColors(false);
                }
     return $list->render();
    }

   public static function getDirectoryItemList($w3,$currentID = 0,$admin = true)
    {
     // Get current directory items list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DIRECTORIES); // Used to enable admin buttons in home stage
	 $directoryID = $w3->getVariable('directoryID');
     $pg = $w3->getVariable('pg');
     $filter       = $w3->getVariable('filter'); // Search fields
	 $filter_check = $w3->getVariable('filter_check');
     $query_filter = " WHERE directoryID='$directoryID'";
     if($filter)
      {
       $search_link = "&filter=$filter";
	   if($filter_check) 
	    {
		 $search_link .= "&filter_check=$filter_check";
		 $query_filter = "WHERE 1=1";
		}
       $query_filter .= " AND title LIKE '%$filter%'";
      }
     else { $search_link = ''; }
     if($admin)
      {
	   $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_DIRECTORY_ITEM;
      }
     else
      {
       $pageID = $w3->getVariable('pageID','get');
       $page_link  = "&pageID=$pageID";	   
       $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DIRECTORY_ITEM."$page_link";
       $query_filter .= " AND enabled='".WM3_cENABLED."' AND (languageID='".$w3->getHomeLanguage()."' OR languageID='".WM3_cLANGUAGE_ALL."')";
      }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DIRECTORIES;
     $id_link = "&directoryID=$directoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY title";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_directories_items $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'directory_itemID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     $pic_download = "<img src=\"".WM3_cPATH_DATA."misc_download.png\" width=\"16\" height=\"16\" border=\"0\" align=\"absmiddle\">";
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&directoryID=$row->directoryID&directory_itemID=$row->directory_itemID";
       if($allowed) $allowed_link = $base_allowed_link."&directory_itemID=$row->directory_itemID";
       if($admin)
        {
	     if($row->source == WM3_cFILE_INTERNAL) { $title = wm3Page::makePageLink($row->pageID,wm3Util::renderContent($w3,$row->title,$row->render_mode)); }
	     else                                   {
			                                     $title =  "<a href=\"$row->home_url\" target=\"_blank\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a>";
	                                             if($row->download_url) $title .= " <a href=\"$row->download_url\" target=\"_blank\">$pic_download</a>";
	                                            }
	     $hits = "($row->hits hits)";
	     $rating = "(Rating: $row->votes_average)";
	     $title = "$title $hits $rating";
	     if($filter && $filter_check)
	      {
		   // For the search in all categories
		   $title .= "<br>(Path:".wm3Directory::makeDirectoryPath($w3,$row->directoryID,$base_link,$admin).")";
		  }
         $_DATA[$p]->title = $title;
		 $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $info = $lang_flag."<br>";
		 if($row->source == WM3_cFILE_INTERNAL) $info .= $w3->getWord(1181); else $info .= $w3->getWord(1182);
		 $login = wm3User::getUserLogin($w3,$row->userID); if(!$login) $login = $w3->getWord(988);
		 $info .= " (".$w3->getWord(1194)." $login)";
         $_DATA[$p]->info = $info;
         // Buttons
         if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_DIRECTORY_ITEM,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_DIRECTORY_ITEM,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_DIRECTORY_ITEM,"action_edit.png",$w3->getWord(178));
		 $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DUPLICATE_DIRECTORY_ITEM,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1416));
         $_DATA[$p]->b4 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_DIRECTORY_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(774));
        }
       else
        {
		 $published = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
		 $updated   = wm3Util::renderDate($w3,$row->directory_item_ts,$w3->getHomeLanguage());
		 $title  = "<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_DIRECTORY_ITEM."\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a><br><br>
		            <i>Published: $published</i><br><i>Last update: $updated</i><br>";
		 $rating = "<nobr>".wm3Util::makeStars($w3,$row->votes_average)." ($row->votes_average)</nobr>";
		 $hits   = "<nobr>$row->hits hits</nobr>";
		 $_DATA[$p]->title  = $title;
		 $_DATA[$p]->rating = $rating;
		 $_DATA[$p]->hits   = $hits;
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DIRECTORY_ITEM,"action_edit.png",$w3->getWord(178));
        }
       if($row->directory_itemID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1160));
     $list->setTotalItems($total_items);
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE.'admin_directory_search_form.inc');
     $list->setSearchForm($search_form);
	 $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     if($found) $list->setCurrentID($currentID);
	 if($admin) {
		         $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&directoryID=$directoryID&action=".WM3_cACTION_ADD_DIRECTORY,"action_add.png","","",$w3->getWord(1163),0,16,16));
	             $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&directoryID=$directoryID&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM,"action_show.png","","",$w3->getWord(648),0,16,16));
				 $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&directoryID=$directoryID&action=".WM3_cACTION_ADD_DIRECTORY_ITEM,"action_add.png","","",$w3->getWord(836),0,16,16));
				}
	 else       {
                 $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
				 $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_LAST_INSERTED,"action_up.png","","",$w3->getWord(1218),0,16,16));
				}
     if($admin) $list->setTitle($list->getTitle()."<br>".wm3Directory::makeDirectoryPath($w3,$directoryID,$base_link,$admin));
	 else       $list->setTitle($list->getTitle()."<br>".wm3Directory::makeDirectoryPath($w3,$directoryID,$base_link.$page_link,$admin));
     $list->setTitle($list->getTitle()."<br><i>".wm3Directory::getDirectoryDescription($w3,$directoryID)."</i>");
     if($admin) {
                 $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM.$id_link.$search_link);
                 $list->setCaptionLabels(array($w3->getWord(1556),$w3->getWord(1671)));
                 $list->setCaptionWidths(array(70,30));
                 $list->setCaptionColspan(array(1,1,4));
                 $list->setWidths(array(70,30));
			    }
     else       {
		         $list->setRenderCaption(false);
		         $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM.$id_link.$search_link);
                 $list->setWidths(array(80,15,5));
                }
     return $list->render();
    }

   public static function addDirectory($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryFieldsArray());
	 $action = WM3_cACTION_ADD_DIRECTORY;
	 require(WM3_cPATH_INCLUDE.'admin_directory_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1169));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
       $_F['parentID']->setValue($w3->getVariable('directoryID','get')); // Take parentID from get
      }
     else
      {
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories WRITE");			
       if($form->validate())
        {
         $lastID = wm3Directory::saveDirectory($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Directory::getDirectoryList($w3,$lastID,true,false);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function editDirectory($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_DIRECTORY;
	 require(WM3_cPATH_INCLUDE.'admin_directory_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit directory");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_directories
                               WHERE directoryID = '".$w3->getVariable('directoryID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Directory::getDirectoryFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryFieldsArray());
       $form->setFieldsValues($_FIELD);
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories WRITE");
       if($form->validate())
        {
         $lastID = wm3Directory::updateDirectory($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Directory::getDirectoryList($w3,$lastID,true,false);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function saveDirectory($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_directories',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();		
    }

   public static function updateDirectory($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories
                       SET   name           = '".$_FIELD['name']."',
					         description    = '".$_FIELD['description']."',
							 directory_type = '".$_FIELD['directory_type']."',
							 icon           = '".$_FIELD['icon']."',
                             enabled        = '".$_FIELD['enabled']."',
                             languageID     = '".$_FIELD['languageID']."'
                       WHERE directoryID    = '".$_FIELD['directoryID']."'");
     return $_FIELD['directoryID'];
    }

/*public static function duplicateDirectory($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages
                             WHERE directoryID = '".$w3->getVariable('directoryID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Directory::getDirectoryFieldsArray(),$row);
       $_FIELD['message'] = $w3->getWord(1417).$_FIELD['message'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['update_ts'] = $_FIELD['ts'] = time();
       $w3->getDBObj()->saveAllTableFields('_messages',$_FIELD,array('update_ts'));
       return $w3->getDBObj()->getLastInsertID();
      }
    }*/

   public static function disableDirectory($w3,$directoryID)
    {
	 // Disable recursively current directory and all the subdirectory in it
     $rs = $w3->getDBObj()->query("SELECT directoryID FROM ".WM3_cCONFIG_DB_PREFIX."_directories WHERE parentID = '$directoryID'");
	 while($row = $w3->getDBObj()->fetch($rs))
	  {
	   wm3Directory::disableDirectory($w3,$row->directoryID);
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories SET enabled = '".WM3_cDISABLED."' WHERE directoryID = '$row->directoryID'");
      }
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories SET enabled = '".WM3_cDISABLED."' WHERE directoryID = '$directoryID'");
	}


   public static function enableDirectory($w3,$directoryID)
    {
	 // Enable recursively current directory and all the subdirectory in it
     $rs = $w3->getDBObj()->query("SELECT directoryID FROM ".WM3_cCONFIG_DB_PREFIX."_directories WHERE parentID = '$directoryID'");
	 while($row = $w3->getDBObj()->fetch($rs))
	  {
	   wm3Directory::enableDirectory($w3,$row->directoryID);
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories SET enabled = '".WM3_cENABLED."' WHERE directoryID = '$row->directoryID'");
	   
      }
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories SET enabled = '".WM3_cENABLED."' WHERE directoryID = '$directoryID'");
	}

   public static function deleteDirectory($w3,$directoryID)
    {
	 // Delete recursively current directory, all the items in it, all the subdirecrory in it with all the items in the varius subdirecrories
     $rs = $w3->getDBObj()->query("SELECT directoryID FROM ".WM3_cCONFIG_DB_PREFIX."_directories WHERE parentID = '$directoryID'");
	 while($row = $w3->getDBObj()->fetch($rs))
	  {
	   wm3Directory::deleteDirectory($w3,$row->directoryID);
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_directories_items WHERE directoryID = '$row->directoryID'");
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_directories       WHERE directoryID = '$row->directoryID'");
      }
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_directories_items WHERE directoryID = '$directoryID'");
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_directories       WHERE directoryID = '$directoryID'");
	}

   public static function addDirectoryItem($w3,$user = false)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryItemFieldsArray());
	 $action = WM3_cACTION_ADD_DIRECTORY_ITEM;
     if($user) {
		        $pageID = $w3->getVariable('pageID');
				require(WM3_cPATH_INCLUDE.'home_directory_item_form.inc');
			   }
	 else      require(WM3_cPATH_INCLUDE.'admin_directory_item_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1175));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
       $_F['directoryID']->setValue($w3->getVariable('directoryID','get')); // Take directoryID from get
      }
     else
      {
       if($user) {
                  if(!(wm3Directory::isDirectoryCanHaveFile($w3,$w3->getVariable('directoryID'),false) &&
                       wm3Directory::canAddDirectoryItem($w3)))
                   return wm3Directory::getDirectoryList($w3,0,false,false);
	              else
		           {
                    $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories       WRITE,
                                                  ".WM3_cCONFIG_DB_PREFIX."_directories_items WRITE,
                                                  ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
                                                  ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
                    if($form->validate())
                     {
                      $lastID = wm3Directory::saveDirectoryItem($w3,true);
                      $w3->getDBObj()->query("UNLOCK TABLES");
                      return wm3Directory::getDirectoryItemList($w3,$lastID,false);
                     }
                    $w3->getDBObj()->query("UNLOCK TABLES");
	               }
                 }
       else      {
                  if(!wm3Directory::isDirectoryCanHaveFile($w3,$w3->getVariable('directoryID')))
                   return wm3Directory::getDirectoryList($w3,0,true,false);
	              else
		           {
                    $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories       WRITE,
                                                  ".WM3_cCONFIG_DB_PREFIX."_directories_items WRITE");
                    if($form->validate())
                     {
                      $lastID = wm3Directory::saveDirectoryItem($w3);
                      $w3->getDBObj()->query("UNLOCK TABLES");
                      return wm3Directory::getDirectoryItemList($w3,$lastID);
                     }
                    $w3->getDBObj()->query("UNLOCK TABLES");
	               }
                 }
      }

     // Operation to do before render the form
	 if(!$user)
	  {
       if($_FIELD['source'] == WM3_cFILE_INTERNAL) $_F['pageID']->setVisible(true);
	   else                                        { $_F['home_url']->setVisible(true); $_F['download_url']->setVisible(true); }
	  }

     return $form->render();
    }

   public static function editDirectoryItem($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_DIRECTORY_ITEM;
	 require(WM3_cPATH_INCLUDE.'admin_directory_item_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit file");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_directories_items
                               WHERE directory_itemID = '".$w3->getVariable('directory_itemID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Directory::getDirectoryItemFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryItemFieldsArray());
       $form->setFieldsValues($_FIELD);
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories       WRITE,
                                     ".WM3_cCONFIG_DB_PREFIX."_directories_items WRITE");
       if($form->validate())
        {
         $lastID = wm3Directory::updateDirectoryItem($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Directory::getDirectoryItemList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }

     // Operation to do before render the form
     if($_FIELD['source'] == WM3_cFILE_INTERNAL) $_F['pageID']->setVisible(true);
     else                                        { $_F['home_url']->setVisible(true); $_F['download_url']->setVisible(true); }

     return $form->render();
    }

   public static function saveDirectoryItem($w3,$user=false)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryItemFieldsArray(),WM3_cQUOTE_DB);
	 $_FIELD['ts'] = time();
	 if($user)
	  {
       if(wm3Session::actionAllowed($w3,$w3->getVariable('_ID','post')))
        {
         wm3Session::protectAction($w3,$w3->getVariable('_ID','post'));
	     $userID = $w3->getAuthenticateAdminUserID();
         $_FIELD['userID']  = $userID;
		 $_FIELD['source']  = WM3_cFILE_EXTERNAL;
		 if($userID == WM3_cUSER_ANONYMOUS && !$w3->getPreferences('anonymous_enabled_directories')) $_FIELD['enabled'] = WM3_cDISABLED;
         else $_FIELD['enabled'] = WM3_cENABLED;
         if($_FIELD['render_mode'] != WM3_cRENDER_MODE_PLAIN_TEXT &&
	        $_FIELD['render_mode'] != WM3_cRENDER_MODE_BB_CODE)
	      $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
	     $_FIELD['languageID'] = WM3_cLANGUAGE_ALL;
         $w3->getDBObj()->saveAllTableFields('_directories_items',$_FIELD);
	     return $w3->getDBObj()->getLastInsertID();
        } 
       return 0;
	  }
     $w3->getDBObj()->saveAllTableFields('_directories_items',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateDirectoryItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Directory::getDirectoryItemFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items
                       SET   userID           = '".$_FIELD['userID']."',
					         pageID           = '".$_FIELD['pageID']."',
					         title            = '".$_FIELD['title']."',
					         description      = '".$_FIELD['description']."',
							 render_mode      = '".$_FIELD['render_mode']."',
							 icon             = '".$_FIELD['icon']."',
							 home_url         = '".$_FIELD['home_url']."',
							 download_url     = '".$_FIELD['download_url']."',
							 source           = '".$_FIELD['source']."',
                             enabled          = '".$_FIELD['enabled']."',
                             languageID       = '".$_FIELD['languageID']."'
                       WHERE directory_itemID = '".$_FIELD['directory_itemID']."'");
     return $_FIELD['directory_itemID'];
    }

   public static function duplicateDirectoryItem($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_directories_items WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_directories       WRITE");
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_directories_items
                             WHERE directory_itemID = '".$w3->getVariable('directory_itemID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Directory::getDirectoryItemFieldsArray(),$row,WM3_cQUOTE_DB);
       $_FIELD['title']   = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['hits']    = $_FIELD['votes_counts'] = $_FIELD['votes_sum'] = $_FIELD['votes_average'] = 0;
       $_FIELD['ts']      = time();
       $w3->getDBObj()->saveAllTableFields('_directories_items',$_FIELD);
	   $w3->getDBObj()->query("UNLOCK TABLES");
       return $w3->getDBObj()->getLastInsertID();
      }
	 $w3->getDBObj()->query("UNLOCK TABLES");
    }

   public static function disableDirectoryItem($w3,$directory_itemID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items SET enabled = '".WM3_cDISABLED."' WHERE directory_itemID = '$directory_itemID'");
	}

   public static function enableDirectoryItem($w3,$directory_itemID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items SET enabled = '".WM3_cENABLED."' WHERE directory_itemID = '$directory_itemID'");
	}
   
   public static function deleteDirectoryItem($w3,$directory_itemID)
    {
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_directories_items WHERE directory_itemID = '$directory_itemID'");
	}

   public static function selectDirectoryType($w3)
    {
     // Return an array of wm3GUIOption objects for directory type select
	 $_LABELS = array($w3->getWord(1165),$w3->getWord(1166));
	 $_VALUES = array(WM3_cDIRECTORY_FILE,WM3_cDIRECTORY_NO_FILE);
     return wm3Util::selectArray($_LABELS,$_VALUES);
    }

   public static function selectDirectoryItemSource($w3)
    {
     // Return an array of wm3GUIOption objects for directory item source select
     return wm3Util::selectArray(array($w3->getWord(1181),$w3->getWord(1182)),
                                 array(WM3_cFILE_INTERNAL,WM3_cFILE_EXTERNAL));
    }

   public static function makeDirectoryPath($w3,$directoryID,$link,$admin)
    {
	 // Create path from current directory to root
	 $_PSEP = $w3->getSkinObj()->getPathSeparator();
	 $path = " ".wm3Util::actionButton($link."&directoryID=$directoryID&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM,"action_show.png",$w3->getWord(648),'','',0,16,16);
	 if(wm3Directory::isDirectoryCanHaveFile($w3,$directoryID,$admin) &&
	    wm3Directory::canAddDirectoryItem($w3))
	  $path .= " ".wm3Util::actionButton($link."&directoryID=$directoryID&action=".WM3_cACTION_ADD_DIRECTORY_ITEM,"action_add.png",$w3->getWord(836),'','',0,16,16);
	 while($directoryID)
	  {
	   $rs = $w3->getDBObj()->query("SELECT directoryID,parentID,name FROM ".WM3_cCONFIG_DB_PREFIX."_directories WHERE directoryID = '$directoryID'");
	   if($w3->getDBObj()->totalRows($rs) == 1)
	    {
	     $row = $w3->getDBObj()->fetch($rs);
	     $path = " ".$_PSEP." <a href=\"$link&directoryID=$directoryID\">".$row->name."</a>".$path;
	     $directoryID = $row->parentID;
	    }
	   else $directoryID = 0;
	  }
	 $path = " <a href=\"$link\">Root</a>".$path;
	 return $path;
	}

   public static function renderDirectoryItem($w3,$admin = false)
    {
     // Get single directory item (home side)

     // Prepare variables
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DIRECTORIES); // Used to enable admin buttons in home stage
     $directoryID      = $w3->getVariable('directoryID');
     $directory_itemID = $w3->getVariable('directory_itemID');
     //if($media_albumID && !$categoryID) // When make a search take only media_albumID (but need also categoryID)
     //$categoryID = wm3MediaAlbum::getMediaAlbumCategoryID($w3,$media_albumID);
     //if($directoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.media_albumID = '$media_albumID'"; else $query_filter = "";
	 $query_filter = '';
     $pg     = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
	 $filter_check = $w3->getVariable('filter_check');
     if($filter) $search_link = "&filter=$filter"; else $search_link = '';
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     $pageID = $w3->getVariable('pageID');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DIRECTORY_ITEM."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
	 $query_filter .= " WHERE ".WM3_cCONFIG_DB_PREFIX."_directories_items.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_directories_items.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_directories_items.languageID='".WM3_cLANGUAGE_ALL."') AND directoryID='$directoryID'";
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DIRECTORIES;
     $id_link = "&directoryID=$directoryID";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_directories_items.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_directories_items
               $query_filter";
     $rs = $rs_aux = $w3->getDBObj()->query($query." ORDER BY ".WM3_cCONFIG_DB_PREFIX."_directories_items.title"); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     if($total_items != 0) $rs = $w3->getDBObj()->query($query." AND ".WM3_cCONFIG_DB_PREFIX."_directories_items.directory_itemID = '$directory_itemID'");

     // Create item
     $_DATA = $_COLSPAN = array();
     $row = $w3->getDBObj()->fetch($rs);
     $_SEP = $w3->getSkinObj()->getSeparator();
     if($row)
      {
       $link = $base_link.$id_link.$search_link.$extra_link;
       if($allowed) $allowed_link = $base_allowed_link."&directory_itemID=$row->directory_itemID";
       require(WM3_cPATH_INCLUDE.'home_directory_item_rate_form.inc');
       $rating = $row->votes_average;
	   if($allowed) $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DIRECTORY_ITEM,"action_edit.png",$w3->getWord(178)); else $button = '';
	   $published = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
       $updated   = wm3Util::renderDate($w3,$row->directory_item_ts,$w3->getHomeLanguage());
       if($row->source == WM3_cFILE_INTERNAL) { $link_home = wm3Page::makePageLink($row->pageID,'',true); $link_download = ''; }
	   else                                   { $link_home = $row->home_url; $link_download = $row->download_url; }
	   $button_home = wm3Util::actionButton($link_home,"misc_home.png","","",$w3->getWord(1688),0,16,16);
	   if($link_download) $button_download = " $_SEP ".wm3Util::actionButton($link_download,"misc_download.png","","",$w3->getWord(1689),0,16,16); else $button_download = '';
       $title = "<b>".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</b> $button<br><br>$button_home$button_download";
	   $login = wm3User::getUserLogin($w3,$row->userID); if(!$login) $login = $w3->getWord(988);
       $info  = "<nobr>(Rating $rating ".wm3Util::makeStars($w3,$rating).") $row->votes_counts votes ($row->hits hits)</nobr><br><br>Published: $published<br>Last update: $updated<br>".$w3->getWord(232)." $login";
	   $description = "<br><i>".wm3Util::renderContent($w3,$row->description,$row->render_mode)."</i><br><br>$home_content";
	   $_DATA[0]->title = $title;
	   $_DATA[0]->info  = $info;
	   $_DATA[1]->description = $description;
	   $_COLSPAN[1] = array(2);
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1160),$_COLSPAN);
     $list->setTotalItems($total_items);
     $list->setMaxPageItems(1);
     require(WM3_cPATH_INCLUDE.'admin_directory_search_form.inc');
     $list->setSearchForm($search_form);
     $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
     $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_LAST_INSERTED,"action_up.png","","",$w3->getWord(1218),0,16,16));
     // if($media_albumID) $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
	 $list->setTitle($list->getTitle()."<br>".wm3Directory::makeDirectoryPath($w3,$directoryID,$base_link.$page_link,$admin));
	 $list->setTitle($list->getTitle()."<br><i>".wm3Directory::getDirectoryDescription($w3,$directoryID)."</i>");
     $list->setRenderCaption(false);
     $list->setUseColors(false);
     $list->setWidths(array(60,40));
     if($row) {
               $list->setPageNavigatorRS($rs_aux);
               $list->setPageNavigatorField('directory_itemID');
               $list->setPageNavigatorID($row->directory_itemID);
               $list->setPagesNavigatorLink($base_link.$id_link.$search_link.$extra_link.$page_link."&action=".WM3_cACTION_SHOW_SINGLE_DIRECTORY_ITEM);
		      }
     return $list->render();
    }

   public static function rateDirectoryItem($w3)
    {
	 if(!$w3->getPreferences('anonymous_vote_directories') &&
	    !$w3->getAuthenticateAdminUserID()) return;
     $directory_itemID = $w3->getVariable('directory_itemID','post');
	 if(!wm3Session::directoryItemAllowed($w3,$directory_itemID,WM3_cSESSION_RATE)) return;
	 else wm3Session::directoryItemProtect($w3,$directory_itemID,WM3_cSESSION_RATE);
     $vote = $w3->getVariable('vote','post');
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items
                       SET    votes_counts = votes_counts + 1,
                              votes_sum = votes_sum + $vote,
							  votes_average = votes_sum/votes_counts
                       WHERE  directory_itemID = '$directory_itemID'");
    }

   public static function hitDirectoryItem($w3)
    {
     $directory_itemID = $w3->getVariable('directory_itemID','get');
	 if(!wm3Session::directoryItemAllowed($w3,$directory_itemID,WM3_cSESSION_HIT)) return;
	 else wm3Session::directoryItemProtect($w3,$directory_itemID,WM3_cSESSION_HIT);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items
                       SET    hits = hits + 1
                       WHERE  directory_itemID = '$directory_itemID'");
    }

   public static function renderDirectoryItemTopRating($w3,$order_by,$label,$by_rate,$by_hits,$by_votes,$max_items=15,$admin=false)
    {
     // Get media album top rating items list (for home side)

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DIRECTORIES); // Used to enable admin buttons in home stage
     $filter = ''; $filter_check = 0; $directoryID = 0;
     $pageID = $w3->getVariable('pageID','get');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DIRECTORY_ITEM."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DIRECTORIES;
     $query_filter = " WHERE ".WM3_cCONFIG_DB_PREFIX."_directories_items.enabled = '".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_directories_items.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_directories_items.languageID='".WM3_cLANGUAGE_ALL."')";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_directories_items.*
	           FROM   ".WM3_cCONFIG_DB_PREFIX."_directories_items
               $query_filter
			   $order_by
			   LIMIT 0,$max_items";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $id_link = '';
       $link  = $base_link.$page_link.$id_link."&directoryID=$row->directoryID&directory_itemID=$row->directory_itemID&action=".WM3_cACTION_SHOW_SINGLE_DIRECTORY_ITEM;
       $n     = ($p+1).".";
       $title = "<a href=\"$link\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a><br>(".wm3Directory::makeDirectoryPath($w3,$row->directoryID,$base_link.$page_link,$admin)." )";
       if($by_rate)
	    {
	     $rating = "<nobr>".wm3Util::makeStars($w3,$row->votes_average)."</nobr>";
         $value  = "<nobr>($row->votes_average)</nobr>";
	    }
	   else
	    {
         if($by_hits)  $value = "<nobr>$row->hits hits</nobr>";
		 if($by_votes) $value = "<nobr>$row->votes_counts votes</nobr>";
		}
       if($by_rate) {
		             $_DATA[$p]->n      = $n;
		             $_DATA[$p]->title  = $title;
		             $_DATA[$p]->rating = $rating;
		             $_DATA[$p]->value  = $value;
                    }
	   else         {
		             $_DATA[$p]->n      = $n;
		             $_DATA[$p]->title  = $title;
		             $_DATA[$p]->value  = $value;
                    }
       if($allowed)
        {
         $allowed_link = $base_allowed_link."&directoryID=$row->directoryID&directory_itemID=$row->directory_itemID&action=".WM3_cACTION_EDIT_DIRECTORY_ITEM;
         $_DATA[$p]->b1 = wm3Util::actionButton($allowed_link,"action_edit.png",$w3->getWord(178));
        }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1142));
     $list->setTotalItems($total_items);
	 $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     if($by_rate)
	  {
	   require(WM3_cPATH_INCLUDE.'admin_directory_search_form.inc');
       $list->setSearchForm($search_form);
	   $_SEP = $w3->getSkinObj()->getSeparator();
       $list->setTitle($w3->getWord($label)." $_SEP <a href=\"$base_link$page_link\">".$w3->getWord(-1)."Root</a> $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_LAST_INSERTED,"action_up.png","","",$w3->getWord(1218),0,16,16));
       $list->setWidths(array(0,85,10,5));
      }
	 else
	  {
	   $list->setTitle($w3->getWord($label));
	   $list->setWidths(array(0,90,10));
	  }
     return $list->render();
    }

   public static function renderDirectoryItemLastInserted($w3,$order_by,$label,$max_items=15,$admin=false)
    {
     // Get media album top rating items list (for home side)

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DIRECTORIES); // Used to enable admin buttons in home stage
     $filter = ''; $filter_check = 0; $directoryID = 0;
     $pageID = $w3->getVariable('pageID','get');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DIRECTORY_ITEM."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DIRECTORIES;
     $query_filter = " WHERE ".WM3_cCONFIG_DB_PREFIX."_directories_items.enabled = '".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_directories_items.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_directories_items.languageID='".WM3_cLANGUAGE_ALL."')";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_directories_items.*
	           FROM   ".WM3_cCONFIG_DB_PREFIX."_directories_items
               $query_filter
			   $order_by
			   LIMIT 0,$max_items";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0;
     $_SEP = $w3->getSkinObj()->getSeparator();
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $id_link = '';
       $link  = $base_link.$page_link.$id_link."&directoryID=$row->directoryID&directory_itemID=$row->directory_itemID&action=".WM3_cACTION_SHOW_SINGLE_DIRECTORY_ITEM;
       $n     = ($p+1).".";
	   $login = wm3User::getUserLogin($w3,$row->userID); if(!$login) $login = $w3->getWord(988);
       $title  = "<a href=\"$link\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a><br>Published: $login<br>(".wm3Directory::makeDirectoryPath($w3,$row->directoryID,$base_link.$page_link,$admin)." )";
       $rating = "<nobr>".wm3Util::makeStars($w3,$row->votes_average)." ($row->votes_average $_SEP $row->votes_counts votes)</nobr>";
	   $value  = "<nobr>$row->hits hits</nobr>";
       $_DATA[$p]->n      = $n;
       $_DATA[$p]->title  = $title;
       $_DATA[$p]->rating = $rating;
       $_DATA[$p]->value  = $value;
       if($allowed)
        {
         $allowed_link = $base_allowed_link."&directoryID=$row->directoryID&directory_itemID=$row->directory_itemID&action=".WM3_cACTION_EDIT_DIRECTORY_ITEM;
         $_DATA[$p]->b1 = wm3Util::actionButton($allowed_link,"action_edit.png",$w3->getWord(178));
        }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
	 $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     require(WM3_cPATH_INCLUDE.'admin_directory_search_form.inc');
     $list->setSearchForm($search_form);
     $list->setTitle($w3->getWord($label)." $_SEP <a href=\"$base_link$page_link\">".$w3->getWord(-1)."Root</a> $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DIRECTORY_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
     $list->setWidths(array(0,85,10,5));
     return $list->render();
    }

   public static function renderDirectorySubfoldersPreview($w3,$directoryID,$link,$n = 3)
    {
     // Render $n subfolders under $directoryID
	 $str = ""; $i = 0;
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_directories
                             WHERE parentID='$directoryID'
			                 ORDER BY name");
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   $name = "<a href=\"$link&directoryID=$row->directoryID</a>\">$row->name</a>";
	   if($i == 0) { $str .= $name; }
	   else        { if($i == $n) { $str .= ", ..."; break; } else { $str .= ", $name"; } }
	   $i++;
	  }
	 return $str;
	}

   private function getDirectoryDescription($w3,$directoryID)
    {
     // Get description from a categoryID
     $rs = $w3->getDBObj()->query("SELECT description FROM ".WM3_cCONFIG_DB_PREFIX."_directories
                             WHERE directoryID = '$directoryID'");
     if($w3->getDBObj()->totalRows($rs) == 0) return "";
     $row = $w3->getDBObj()->fetch($rs);
     return $row->description;
    }

   private static function countDirectoryFolders($w3,$directoryID,$filter = "")
    {
     // Get the number of folders in a directory
     $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX."_directories","WHERE parentID = '$directoryID'$filter");
     return $total;
    }

   private static function countDirectoryFiles($w3,$directoryID,$filter = '')
    {
     // Get the number of files in a directory
     $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX."_directories_items","WHERE directoryID = '$directoryID'$filter");
     return $total;
    }

   private static function isDirectoryCanHaveFile($w3,$directoryID,$admin = true)
    {
     // Return true if the directory with directoryID can have files else return false
	 if($directoryID == 0) // 0 its root directory (only administrator can put file in the root)
	  {
	   if($admin) return true; else return false;
	  }
     $rs = $w3->getDBObj()->query("SELECT directory_type FROM ".WM3_cCONFIG_DB_PREFIX."_directories
                             WHERE  directoryID = '$directoryID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return false;
     $row = $w3->getDBObj()->fetch($rs);
     if($row->directory_type == WM3_cDIRECTORY_FILE) return true;
	 else                                            return false;
	}

   private static function canAddDirectoryItem($w3)
    {
	 // Return true if user/anonymous can add an item into the directory
     if($w3->getAuthenticateAdminUserID() ||
		$w3->getAuthenticateAdminUserID() == WM3_cUSER_ANONYMOUS && $w3->getPreferences('anonymous_add_directories'))
	  return true;
	 else
	  return false;
	}

   public static function existsDirectory($w3,$directoryID)
    {
     // Return true if the directory with directoryID exists else return false
	 if($directoryID == 0) return true; // 0 its root directory and exists
     $rs = $w3->getDBObj()->query("SELECT directoryID FROM ".WM3_cCONFIG_DB_PREFIX."_directories
                             WHERE  directoryID = '$directoryID'");
     if($w3->getDBObj()->totalRows($rs) == 1) return true;
	 else                                     return false;
	}

  }

?>
