<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Ecommerce extends wm3Section
  {

   function __construct() { }

   public static function getSectionParameters()
    {
     // Set the right parameters for ecommerce section
     return array(
                  'section'                       => WM3_cSECTION_ECOMMERCE,
                  'allowed_section'               => WM3_cSECTION_ECOMMERCE,
                  'allow_category_description'    => false,
                  'allow_subcategory_description' => false,
                  'category_form'                 => 'admin_ecommerce_category_form.inc',
                  'search_form'                   => 'admin_ecommerce_search_form.inc',
                  'subcategory_form'              => 'admin_ecommerce_subcategory_form.inc',
                  'table_categories'              => '_ecommerce_categories',
                  'table_subcategories'           => '_ecommerce_subcategories',
                  'table_subcategories_count'     => '_ecommerce_subcategories',
                  'table_items_count'             => '_ecommerce_products',
                  'action_add_category'           => WM3_cACTION_ADD_ECOMMERCE_CATEGORY,
                  'action_show_subcategory'       => WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY,
                  'action_add_subcategory'        => WM3_cACTION_ADD_ECOMMERCE_SUBCATEGORY,
                  'action_disable_category'       => WM3_cACTION_DISABLE_ECOMMERCE_CATEGORY,
                  'action_enable_category'        => WM3_cACTION_ENABLE_ECOMMERCE_CATEGORY,
                  'action_edit_category'          => WM3_cACTION_EDIT_ECOMMERCE_CATEGORY,
                  'action_delete_category'        => WM3_cACTION_DELETE_ECOMMERCE_CATEGORY,
                  'action_show_items'             => WM3_cACTION_SHOW_ECOMMERCE_PRODUCT,
                  'action_add_item'               => WM3_cACTION_ADD_ECOMMERCE_PRODUCT,
                  'action_disable_subcategory'    => WM3_cACTION_DISABLE_ECOMMERCE_SUBCATEGORY,
                  'action_enable_subcategory'     => WM3_cACTION_ENABLE_ECOMMERCE_SUBCATEGORY,
                  'action_edit_subcategory'       => WM3_cACTION_EDIT_ECOMMERCE_SUBCATEGORY,
                  'action_delete_subcategory'     => WM3_cACTION_DELETE_ECOMMERCE_SUBCATEGORY,
                  'action_search'                 => WM3_cACTION_SHOW_ECOMMERCE_PRODUCT,
                  'label_category_list_title'     => 1664,
                  'label_subcategory_add'         => 1663,
                  'label_subcategories_count'     => 1051,
                  'label_items_count'             => 1681,
                  'label_item_add'                => 1665);
    }

   public static function getEcommerceProductFieldsArray()
    {
     return array('productID','subcategoryID','userID','code','name','render_mode','description','full_description','align',
                  'price','price_description','discount','special',
                  'availability','stock','options','enabled','languageID','ts','categoryID');
    }

   public static function getEcommercePictureFieldsArray()
    {
     return array('pictureID','productID','picture_from','picture_from_local','picture','picture_from_remote','thumbnail_from','thumbnail_from_local','thumbnail','thumbnail_from_remote','description','enabled','languageID','ts','categoryID','subcategoryID');
    }

   public static function getEcommerceCartItemFieldsArray()
    {
     return array('cart_itemID','productID','userID','orderID','product_code','product_name','product_description','options','quantity','price','discount',
				  'enabled','languageID','ts');
    }

   public static function getEcommerceProductInformationFieldsArray()
    {
     return array('name','email','message','newsletter','subject','message_head');
    }

   public static function getEcommerceProductSendToFriendFieldsArray()
    {
     return array('name','your_email','friend_email','message','newsletter','subject','message_head');
    }

   public static function getEcommerceOrderItemFieldsArray()
    {
     return array('orderID','userID','order_ts','status','shipping_cost','enabled','languageID','ts');
    }

   public static function getEcommerceProductCustomDataFieldsArray()
    {
     return array('dataID','productID','fieldID','value','enabled','languageID','ts');
    }

   public static function getEcommerceProductCustomFieldValueArray($w3)
    {
     $query = "SELECT *
	           FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
               WHERE  enabled='".WM3_cENABLED."'
			   ORDER BY ts DESC";
     $rs = $w3->getDBObj()->query($query);
	 $_ARRAY = array();
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $field = wm3Ecommerce::getCustomFieldStringName().$row->fieldID;
       array_push($_ARRAY,$field);
      }
	 return $_ARRAY;
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_ECOMMERCE_CATEGORY:
        {
         return wm3Ecommerce::addEcommerceCategory($w3);
         break;
        }
       case WM3_cACTION_EDIT_ECOMMERCE_CATEGORY:
        {
         return wm3Ecommerce::editEcommerceCategory($w3);
         break;
        }
       case WM3_cACTION_DISABLE_ECOMMERCE_CATEGORY:
        {
         wm3Ecommerce::disableEcommerceCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Ecommerce::getEcommerceCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_ECOMMERCE_CATEGORY:
        {
         wm3Ecommerce::enableEcommerceCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Ecommerce::getEcommerceCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_ECOMMERCE_CATEGORY:
        {
         wm3Ecommerce::deleteEcommerceCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Ecommerce::getEcommerceCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_ECOMMERCE_SUBCATEGORY:
        {
         return wm3Ecommerce::addEcommerceSubcategory($w3);
         break;
        }
       case WM3_cACTION_DISABLE_ECOMMERCE_SUBCATEGORY:
        {
         wm3Ecommerce::disableEcommerceSubcategory($w3,$w3->getVariable('subcategoryID','get'));
         return wm3Ecommerce::getEcommerceSubcategoryList($w3,$w3->getVariable('subcategoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_ECOMMERCE_SUBCATEGORY:
        {
         wm3Ecommerce::enableEcommerceSubcategory($w3,$w3->getVariable('subcategoryID','get'));
         return wm3Ecommerce::getEcommerceSubcategoryList($w3,$w3->getVariable('subcategoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_ECOMMERCE_SUBCATEGORY:
        {
         wm3Ecommerce::deleteEcommerceSubcategory($w3,$w3->getVariable('subcategoryID','get'));
         return wm3Ecommerce::getEcommerceSubcategoryList($w3);
         break;
        }
       case WM3_cACTION_EDIT_ECOMMERCE_SUBCATEGORY:
        {
         return wm3Ecommerce::editEcommerceSubcategory($w3);
         break;
        }
       case WM3_cACTION_ADD_ECOMMERCE_PRODUCT:
        {
         return wm3Ecommerce::addEcommerceProduct($w3);
         break;
        }
       case WM3_cACTION_EDIT_ECOMMERCE_PRODUCT:
        {
		 wm3Ecommerce::synchronizeEcommerceProductCustomData($w3);
         return wm3Ecommerce::editEcommerceProduct($w3);
         break;
        }
       case WM3_cACTION_DISABLE_ECOMMERCE_PRODUCT:
        {
         wm3Ecommerce::disableEcommerceProduct($w3,$w3->getVariable('productID','get'));
         return wm3Ecommerce::getEcommerceProductList($w3,$w3->getVariable('productID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_ECOMMERCE_PRODUCT:
        {
         wm3Ecommerce::enableEcommerceProduct($w3,$w3->getVariable('productID','get'));
         return wm3Ecommerce::getEcommerceProductList($w3,$w3->getVariable('productID','get'));
         break;
        }
       case WM3_cACTION_DELETE_ECOMMERCE_PRODUCT:
        {
         wm3Ecommerce::deleteEcommerceProduct($w3,$w3->getVariable('productID','get'));
         return wm3Ecommerce::getEcommerceProductList($w3);
         break;
        }
       /*case WM3_cACTION_DUPLICATE_ECOMMERCE_PRODUCT:
        {
         $lastID = wm3Ecommerce::duplicateEcommerceProduct($w3);
         // $msg= message duplicated...//TODO
         return wm3Ecommerce::getEcommerceProductList($w3,$lastID);
         break;
        }*/
       case WM3_cACTION_ADD_ECOMMERCE_PICTURE:
        {
         return wm3Ecommerce::addEcommercePicture($w3);
         break;
        }
       case WM3_cACTION_SAVE_ECOMMERCE_PICTURE:
        {
		 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products          WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories     WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories        WRITE");
         $error = wm3Ecommerce::checkEcommercePictureError($w3);
         if(!$error) {        	
                      $lastID = wm3Ecommerce::saveEcommercePicture($w3);
                      $w3->getDBObj()->query("UNLOCK TABLES");
                      return wm3Ecommerce::getEcommercePictureList($w3,$lastID);
                     }
         else        {
			          $w3->getDBObj()->query("UNLOCK TABLES");
			          return wm3Ecommerce::addEcommercePicture($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_DISABLE_ECOMMERCE_PICTURE:
        {
         wm3Ecommerce::disableEcommercePicture($w3,$w3->getVariable('pictureID','get'));
         return wm3Ecommerce::getEcommercePictureList($w3,$w3->getVariable('pictureID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_ECOMMERCE_PICTURE:
        {
         wm3Ecommerce::enableEcommercePicture($w3,$w3->getVariable('pictureID','get'));
         return wm3Ecommerce::getEcommercePictureList($w3,$w3->getVariable('pictureID','get'));
         break;
        }
       case WM3_cACTION_DELETE_ECOMMERCE_PICTURE:
        {
         wm3Ecommerce::deleteEcommercePicture($w3,$w3->getVariable('pictureID','get'));
         return wm3Ecommerce::getEcommercePictureList($w3);
         break;
        }
       case WM3_cACTION_ACCEPT_ECOMMERCE_ORDER:
        {
         wm3Ecommerce::acceptEcommerceOrder($w3,$w3->getVariable('orderID','get'));
         return wm3Ecommerce::getEcommerceOrderList($w3,$w3->getVariable('orderID','get'));
         break;
        }
       case WM3_cACTION_REJECT_ECOMMERCE_ORDER:
        {
         wm3Ecommerce::rejectEcommerceOrder($w3,$w3->getVariable('orderID','get'));
         return wm3Ecommerce::getEcommerceOrderList($w3,$w3->getVariable('orderID','get'));
         break;
        }
       case WM3_cACTION_SEND_ECOMMERCE_ORDER:
        {
         wm3Ecommerce::sendEcommerceOrder($w3,$w3->getVariable('orderID','get'));
         return wm3Ecommerce::getEcommerceOrderList($w3,$w3->getVariable('orderID','get'));
         break;
        }
       case WM3_cACTION_WAIT_ECOMMERCE_ORDER:
        {
         wm3Ecommerce::waitEcommerceOrder($w3,$w3->getVariable('orderID','get'));
         return wm3Ecommerce::getEcommerceOrderList($w3,$w3->getVariable('orderID','get'));
         break;
        }
       case WM3_cACTION_DELETE_ECOMMERCE_ORDER:
        {
         wm3Ecommerce::deleteEcommerceOrder($w3,$w3->getVariable('orderID','get'));
         return wm3Ecommerce::getEcommerceOrderList($w3);
         break;
        }
       case WM3_cACTION_PRINTABLE_ECOMMERCE_ORDER:
        {
         return wm3Ecommerce::getEcommerceOrderItemList($w3,0,true,true);
         break;
        }
       case WM3_cACTION_SHOW_ECOMMERCE_ORDER_ITEM:
        {
         return wm3Ecommerce::getEcommerceOrderItemList($w3);
         break;
        }
       case WM3_cACTION_SHOW_ECOMMERCE_ORDER:
        {
         return wm3Ecommerce::getEcommerceOrderList($w3);
         break;
        }
       case WM3_cACTION_SHOW_ECOMMERCE_PICTURE:
        {
         return wm3Ecommerce::getEcommercePictureList($w3);
         break;
        }
       case WM3_cACTION_SHOW_ECOMMERCE_PRODUCT:
        {
         return wm3Ecommerce::getEcommerceProductList($w3);
         break;
        }
       case WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY:
        {
         return wm3Ecommerce::getEcommerceSubcategoryList($w3);
         break;
        }
       default:
        {
         return wm3Ecommerce::getEcommerceCategoryList($w3);
        }
      }
    }

   public static function renderEcommerceCategoryList($w3,$currentID = 0,$admin = false,$no_icon = true,$no_allowed = true,$no_page_link = true,$folder_style = false,$no_header = true,$simple_counter = true)
    {
     // Get ecommerce category list for panel (home side)

     // Prepare variables to create the list
     //$query_filter = "WHERE enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME;
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  =  "&filter=$filter";
       //$query_filter .= " AND message LIKE '%$filter%'"; // ???
      }
     else { $search_link = ""; }
     $search_form_link  = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT;
     $id_link = "";
     if($w3->getAction() == WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY ||
        $w3->getAction() == WM3_cACTION_SHOW_ECOMMERCE_PRODUCT     ||
        $w3->getAction() == WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT)
      $show_subcategories = true;
     else $show_subcategories = false;

     require(WM3_cPATH_INCLUDE."panel_ecommerce_search_form.inc");

     if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
	  $search_form = "<br>".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME."&action=".WM3_cACTION_SHOW_ECOMMERCE_CART,"misc_cart.png","","",$w3->getWord(692))."<br><br>".$search_form;

     return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin,$no_icon,$no_allowed,$base_link,$no_page_link,$show_subcategories,$folder_style,$no_header,$simple_counter,$search_form,true);
    }

   public static function renderEcommerceSubcategoryList($w3,$currentID = 0,$admin = false,$no_icon = true,$no_allowed = true,$no_page_link = true,$folder_style = false,$no_header = true,$simple_counter = true)
    {
     // Get ecommerce subcategory list for panel (home side)

     // Prepare variables to create the list
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME;

     return $w3->getSectionObj()->getSubcategoryList($w3,$currentID,$admin,$no_icon,$no_allowed,$base_link,$no_page_link,$folder_style,$no_header,$simple_counter,true);
    }

   public static function renderEcommerceProductList($w3,$currentID = 0,$admin = false,$no_form_search = true,$show_picture = true,$special_offer = false)
    {
     // Get ecommerce product list for a subcategory (home side)

     // Prepare variables to create the list
     return wm3Ecommerce::getEcommerceProductList($w3,$w3->getVariable('productID'),$admin,$no_form_search,$show_picture,$special_offer);
    }

   public static function renderEcommerceSingleProduct($w3,$currentID = 0,$admin = false,$no_form_search = true,$error = 0,$info = false,$friend = false,$msg = '')
    {
     // Get single ecommerce product (home side)

     // Prepare variables
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_ECOMMERCE); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID');
     $subcategoryID = $w3->getVariable('subcategoryID');
     $productID     = $w3->getVariable('productID');
	 $pictureID     = $w3->getVariable('pictureID');
     //if($subcategoryID && !$categoryID) // When make a search take only subcategoryID (but need also categoryID)
     // $categoryID = wm3Ecommerce::getCategoryID($w3,$subcategoryID);
     if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.productID = '$productID'"; else $query_filter = '';
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($filter) $search_link = "&filter=$filter"; else $search_link = '';
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     $pageID = $w3->getVariable('pageID');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".WM3_cLANGUAGE_ALL."')";
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_ECOMMERCE;
     $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID
               $query_filter";
     $rs = $rs_aux = $w3->getDBObj()->query($query." ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.name DESC"); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     if($total_items != 0) $rs = $w3->getDBObj()->query($query." AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.productID = '$productID'");

     // Create item
     $_DATA = array();
	 $currency = $w3->getPreferences('ecommerce_currency');
	 $_SEP = $w3->getSkinObj()->getSeparator();
     $row = $w3->getDBObj()->fetch($rs);
     if($row)
      {
       $link = $base_link.$id_link.$search_link.$extra_link;
       if($allowed) $allowed_link = $base_allowed_link."&productID=$row->productID";
       if($info) // More informations form
	    {
         // Initialize form
         $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductInformationFieldsArray());
         $_FIELD['categoryID']    = $categoryID;
         $_FIELD['subcategoryID'] = $subcategoryID;
         $_FIELD['productID']     = $productID;
         require(WM3_cPATH_INCLUDE.'home_ecommerce_information_form.inc');
         $form->setSubmitLabel($w3->getWord(294));
         $form->setTitle($w3->getWord(1616));
         $form->setFieldsValues($_FIELD);

         // Render form
         if(!$form->wasSubmit())
          {
           // Default values for the form
           $product_name = wm3Ecommerce::getEcommerceProductName($w3,$productID);
		   $_F['message_head']->setValue("Information request for product '$product_name' (ID #$productID)\nhttp://".$w3->getPreferences('site_address')."/$base_link$id_link$page_link&productID=$productID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\n\n");
           $_F['subject']->setValue($w3->getPreferences('site_address').": Information request for product '$product_name' (ID #$productID)");
           $_F['newsletter']->setValue(WM3_cENABLED);
          }
         else
          {
           // Send more informations email for an ecommerce product (for home page)
           $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
           if($form->validate())
            {
             $allowed = wm3Newsletter::addToNewsletterContact($w3);
		     $w3->getDBObj()->query("UNLOCK TABLES");
             $msg = wm3Newsletter::sendContact($w3,$allowed,false);
		    }
           $w3->getDBObj()->query("UNLOCK TABLES");
          }
         if(!$msg) $home_content = $form->render(); else $home_content = "<b>$msg</b>";
        }
       if($friend) // Send to friend form
	    {
         // Initialize form
         $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductSendToFriendFieldsArray());
         $_FIELD['categoryID']    = $categoryID;
         $_FIELD['subcategoryID'] = $subcategoryID;
         $_FIELD['productID']     = $productID;
         require(WM3_cPATH_INCLUDE.'home_ecommerce_send_to_friend_form.inc');
         $form->setSubmitLabel($w3->getWord(294));
         $form->setTitle($w3->getWord(1617));
         $form->setFieldsValues($_FIELD);

         // Render form
         if(!$form->wasSubmit())
          {
           // Default values for the form
           $product_name = wm3Ecommerce::getEcommerceProductName($w3,$productID);
		   $_F['message_head']->setValue("Your friend send to you information about this product: '$product_name'\nhttp://".$w3->getPreferences('site_address')."/$base_link$id_link$page_link&productID=$productID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\n\n");
           $_F['subject']->setValue($w3->getPreferences('site_address').": Your friend send to you informations for product '$product_name'");
           $_F['newsletter']->setValue(WM3_cENABLED);
          }
         else
          {
           // Send to friend for an ecommerce product (for home page)
           $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
           if($form->validate())
            {
             $allowed = wm3Newsletter::addToNewsletterSendToFriend($w3);
		     $w3->getDBObj()->query("UNLOCK TABLES");
             $msg = wm3Newsletter::sendSendToFriend($w3,$allowed,true,true);
		    }
           $w3->getDBObj()->query("UNLOCK TABLES");
          }
         if(!$msg) $home_content = $form->render(); else $home_content = "<b>$msg</b>";
        }
	   if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL) 
	    {
	     if(!$info && !$friend)
	      {
           // Initialize form
           $options = $row->options;
           $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceCartItemFieldsArray());
           $_FIELD['categoryID']    = $categoryID;
           $_FIELD['subcategoryID'] = $subcategoryID;
           $_FIELD['productID']     = $productID;
           require(WM3_cPATH_INCLUDE.'home_ecommerce_cart_add_form.inc');
           $form->setTitle($w3->getWord(693));
           $form->setSubmitLabel($w3->getWord(693));
           $form->setRenderResetButton(false);
           $form->setFieldsValues($_FIELD);
           switch($error)
            {
             case 1: // Bad quantity
              {
               $form->setError(true);
               $form->setTitle("Invalid quantity");
               $_F['quantity']->setError(true);
               break;
              }
             default:
              {
               // Default values for the form
               $_F['quantity']->setValue(1);
              }
            }
           $home_content = $form->render();
	  	  }
         $availability_content = '';
         if(!$info && !$friend)
	      {
	       $availability = $w3->getWord(676)." ".$w3->getWord(678+$row->availability)." ";
	       if($row->availability == WM3_cECOMMERCE_AVAILABILITY_HEIGHT)  $availability .= wm3Util::renderImg('misc_availability_height.png', '',24,24);
	       if($row->availability == WM3_cECOMMERCE_AVAILABILITY_EVERAGE) $availability .= wm3Util::renderImg('misc_availability_average.png','',24,24);
	       if($row->availability == WM3_cECOMMERCE_AVAILABILITY_LOW)     $availability .= wm3Util::renderImg('misc_availability_low.png',    '',24,24);
  	       if($row->availability == WM3_cECOMMERCE_AVAILABILITY_NONE)    $availability .= wm3Util::renderImg('misc_availability_none.png',   '',24,24);
           $availability_content = $availability;
	       $availability_content .= "<br><br>$home_content";
	      }
        }
	   else { $availability_content = ''; }

	   if($allowed) $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_ECOMMERCE_PRODUCT,"action_edit.png",$w3->getWord(178)); else $button = '';
	   if($row->discount > 0) $price = "<s>$row->price $currency $row->price_description</s><br>".($row->price-($row->price*$row->discount/100))." $currency $row->price_description <i>(".$w3->getWord(1500)." $row->discount %)</i>";
	   else                   $price = "$row->price $currency $row->price_description";

       $extra_fields = $extra_button = '';
	   if($w3->getPreferences('ecommerce_show_extra') == WM3_cENABLED)
	    {
	     // Printable, more informations and send to friend buttons
	     $extra_button  = wm3Util::actionButton($base_link.$id_link."&productID=$productID&pictureID=$pictureID&action=".WM3_cACTION_PRINTABLE_SINGLE_ECOMMERCE_PRODUCT,"action_print_mini.png","","",$w3->getWord(1400),0,16,16,'absmiddle','_blank');
	     $extra_button .= " $_SEP ".wm3Util::actionButton($base_link.$id_link."&productID=$productID&pictureID=$pictureID&action=".WM3_cACTION_INFORMATIONS_SINGLE_ECOMMERCE_PRODUCT,"action_add.png","","",$w3->getWord(1487),0,16,16);
         $extra_button .= " $_SEP ".wm3Util::actionButton($base_link.$id_link."&productID=$productID&pictureID=$pictureID&action=".WM3_cACTION_SEND_TO_FRIEND_SINGLE_ECOMMERCE_PRODUCT,"action_newsletter.png","","",$w3->getWord(1488),0,16,16);
	     if($info || $friend) $extra_button .= " $_SEP ".wm3Util::actionButton($base_link.$id_link."&productID=$productID&pictureID=$pictureID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT,"action_down.png","","",$w3->getWord(-1)."Return to product",0,16,16);
	     $extra_button .= "<br><br>";
        }
	   if(!$info && !$friend) $extra_fields = wm3Ecommerce::renderEcommerceProductCustomFieldData($w3,$productID,false);
	   $pictures_list = wm3Ecommerce::getEcommercePictureList($w3,0,false);

       $code = $picture_content = $price_content = '';
	   if(!$info && !$friend)
	    {
	     $picture_content = wm3Ecommerce::getEcommercePictureFirst($w3,$categoryID,$subcategoryID,$productID,$pictureID,false,-1);
         if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)   { $code = " ($row->code)"; $price_content = $price; }
	     else if($w3->getPreferences('ecommerce_show_catalogue_price') == WM3_cENABLED) { $code = " ($row->code)"; $price_content = $price; }
         $title_content       = "<b>$row->name</b>$code $button<br><br>$row->description";
	     $description_content = "<br>$extra_button$extra_fields<br><i>".wm3Util::renderContent($w3,$row->full_description,$row->render_mode)."</i><br><br>$pictures_list";
        }
	   else
	    {
	     $title_content       = "<br>$extra_button";
	     $description_content = $home_content;
	    }
       $social_facebook = wm3Social::renderFacebook($w3,$base_link.$id_link."&productID=$productID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT);
       $social_gplusone = wm3Social::renderGPlusone($w3,$base_link.$id_link."&productID=$productID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT);
       $social_twitter  = wm3Social::renderTwitter ($w3,$base_link.$id_link."&productID=$productID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT,$row->name);
       ob_start();
       require($w3->getSkinObj()->getFrameProduct($picture_content));
       $item_content = ob_get_contents();
       ob_end_clean();
       $_DATA[0]->content = $item_content;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
     $list->setMaxPageItems(1);
     if(!$no_form_search)
      {
       require(WM3_cPATH_INCLUDE.'admin_ecommerce_search_form.inc');
       $list->setSearchForm($search_form);
      }
     if($admin) $list->setTitle("<a href=\"$base_link\">".$w3->getWord(1664)."</a>");
     else       $list->setTitle("<a href=\"$base_link$page_link\">".$w3->getWord(501)."</a>");
     if($subcategoryID)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin)
        {
       	 $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY."\">".wm3Ecommerce::getEcommerceCategoryName($w3,$categoryID)."</a>"
          ." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceSubcategoryName($w3,$subcategoryID)." ($total_items)</a>"
          ." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_ECOMMERCE_PRODUCT,"action_add.png","","",$w3->getWord(1665),0,16,16));
        }
       else
        {
         $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY."\">".wm3Ecommerce::getEcommerceCategoryName($w3,$categoryID)."</a>"
          ." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceSubcategoryName($w3,$subcategoryID)."</a>"
          ." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&productID=$productID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceProductName($w3,$productID)."</a>");
        }
      }
     $list->setRenderCaption(false);
     $list->setUseColors(false);
     $list->setWidths(array(100));
     if($row)
      {
       $list->setPageNavigatorRS($rs_aux);
       $list->setPageNavigatorField('productID');
       $list->setPageNavigatorID($row->productID);
       $list->setPagesNavigatorLink($base_link.$id_link.$search_link.$extra_link.$page_link."&action=".WM3_cACTION_SHOW_SINGLE_MEDIA);//???
      }
     return $list->render();
    }

   public static function renderEcommerceSingleProductPrintable($w3)
    {
     // Get single printable ecommerce product (home side)

     // Prepare variables
     $categoryID    = $w3->getVariable('categoryID');
     $subcategoryID = $w3->getVariable('subcategoryID');
     $productID     = $w3->getVariable('productID');
	 $pictureID     = $w3->getVariable('pictureID');
     //if($subcategoryID && !$categoryID) // When make a search take only subcategoryID (but need also categoryID)
     // $categoryID = wm3Ecommerce::getCategoryID($w3,$subcategoryID);
     if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.productID = '$productID'"; else $query_filter = '';
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".WM3_cLANGUAGE_ALL."')";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID
               $query_filter";
     $rs = $rs_aux = $w3->getDBObj()->query($query." ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.name DESC"); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     if($total_items != 0) $rs = $w3->getDBObj()->query($query." AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.productID = '$productID'");
     if($subcategoryID)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       $title = wm3Ecommerce::getEcommerceCategoryName($w3,$categoryID);
       $title .= " $_PSEP ".wm3Ecommerce::getEcommerceSubcategoryName($w3,$subcategoryID);
       $title .= " $_PSEP ".wm3Ecommerce::getEcommerceProductName($w3,$productID);
      }

     // Create item
     $_DATA = $_COLSPAN = array();
	 $currency = $w3->getPreferences('ecommerce_currency');
	 $picture_content = '';
     $row = $w3->getDBObj()->fetch($rs);
     if($row)
      {
	   if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL) 
	    {
         $availability_content = '';
         $availability = $w3->getWord(676)." ".$w3->getWord(678+$row->availability)." ";
	     if($row->availability == WM3_cECOMMERCE_AVAILABILITY_HEIGHT)  $availability .= wm3Util::renderImg('misc_availability_height.png', '',24,24);
	     if($row->availability == WM3_cECOMMERCE_AVAILABILITY_EVERAGE) $availability .= wm3Util::renderImg('misc_availability_average.png','',24,24);
	     if($row->availability == WM3_cECOMMERCE_AVAILABILITY_LOW)     $availability .= wm3Util::renderImg('misc_availability_low.png',    '',24,24);
  	     if($row->availability == WM3_cECOMMERCE_AVAILABILITY_NONE)    $availability .= wm3Util::renderImg('misc_availability_none.png',   '',24,24);
         $availability_content = $availability;
        }
	   else $availability_content = '';

	   if($row->discount > 0) $price = "<s>$row->price $currency $row->price_description</s><br><b>".($row->price-($row->price*$row->discount/100))." $currency $row->price_description</b> <i>(".$w3->getWord(1500)." $row->discount %)</i>";
	   else                   $price = "<b>$row->price $currency $row->price_description</b>";

       $extra_fields = $extra_button = '';
       $extra_fields = wm3Ecommerce::renderEcommerceProductCustomFieldData($w3,$productID,false);

       $code = $price_content = '';
       $picture_content = wm3Ecommerce::getEcommercePictureFirst($w3,$categoryID,$subcategoryID,$productID,$pictureID,false,-1);
       if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)   { $code = " ($row->code)"; $price_content = $price; }
	   else if($w3->getPreferences('ecommerce_show_catalogue_price') == WM3_cENABLED) { $code = " ($row->code)"; $price_content = $price; }
       $title_content       = "<b>$row->name</b>$code<br><br>$row->description<br>$price_content<br><br>$availability_content";
	   $description_content = "<br>$extra_fields<br><i>".wm3Util::renderContent($w3,$row->full_description,$row->render_mode)."</i>";

       if($picture_content) $_DATA[0]->picture = $picture_content;
	   $_DATA[0]->content = $title_content;
	   $_DATA[1]->content = $description_content;
       if($picture_content) $_COLSPAN[1] = array(2);
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'',$_COLSPAN);
     $list->setTotalItems($total_items);
     $list->setMaxPageItems(1);
     $list->setRenderCaption(false);
     $list->setUseColors(false);
     if($picture_content) $list->setWidths(array(0,100));
     else                 $list->setWidths(array(100));
     $list->setRenderPagesNavigator(false);
	 $w3->getPageObj()->setTitle($title);
	 $w3->getPageObj()->setSubTitle('');
	 $w3->getPageObj()->setPageContent($list->render());
    }

   public static function renderEcommerceProductCustomFieldData($w3,$productID = 0,$admin = false)
    {
     // Get single ecommerce product custom fields data list (home side)

     // Prepare variables
     if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
      $query_filter = "AND (show_in = ".WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_TRANSACTIONS." OR show_in = ".WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_BOTH.")";
     else
	  $query_filter = "AND (show_in = ".WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_CATALOGUE." OR show_in = ".WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_BOTH.")";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data.fieldID DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data.*,
	                  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields.show_in
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data,
			          ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data.productID='$productID' AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data.enabled='".WM3_cENABLED."'
			     AND  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data.fieldID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields.fieldID
               $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by);
     $total_items = $w3->getDBObj()->totalRows($rs);
     if($total_items != 0) $rs = $w3->getDBObj()->query($query);

     // Create list content
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $label = wm3Ecommerce::getEcommerceProductCustomFieldLabel($w3,$row->fieldID);
       $_DATA[$p]->label = $label;
       $_DATA[$p]->value = $row->value;
	   $p++;
      }

     // Render List
     if($total_items == 0) return ''; // Return a totally empty list if there are 0 items
     $list = new wm3GUIList($w3,$_DATA);
     if($admin) $list->setTitle($w3->getWord(1664));
     $list->setTotalItems($total_items);
     $list->setRenderCaption(false);
     $list->setInvertColors(true);
     $list->setWidths(array(20,80));
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public static function getEcommerceCategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin);
    }

   public static function addEcommerceCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addCategory($w3,$error);
    }

   public static function editEcommerceCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editCategory($w3,$error);
    }

   public static function disableEcommerceCategory($w3,$categoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'");
    }

   public static function enableEcommerceCategory($w3,$categoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'");
    }
   
   public static function deleteEcommerceCategory($w3,$categoryID)
    {
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products          WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories        WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories     WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items       WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data       WRITE");

     // Delete also the images, cart items (no ordered) and custom data
     $rs = $w3->getDBObj()->query("SELECT productID
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
							        ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
	                                ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID = '$categoryID'
							   AND  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID = ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID
							   AND  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID = ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID");
     while($row = $w3->getDBObj()->fetch($rs))
	  {
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WHERE productID = '$row->productID'");
       $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items WHERE productID = '$row->productID' AND orderID = '0'");
       $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data WHERE productID = '$row->productID'");
      }

     $w3->getSectionObj()->deleteCategory($w3,$categoryID);
	 $w3->getDBObj()->query("UNLOCK TABLES");
    }

   public static function selectEcommerceCategory($w3,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectCategory($w3,$all,$admin);
    }

   public static function getEcommerceCategoryName($w3,$categoryID)
    {
     return $w3->getSectionObj()->getCategoryName($w3,$categoryID);
    }

   public static function getEcommerceSubcategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getSubcategoryList($w3,$currentID,$admin);
    }

   public static function addEcommerceSubcategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addSubcategory($w3,$error);
    }

   public static function editEcommerceSubcategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editSubcategory($w3,$error);
    }

   public static function disableEcommerceSubcategory($w3,$subcategoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories SET enabled = '".WM3_cDISABLED."' WHERE subcategoryID = '$subcategoryID'");
    }

   public static function enableEcommerceSubcategory($w3,$subcategoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories SET enabled = '".WM3_cENABLED."' WHERE subcategoryID = '$subcategoryID'");
    }
   
   public static function deleteEcommerceSubcategory($w3,$subcategoryID)
    {
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products          WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories        WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories     WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items       WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data       WRITE");

     // Delete also the images, cart items (no ordered) and custom data
     $rs = $w3->getDBObj()->query("SELECT productID FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE  subcategoryID = '$subcategoryID'");
     while($row = $w3->getDBObj()->fetch($rs))
	  {
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WHERE productID = '$row->productID'");
       $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items WHERE productID = '$row->productID' AND orderID = '0'");
       $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data WHERE productID = '$row->productID'");
      }

     $w3->getSectionObj()->deleteSubcategory($w3,$subcategoryID);
	 $w3->getDBObj()->query("UNLOCK TABLES");
    }

   public static function getEcommerceSubcategoryName($w3,$subcategoryID)
    {
     return $w3->getSectionObj()->getSubcategoryName($w3,$subcategoryID);
    }

   public static function selectEcommerceSubcategory($w3,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectSubcategory($w3,$all,$admin);
    }

   public static function getEcommerceCategoryID($w3,$subcategoryID)
    {
     return $w3->getSectionObj()->getCategoryID($w3,$subcategoryID);
    }

   public static function getEcommerceSubcategoryID($w3,$productID)
    {
     // Get subcategoryID from a productID
     $rs = $w3->getDBObj()->query("SELECT subcategoryID FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE  productID = '$productID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->subcategoryID;
    }

   public static function getEcommerceProductList($w3,$currentID = 0,$admin = true,$no_form_search = false,$show_picture = false,$special_offer = false)
    {
     // Get products list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_ECOMMERCE); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID');
     $subcategoryID = $w3->getVariable('subcategoryID');
	 $currency = $w3->getPreferences('ecommerce_currency');
     if($subcategoryID && !$categoryID) // When make a search take only subcategoryID (but need also categoryID)
      $categoryID = wm3Ecommerce::getEcommerceCategoryID($w3,$subcategoryID);	  
     if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID = '$subcategoryID'"; else $query_filter = "";
     if($special_offer) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.special = '".WM3_cENABLED."'"; // Show special offer only
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.description LIKE '%$filter%'";
     	         }
     else        { if(!$special_offer) { if(!$subcategoryID) $query_filter =" AND 1=0"; } $search_link = ""; }
     if($admin) {
                 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".WM3_cLANGUAGE_ALL."')";
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_ECOMMERCE;
	 $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.name";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID
               $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'productID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   if($row->discount > 0) $price = "<s>$row->price $currency $row->price_description</s><br>".($row->price-($row->price*$row->discount/100))." $currency $row->price_description <i>(".$w3->getWord(1500)." $row->discount %)</i>";
  	   else                   $price = "$row->price $currency";
       $link = $base_link.$id_link.$extra_link."&productID=$row->productID";
       if($allowed) $allowed_link = $base_allowed_link."&productID=$row->productID";
       if($subcategoryID || $special_offer)
	                      {
                           if($admin) {
							           $total_pictures = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures","WHERE productID='$row->productID'");
                           	           $_DATA[$p]->name  = "<a href=\"$link&action=".WM3_cACTION_SHOW_ECOMMERCE_PICTURE."\">$row->name</a><br>($total_pictures pictures)";
                        	           $_DATA[$p]->price = "$price<br>".$row->description;
                        	          }
                           else       {
							           $price_content = '';
							           if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL) $price_content = $price."<br>";
	                                   else if($w3->getPreferences('ecommerce_show_catalogue_price') == WM3_cENABLED) $price_content = $price."<br>";
                           	           if($show_picture)
                           	            {
										 $picture = wm3Ecommerce::getEcommercePictureFirst($w3,$categoryID,$subcategoryID,$row->productID);
									 	 if($special_offer)
    									  $link = $base_link."&subcategoryID=".$row->subcategoryID."&categoryID=".wm3Ecommerce::getEcommerceCategoryID($w3,$row->subcategoryID).$extra_link."&productID=$row->productID";
                           	             $_DATA[$p]->picture = "<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\">$picture</a>";
                           	             $_DATA[$p]->content = "<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\">$row->name</a><br>$price_content".$row->description;
                           	            }
                           	           else
                           	            {
                           	             $_DATA[$p]->name    = "<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\">$row->name</a>";
                        	             $_DATA[$p]->content = "$price_content".$row->description;
                        	            }
                        	          }
                          }
       else               {
       	                   // For the search in all categories -> subcategories
						   $_PSEP = $w3->getSkinObj()->getPathSeparator();
                           if($admin) {
							           $_DATA[$p]->name = "$row->name<br>(".$w3->getWord(659)."
                           	                              <a href=\"$base_link&categoryID=".$w3->getSectionObj()->getCategoryID($w3,$row->subcategoryID)."&action=".WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY."\">".wm3Ecommerce::getEcommerceCategoryName($w3,$w3->getSectionObj()->getCategoryID($w3,$row->subcategoryID))."</a>
                           	                              $_PSEP <a href=\"$base_link$search_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceSubcategoryName($w3,$row->subcategoryID)."</a>)";
                                       $_DATA[$p]->description = $row->description;
									  }
                           else       {
							           if($show_picture) $_DATA[$p]->picture = "<a href=\"$link$page_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommercePictureFirst($w3,$categoryID,$subcategoryID,$row->productID)."</a>";
                           	           $_DATA[$p]->name = "<a href=$link$page_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT.">$row->name</a><br>(".$w3->getWord(659)."
                           	                              <a href=\"$base_link$page_link&categoryID=".$w3->getSectionObj()->getCategoryID($w3,$row->subcategoryID)."&action=".WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY."\">".wm3Ecommerce::getEcommerceCategoryName($w3,$w3->getSectionObj()->getCategoryID($w3,$row->subcategoryID))."</a>
                           	                              $_PSEP <a href=\"$base_link$search_link$page_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceSubcategoryName($w3,$row->subcategoryID)."</a>)";
                                       $_DATA[$p]->description = $row->description;
									  }
                          }
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $_DATA[$p]->info = $lang_flag;
         // Buttons
         $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_ADD_ECOMMERCE_PICTURE,"action_add_from.png",$w3->getWord(1667));
         if($row->enabled) $_DATA[$p]->b2 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_ECOMMERCE_PRODUCT,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b2 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_ECOMMERCE_PRODUCT,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_ECOMMERCE_PRODUCT,"action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b4 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_ECOMMERCE_PRODUCT,"action_delete.png",$w3->getWord(179),$w3->getWord(772));
        }
       else
        {
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_ECOMMERCE_PRODUCT,"action_edit.png",$w3->getWord(178));
        }
       if($row->productID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'');
     $list->setTotalItems($total_items);
	 $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     if(!$no_form_search) {
		                   require(WM3_cPATH_INCLUDE.'admin_ecommerce_search_form.inc');
     		               $list->setSearchForm($search_form);
     		              }
     if($admin) $list->setTitle("<a href=\"$base_link\">".$w3->getWord(1664)."</a>");
     else       $list->setTitle("<a href=\"$base_link$page_link\">".$w3->getWord(501)."</a>");
     if($subcategoryID)
      {
	   $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) {
       	           $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY."\">".wm3Ecommerce::getEcommerceCategoryName($w3,$categoryID)."</a>");
                   $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
                   $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_ECOMMERCE_PRODUCT,"action_add.png","","",$w3->getWord(1665),0,16,16));
                  }
       else       {
       	           $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY."\">".wm3Ecommerce::getEcommerceCategoryName($w3,$categoryID)."</a>");
                   $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
                  }
      }
     if($admin) {
		         if($found) $list->setCurrentID($currentID);
                 $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT.$id_link.$search_link);
                 $list->setCaptionLabels(array($w3->getWord(194),$w3->getWord(1671),$w3->getWord(1407)));
                 $list->setCaptionWidths(array(30,40,30));
                 $list->setCaptionColspan(array(1,1,1,4));
                 $list->setWidths(array(30,40,30));
			    }
     else       {
		         $list->setRenderCaption(false);
                 if($special_offer) $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_SPECIAL_OFFER.$id_link.$search_link);
	             else               $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT.$id_link.$search_link);
                 if($show_picture) $list->setWidths(array(0,100));
                 else              $list->setWidths(array(35,65));
                }
     return $list->render();
    }

   public static function getEcommercePictureList($w3,$currentID = 0,$admin = true)
    {
     // Get product pictures list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_ECOMMERCE); // Used to enable admin buttons in home stage
     $productID     = $w3->getVariable('productID');
     $categoryID    = $w3->getVariable('categoryID');
     $subcategoryID = $w3->getVariable('subcategoryID');
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($admin) {
				 $query_filter = '';
                 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
				 $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.languageID='".WM3_cLANGUAGE_ALL."')";
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_ECOMMERCE;
     $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID&productID=$productID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.ts DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.productID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.productID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.productID = '$productID'
               $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'pictureID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   $link = $base_link.$id_link.$extra_link."&pictureID=$row->pictureID";
       if($allowed) $allowed_link = $base_allowed_link."&productID=$row->productID";       
       if($subcategoryID) {
                           if($admin) {
							           $_DATA[$p]->picture     = "<a href=\"".WM3_cPATH_ECOMMERCE."$row->picture\" target=\"_blank\"><img src=\"".WM3_cPATH_ECOMMERCE."$row->thumbnail\" width=\"60\" height=\"45\" border=\"0\"></a>";
                        	           $_DATA[$p]->description = $row->description;
									  }
                           else       {
                           	           $picture_content = "<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\"><img src=\"".WM3_cPATH_ECOMMERCE."$row->thumbnail\" width=\"120\" height=\"90\" border=\"0\" alt=\"$row->description\" title=\"$row->description\"></a>";
                                       $title_content   = "";//<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_MEDIA."\">$row->description</a>";
                                       ob_start();
                                       require($w3->getSkinObj()->getFramePicture());
                                       $item_content = ob_get_contents();
                                       ob_end_clean();
                           	           $_DATA[$p]->content = $item_content;
									  }
                          }
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $_DATA[$p]->info = $lang_flag;
         // Buttons
         if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_ECOMMERCE_PICTURE,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_ECOMMERCE_PICTURE,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_ECOMMERCE_PICTURE,"action_delete.png",$w3->getWord(179),$w3->getWord(772));
        }
       else
        {
         //if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_ECOMMERCE_PICTURE,"action_edit.png",$w3->getWord(178));
        }
       if($admin) if($row->productID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
	 $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     if($admin) $list->setTitle("<a href=\"$base_link\">".$w3->getWord(1664)."</a>");
     else       $list->setTitle($w3->getWord(1749));
     if($productID)
      {
	   $_SEP  = $w3->getSkinObj()->getSeparator();
       $_PSEP = $w3->getSkinObj()->getPathSeparator();	
       if($admin) {
                   $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY."\">".wm3Ecommerce::getEcommerceCategoryName($w3,$categoryID)."</a>");
                   $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceSubcategoryName($w3,$subcategoryID)."</a>");
                   $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PICTURE."\">".wm3Ecommerce::getEcommerceProductName($w3,$productID)." ($total_items)</a>");
                   $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_ECOMMERCE_PICTURE,"action_add.png","","",$w3->getWord(1667),0,16,16));
                  }
      }
     if($admin) {
		         require(WM3_cPATH_INCLUDE.'admin_ecommerce_search_form.inc');
		         $list->setSearchForm($search_form);
		         if($found) $list->setCurrentID($currentID);
                 $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PICTURE.$id_link);
                 $list->setCaptionLabels(array($w3->getWord(194),$w3->getWord(1671),$w3->getWord(1671)));
                 $list->setCaptionWidths(array(0,70,30));
                 $list->setCaptionColspan(array(1,1,1,2));
                 $list->setWidths(array(0,70,30));
			    }
     else       {
		         $list->setRenderCaption(false);
                 $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT.$id_link);
                 $list->setWidths(array(25,25,25,25));
                 $list->setObjectsPerRow(4);
                 $list->setUseColors(false);
                }
     return $list->render();
    }

   public static function getEcommerceProductCustomField($w3,$title = '',$from_db = false)
    {
     // Get ecommerce custom fields to add/edit a product (admin side)

     // Prepare variables
     $query_filter = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields.fieldID DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields.enabled='".WM3_cENABLED."'
               $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by);
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return array();

     // Add fields
     if($from_db) // Take values from database
      {
       $rs_db = $w3->getDBObj()->query("SELECT fieldID,value FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data
                                  WHERE productID = '".$w3->getVariable('productID','get')."'
								  ORDER BY fieldID DESC");
       while($row_db = $w3->getDBObj()->fetch($rs_db))
        $_FIELD[wm3Ecommerce::getCustomFieldStringName().$row_db->fieldID] = $row_db->value;
      }
     else // Take values from post
	  {
	   $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductCustomFieldValueArray($w3));
      }

     $_NAME  = array_keys($_FIELD); $p = 0;
     $fields['s1'] = new wm3GUISeparator($title);
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   $label = wm3Ecommerce::getEcommerceProductCustomFieldLabel($w3,$row->fieldID,true);
       $fields[$_NAME[$p]] = new wm3GUITextField($_NAME[$p],$_FIELD[$_NAME[$p]],$label,$row->size);
       if($row->required == WM3_cENABLED) $fields[$_NAME[$p]]->addValidation(WM3_cVALIDATE_NOT_NULL,"Field must be not empty");
       switch($row->type)
        {
		 case WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_INTEGER:
		  {
           $fields[$_NAME[$p]]->addValidation(WM3_cVALIDATE_IS_INTEGER,"Field must be an integer number");
		   break;
		  }
		 case WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_DECIMAL:
		  {
           $fields[$_NAME[$p]]->addValidation(WM3_cVALIDATE_IS_INTEGER,"Field must be a decimal number");//TODO validate decimal
		   break;
		  }
		 case WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_STRING:
		  {
           //$fields[$_NAME[$p]]->addValidation(WM3_cVALIDATE_NOT_NULL,"Field must be a string");//TODO
		   break;
		  }
		}
       $p++;
      }
     return $fields;
    }

   public static function getEcommerceOrderList($w3,$currentID = 0,$admin = true)
    {
     // Get orders list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     //$allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ); // Used to enable admin buttons in home stage
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE message LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
     if($admin) $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     else
      {
       if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
       $query_filter .= "userID='".$w3->getAuthenticateUserID()."'";
      }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     //if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_ECOMMERCE;
     $id_link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders.order_ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
                        $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'orderID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
	 if($total_items != 0 && $admin) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = $_COLSPAN = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link."&orderID=$row->orderID";
       //if($allowed) $allowed_link = $base_allowed_link."&orderID=$row->orderID";
	   $order  = "<a href=\"$link$search_link&action=".WM3_cACTION_SHOW_ECOMMERCE_ORDER_ITEM."\">Order id: #$row->orderID</a><br>Order date: ".wm3Util::renderDate($w3,$row->order_ts,$w3->getAdminLanguage());
	   if($admin) $user = wm3User::getUserLogin($w3,$row->userID);
	   $total = wm3Ecommerce::getEcommerceOrderTotal($w3,$row->orderID);
       $info   = "Total: $total currency...<br>(x items)";
       if($row->status == WM3_cECOMMERCE_ORDER_WAITING) $status = "<img src=\"".WM3_cPATH_DATA."action_order_wait.png\"   width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(745);
	   if($row->status == WM3_cECOMMERCE_ORDER_ACCEPT)  $status = "<img src=\"".WM3_cPATH_DATA."action_order_accept.png\" width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(744);
	   if($row->status == WM3_cECOMMERCE_ORDER_SENDED)  $status = "<img src=\"".WM3_cPATH_DATA."action_order_send.png\"   width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(743);
	   if($row->status == WM3_cECOMMERCE_ORDER_REJECT)  $status = "<img src=\"".WM3_cPATH_DATA."action_order_reject.png\" width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(746);
       if($admin)
        {
         //$lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 $_DATA[$p]->order  = $order;
		 $_DATA[$p]->user   = $user;
		 $_DATA[$p]->info   = $info;
		 $_DATA[$p]->status = $status;
         // Buttons
		 $button_accept          = wm3Util::actionButton("$link$extra_link$search_link&action=".WM3_cACTION_ACCEPT_ECOMMERCE_ORDER,"action_order_accept.png",$w3->getWord(719),$w3->getWord(767));
		 $button_accept_inactive = wm3Util::renderImg('action_order_accept_inactive.png','',24,24,WM3_cPATH_DATA);
		 $button_reject          = wm3Util::actionButton("$link$extra_link$search_link&action=".WM3_cACTION_REJECT_ECOMMERCE_ORDER,"action_order_reject.png",$w3->getWord(720),$w3->getWord(768));
		 $button_reject_inactive = wm3Util::renderImg('action_order_reject_inactive.png','',24,24,WM3_cPATH_DATA);
		 $button_send            = wm3Util::actionButton("$link$extra_link$search_link&action=".WM3_cACTION_SEND_ECOMMERCE_ORDER,"action_order_send.png",$w3->getWord(721),$w3->getWord(769));
		 $button_send_inactive   = wm3Util::renderImg('action_order_send_inactive.png','',24,24,WM3_cPATH_DATA);
		 $button_wait            = wm3Util::actionButton("$link$extra_link$search_link&action=".WM3_cACTION_WAIT_ECOMMERCE_ORDER,"action_order_wait.png",$w3->getWord(721),$w3->getWord(769));
		 $button_wait_inactive   = wm3Util::renderImg('action_order_wait_inactive.png','',24,24,WM3_cPATH_DATA);
		 $button_delete          = wm3Util::actionButton("$link$extra_link$search_link&action=".WM3_cACTION_DELETE_ECOMMERCE_ORDER,"action_delete.png",$w3->getWord(179),$w3->getWord(774));
		 $button_delete_inactive = wm3Util::renderImg('action_delete_inactive.png','',24,24,WM3_cPATH_DATA);
		 if($row->status == WM3_cECOMMERCE_ORDER_WAITING)
          { $_DATA[$p]->b1 = $button_accept; $_DATA[$p]->b2 = $button_reject; $_DATA[$p]->b3 = $button_send_inactive; $_DATA[$p]->b4 = $button_wait_inactive; $_DATA[$p]->b5 = $button_delete; }
		 if($row->status == WM3_cECOMMERCE_ORDER_ACCEPT)
          { $_DATA[$p]->b1 = $button_accept_inactive; $_DATA[$p]->b2 = $button_reject_inactive; $_DATA[$p]->b3 = $button_send; $_DATA[$p]->b4 = $button_wait; $_DATA[$p]->b6 = $button_delete_inactive; }
		 if($row->status == WM3_cECOMMERCE_ORDER_REJECT)
          { $_DATA[$p]->b1 = $button_accept_inactive; $_DATA[$p]->b2 = $button_reject_inactive; $_DATA[$p]->b3 = $button_send_inactive; $_DATA[$p]->b4 = $button_wait; $_DATA[$p]->b5 = $button_delete; }
		 if($row->status == WM3_cECOMMERCE_ORDER_SENDED)
          { $_DATA[$p]->b1 = $button_accept_inactive; $_DATA[$p]->b2 = $button_reject_inactive; $_DATA[$p]->b3 = $button_send_inactive; $_DATA[$p]->b4 = $button_wait_inactive; $_DATA[$p]->b5 = $button_delete_inactive; }
        }
       else
        {
		 $_DATA[$p]->order  = $order;
		 $_DATA[$p]->info   = $info;
		 $_DATA[$p]->status = $status;
         //if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MESSAGE,"action_edit.png",$w3->getWord(178));
        }
       if($row->orderID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }
     if(!$admin)
	  {
       $_DATA[$p]->content = "<br>".wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_SHOW_ECOMMERCE_CART,"misc_cart.png","","",$w3->getWord(692))."<br><br>";
       $_COLSPAN[$p] = array(3);
	  }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'',$_COLSPAN);
     $list->setTotalItems($total_items);
     if($admin) {
                 require(WM3_cPATH_INCLUDE.'admin_message_search_form.inc');
		         $list->setSearchForm($search_form);
                 $list->setTitle($w3->getWord(794)." ($total_items)");
		         if($found) $list->setCurrentID($currentID);
                 $list->setMaxPageItems($max_page_items);
                 $list->setPage($pg);
                 $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_ORDER.$id_link);
                 $list->setCaptionLabels(array($w3->getWord(750),$w3->getWord(403),$w3->getWord(1671),$w3->getWord(806)));
                 $list->setCaptionWidths(array(30,15,35,20));
                 $list->setCaptionColspan(array(1,1,1,1,5));
                 $list->setWidths(array(30,15,35,20));
			    }
     else       {
		         $list->setRenderCaption(false);
		         $list->setRenderPagesNavigator(false);
                 $list->setWidths(array(35,40,25));
                }
     return $list->render();
    }

   public static function getEcommerceOrderItemList($w3,$currentID = 0,$admin = true,$printable = false)
    {
     // Get items list for an order (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     //$allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ); // Used to enable admin buttons in home stage
	 $orderID = $w3->getVariable('orderID');
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "AND message LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
     if($admin) $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     else       $query_filter .= "AND userID='".$w3->getAuthenticateUserID()."'";
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     //if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_ECOMMERCE;
     $id_link = ''; $link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items.ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
	           WHERE  orderID = '$orderID'
	           $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'orderID',$rs);//???
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
	 if($printable) $limit = "";
	 else           $limit = " LIMIT ".($pg*$max_page_items).",$max_page_items";
     if($total_items != 0 && $admin) $rs = $w3->getDBObj()->query($query.$order_by.$limit);

     // Create list content
     $_DATA = $_COLSPAN = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&orderID=$row->orderID";
       //if($allowed) $allowed_link = $base_allowed_link."&orderID=$row->orderID";
	   $product_link = '';
       if(!$printable)
	    {
	     if(wm3Ecommerce::existsEcommerceProduct($w3,$row->productID))
		  {
		   if($admin) $product_link = " ".wm3Util::actionButton("$link&productID=$row->productID&action=".WM3_cACTION_EDIT_ECOMMERCE_PRODUCT,"action_show.png",'','','Show product',0,16,16);
		   else       {
                       $subcategoryID = wm3Ecommerce::getEcommerceSubcategoryID($w3,$row->productID);
                       $categoryID    = wm3Ecommerce::getEcommerceCategoryID($w3,$subcategoryID);
			           $product_link = " ".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&categoryID=$categoryID&subcategoryID=$subcategoryID&productID=$row->productID&section=".WM3_cSECTION_HOME."&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT,"action_show.png",'','','Show product',0,16,16);
				      }
	      }
	     else         $product_link = " <i>(Product was deleted)</i>";
	    }
	   $product  = "<b>$row->product_name</b> (#$row->product_code)$product_link<br>$row->product_description";
	   $quantity = $row->quantity;
       $price    = $row->price;
       $data     = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
       if($admin)
        {
         //$lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $_DATA[$p]->product  = $product;
         $_DATA[$p]->quantity = $quantity;
         $_DATA[$p]->price    = $price;
         $_DATA[$p]->data     = $data;
         // Buttons
		 if(!$printable) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_ECOMMERCE_ORDER,"action_delete.png",$w3->getWord(179),$w3->getWord(774));
        }
       else
        {
         $_DATA[$p]->product  = $product;
         $_DATA[$p]->quantity = $quantity;
         $_DATA[$p]->price    = $price;
         $_DATA[$p]->data     = $data;
         //if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MESSAGE,"action_edit.png",$w3->getWord(178));
        }
       if($row->orderID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }
     //$_DATA[$p]->total = $total; $_COLSPAN[$p] = array(4); $p++; //TODO totale?
     if(!$admin && count($_DATA) > 0)
	  {
       $_DATA[$p]->button = "<br>".wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_SHOW_ECOMMERCE_CART,"misc_cart.png","","",$w3->getWord(692))."<br><br>";
       $_COLSPAN[$p] = array(4);
	  }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'',$_COLSPAN);
	 $_SEP = $w3->getSkinObj()->getSeparator();
     $list->setTotalItems($total_items);
     $list->setCaptionLabels(array($w3->getWord(737),$w3->getWord(677),$w3->getWord(674),$w3->getWord(807)));
     $list->setCaptionWidths(array(60,8,8,24)); 
     $list->setCaptionColspan(array(1,1,1,1,1));
     $list->setWidths(array(60,8,8,24));

     // Order user information
     $userID = wm3Ecommerce::getEcommerceOrderUserID($w3,$orderID);
     if(!$admin) if($w3->getAuthenticateUserID() != $userID) $userID = 0; // Prevent an user to see other users orders details
	 if($userID)
	  {
       $user_rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users WHERE userID = '$userID'");
       if($w3->getDBObj()->totalRows($user_rs) == 0) $user_info = "<br>User not found.";
	   else
	    {
	     $row = $w3->getDBObj()->fetch($user_rs);
	     $user_info = "<br>$row->name $row->surname ($row->login)<br>$row->address<br>$row->zip_code $row->city ($row->stateID), ".wm3Statistic::getCountryName($w3,$row->countryID);
	    }
       $list->setExtraHeader("<hr>".$w3->getWord(398)."<br>".$user_info);
      }

     if($admin)
      {
	   if(!$printable)
	    {
         require(WM3_cPATH_INCLUDE.'admin_message_search_form.inc');
         $list->setSearchForm($search_form);
         if($found) $list->setCurrentID($currentID);
	     $_PSEP = $w3->getSkinObj()->getPathSeparator();
	     $button_accept  = wm3Util::actionButton("$base_link&orderID=$orderID&action=".WM3_cACTION_ACCEPT_ECOMMERCE_ORDER,"action_order_accept.png",'',$w3->getWord(767),$w3->getWord(719));
	     $button_reject  = wm3Util::actionButton("$base_link&orderID=$orderID&action=".WM3_cACTION_REJECT_ECOMMERCE_ORDER,"action_order_reject.png",'',$w3->getWord(768),$w3->getWord(720));
	     $button_send    = wm3Util::actionButton("$base_link&orderID=$orderID&action=".WM3_cACTION_SEND_ECOMMERCE_ORDER,"action_order_send.png",    '',$w3->getWord(769),$w3->getWord(721));
	     $button_wait    = wm3Util::actionButton("$base_link&orderID=$orderID&action=".WM3_cACTION_WAIT_ECOMMERCE_ORDER,"action_order_wait.png",    '',$w3->getWord(769),$w3->getWord(721));
	     $button_delete  = wm3Util::actionButton("$base_link&orderID=$orderID&action=".WM3_cACTION_DELETE_ECOMMERCE_ORDER,"action_delete.png",      '',$w3->getWord(774),$w3->getWord(179));
         $status_buttons = '';
	     $order_status   = wm3Ecommerce::getEcommerceOrderStatus($w3,$orderID);
	     $status = '';
	     if($order_status == WM3_cECOMMERCE_ORDER_WAITING)
	      {
	       $status = "<img src=\"".WM3_cPATH_DATA."action_order_wait.png\" width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(745);
	       $status_buttons = " $_SEP $button_accept $_SEP $button_reject $_SEP $button_delete";
	      }
	     if($order_status == WM3_cECOMMERCE_ORDER_ACCEPT)
	      {
		   $status = "<img src=\"".WM3_cPATH_DATA."action_order_accept.png\" width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(744);
	       $status_buttons = " $_SEP $button_send $_SEP $button_wait";
	      }
	     if($order_status == WM3_cECOMMERCE_ORDER_REJECT)
	      {
           $status = "<img src=\"".WM3_cPATH_DATA."action_order_reject.png\" width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(746);
	       $status_buttons = " $_SEP $button_wait $_SEP $button_delete";
	      }
	     if($order_status == WM3_cECOMMERCE_ORDER_SENDED)
	      {
		   $status_buttons = "";
	       $status = "<img src=\"".WM3_cPATH_DATA."action_order_send.png\" width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(743);
	      }
	     $status_buttons .= " $_SEP ".wm3Util::actionButton($base_link.$extra_link."&orderID=$orderID&action=".WM3_cACTION_PRINTABLE_ECOMMERCE_ORDER,"action_print.png",'','',$w3->getWord(1400),0,24,24,"absmiddle","_blank");
	     $user_name = "username TODO";//wm3User::getUserLogin($w3,$row->userID);
	     $total = wm3Ecommerce::getEcommerceOrderTotal($w3,$orderID);
         $list->setTitle("<a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_ECOMMERCE."&action=".WM3_cACTION_SHOW_ECOMMERCE_ORDER."\">".$w3->getWord(794)."</a> ".$_PSEP." Order id: #$orderID ($total_items, $total ".$w3->getPreferences('ecommerce_currency').", $user_name, $status) $status_buttons");
         $list->setMaxPageItems($max_page_items);
         $list->setPage($pg);
         $list->setPagesNavigatorLink($base_link."&orderID=$orderID&action=".WM3_cACTION_SHOW_ECOMMERCE_ORDER_ITEM.$id_link);
		}
      }
     else
      {
	   $list->setTitle("Order id: #$orderID");
	   $list->setRenderPagesNavigator(false);
      }
     if($printable)
      {
	   $w3->getPageObj()->setTitle("Order id: #$orderID");
       $w3->getPageObj()->setSubTitle('');
       $list->setTitle("Print time: ".wm3Util::renderDate($w3,time(),$w3->getAdminLanguage()));
       $list->setRenderPagesNavigator(false);
      }
     return $list->render();
    }

   public static function checkEcommercePictureError($w3)
    {
     // Check form invalid inputs and upload error
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommercePictureFieldsArray());

     $aux = time()."_".rand(1,99999); // Avoid overwritting the files
     if($_FIELD['picture_from'] == WM3_cUPLOAD_FROM_LOCAL) // Take file from local hard drive
      {
       // Upload the file and give the name to the files
       if($_FILES['picture_from_local']['name']) $picture_name = $aux.".".wm3Util::cutExtension($_FILES['picture_from_local']['name']);
       else                                      $picture_name = "";
       $error = wm3Folder::uploadFile("picture_from_local",WM3_cPATH_ECOMMERCE,$picture_name,true,wm3Folder::mimeTypeImage(),0);
       if($error) return $error;
      }
     if($_FIELD['thumbnail_from'] == WM3_cUPLOAD_FROM_LOCAL) // Take file from local hard drive
      {
       // Upload the file and give the name to the files
       if($_FILES['thumbnail_from_local']['name']) $thumbnail_name = $aux."_t.".wm3Util::cutExtension($_FILES['thumbnail_from_local']['name']);
       else                                        $thumbnail_name = "";
       $error = wm3Folder::uploadFile("thumbnail_from_local",WM3_cPATH_ECOMMERCE,$thumbnail_name,true,wm3Folder::mimeTypeImage(),0);
       if($error) return $error + 6;
      }
	 if(!wm3Ecommerce::existsEcommerceProduct($w3,$_FIELD['productID'])) return 13;
     return 0; // Take file from remote folder (or no errors)
    }

   public static function addEcommerceProduct($w3)
    {
	 // Initialize form
	 $from_db = false;
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductFieldsArray());
	 $action = WM3_cACTION_ADD_ECOMMERCE_PRODUCT;
	 require(WM3_cPATH_INCLUDE.'admin_ecommerce_product_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1665));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
       $_F['categoryID']->setValue($w3->getVariable('categoryID','get')); // Take categoryID from get
       $_F['subcategoryID']->setValue($w3->getVariable('subcategoryID','get')); // Take subcategoryID from get
      }
     else
      {
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products      WRITE,
		                             ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
		                             ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE,
									 ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields WRITE,
									 ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data   WRITE");
       if($form->validate())
        {
         $lastID = wm3Ecommerce::saveEcommerceProduct($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Ecommerce::getEcommerceProductList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function editEcommerceProduct($w3)
    {
	 // Initialize form
     if($w3->getVariable('wm3_was_submit','post')) $from_db = false; else $from_db = true; // Patch to get custom field correctly
	 $action = WM3_cACTION_EDIT_ECOMMERCE_PRODUCT;
	 require(WM3_cPATH_INCLUDE.'admin_ecommerce_product_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit product");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                               WHERE productID = '".$w3->getVariable('productID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Ecommerce::getEcommerceProductFieldsArray(),$row);

       // Default value for fields not in $row object
       $_FIELD['categoryID'] = $w3->getVariable('categoryID','get'); // Take categoryID from get
       $form->setFieldsValues($_FIELD);
      }
     else
      {
	   $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductFieldsArray());
       $form->setFieldsValues($_FIELD);
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products      WRITE,
		                             ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
		                             ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE,
									 ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields WRITE,
									 ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data   WRITE");
       if($form->validate())
        {
         $lastID = wm3Ecommerce::updateEcommerceProduct($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Ecommerce::getEcommerceProductList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function synchronizeEcommerceProductCustomData($w3)
    {
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products      WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data   WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels WRITE");

     // Synchronize products that have some custom data field missing
	 $productID = $w3->getVariable('productID','get');
	 if(!$w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX."_ecommerce_products","WHERE productID ='$productID'")) // Check if product exists
	  { $w3->getDBObj()->query("UNLOCK TABLES"); return; }
	 $_FIELD['dataID']     = 0;
	 $_FIELD['productID']  = $productID;
	 $_FIELD['fieldID']    = 0;
	 $_FIELD['value']      = '';
	 $_FIELD['enabled']    = WM3_cENABLED;
	 $_FIELD['languageID'] = WM3_cLANGUAGE_ALL;
	 $_FIELD['ts']         = time();
	 $rs = $w3->getDBObj()->query("SELECT fieldID FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields");
	 while($row = $w3->getDBObj()->fetch($rs))
	  {
       if(!$w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data","WHERE fieldID='".$row->fieldID."' AND productID='$productID'"))
	    {
         $_FIELD['fieldID']   = $row->fieldID;
         $w3->getDBObj()->saveAllTableFields('_ecommerce_custom_data',$_FIELD);
	    }
	  }

	 $w3->getDBObj()->query("UNLOCK TABLES");
	}

   public static function saveEcommerceProduct($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_ecommerce_products',$_FIELD,array('categoryID'));
	 $lastID = $w3->getDBObj()->getLastInsertID();

     // Save also custom fields values
	 // TODO fare lock table di ecommerce_custom_fields
     $_VALUE = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductCustomFieldValueArray($w3));
	 $_ID    = array_keys($_VALUE);
	 for($i = 0; $i < sizeof($_VALUE); $i++)
	  {
       $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductCustomDataFieldsArray(),WM3_cQUOTE_DB);
	   $_FIELD['productID']  = $lastID;
	   $_FIELD['fieldID']    = substr($_ID[$i],wm3Ecommerce::getCustomFieldStringName(true));
	   $_FIELD['value']      = wm3Util::quoteDB($_VALUE[$_ID[$i]]);
	   $_FIELD['enabled']    = WM3_cENABLED;
	   $_FIELD['languageID'] = 0;//???
	   $_FIELD['ts']         = time();
	   $w3->getDBObj()->saveAllTableFields('_ecommerce_custom_data',$_FIELD);
      }
     return $lastID;
    }

   public static function updateEcommerceProduct($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                       SET   subcategoryID     = '".$_FIELD['subcategoryID']."',
                             userID            = '".$_FIELD['userID']."',
                             code              = '".$_FIELD['code']."',
                             name              = '".$_FIELD['name']."',
                             description       = '".$_FIELD['description']."',
                             full_description  = '".$_FIELD['full_description']."',
							 render_mode       = '".$_FIELD['render_mode']."',
                             price             = '".$_FIELD['price']."',
                             price_description = '".$_FIELD['price_description']."',
                             discount          = '".$_FIELD['discount']."',
                             special           = '".$_FIELD['special']."',
                             stock             = '".$_FIELD['stock']."',
                             availability      = '".$_FIELD['availability']."',
                             options           = '".$_FIELD['options']."',
                             enabled           = '".$_FIELD['enabled']."',
                             languageID        = '".$_FIELD['languageID']."'
                       WHERE productID         = '".$_FIELD['productID']."'");

     // Update custom fields values
//TODO verificare che funzioni quando inserisco un nuovo field dalle preference è non c'è
// nessuna row in ecommerce_custom_data relativa al prodotto da modificare.
     $_VALUE = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductCustomFieldValueArray($w3));
	 $_ID    = array_keys($_VALUE);
	 for($i = 0; $i < sizeof($_VALUE); $i++)
	  {
       $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductCustomDataFieldsArray(),WM3_cQUOTE_DB);
	   $_FIELD['value']   = wm3Util::quoteDB($_VALUE[$_ID[$i]]);
	   $_FIELD['fieldID'] = substr($_ID[$i],wm3Ecommerce::getCustomFieldStringName(true));
	   //$_FIELD['enabled'] = WM3_cENABLED;
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data
                         SET value       = '".$_FIELD['value']."'
                         WHERE productID = '".$_FIELD['productID']."' AND
						       fieldID   = '".$_FIELD['fieldID']."'");
      }
     return $_FIELD['productID'];
    }

   public static function duplicateEcommerceProduct($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_news
                             WHERE newsID = '".$w3->getVariable('newsID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Ecommerce::getEcommerceFieldsArray(),$row);
       $_FIELD['title'] = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       //$_FIELD['update_ts'] = $_FIELD['ts'] = time();
       $_FIELD['ts'] = time();
       //$w3->getDBObj()->saveAllTableFields('_news',$_FIELD,array('update_ts'));
       $w3->getDBObj()->saveAllTableFields('_news',$_FIELD);
       return $w3->getDBObj()->getLastInsertID();
      }
    }

   public static function disableEcommerceProduct($w3,$productID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products SET enabled = '".WM3_cDISABLED."' WHERE productID = '$productID'");
	}

   public static function enableEcommerceProduct($w3,$productID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products SET enabled = '".WM3_cENABLED."' WHERE productID = '$productID'");
	}
   
   public static function deleteEcommerceProduct($w3,$productID)
    {
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products          WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories        WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories     WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items       WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data       WRITE");
     // Delete also the images, cart items (no ordered) and custom data
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WHERE productID = '$productID'");
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items WHERE productID = '$productID' AND orderID = '0'");
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data WHERE productID = '$productID'");
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products WHERE productID = '$productID'");
     $w3->getDBObj()->query("UNLOCK TABLES");	 
	}

   public static function addEcommercePicture($w3,$error = 0)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommercePictureFieldsArray());
	 $action = WM3_cACTION_SAVE_ECOMMERCE_PICTURE;
	 require(WM3_cPATH_INCLUDE.'admin_ecommerce_picture_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1667));
     $form->setFieldsValues($_FIELD);

     if($error)
      {
       // Delete bad uploaded files (if exists)
       if(file_exists(WM3_cPATH_ECOMMERCE.$_FILES['picture_from_local']['name']))   @unlink(WM3_cPATH_ECOMMERCE.$_FILES['picture_from_local']['name']);
       if(file_exists(WM3_cPATH_ECOMMERCE.$_FILES['thumbnail_from_local']['name'])) @unlink(WM3_cPATH_ECOMMERCE.$_FILES['thumbnail_from_local']['name']);
       $form->setError(true);
      }
     switch($error)
      {
       // Picture error
       case 1: // Upload error
        {
         $_F['picture_from_local']->setError(true);
         $form->setTitle("Error Upload error $error");
         break;
        }
       case 2: // File not allowed
        {
         $_F['picture_from_local']->setError(true);
         $form->setTitle("Error Not allowed $error");
         break;
        }
       case 5: // File too big
        {
         $_F['picture_from_local']->setError(true);
         $form->setTitle("Error file too big $error");
         break;
        }
       case 6: // Empty file given (no upload performed)
        {
         $_F['picture_from_local']->setError(true);
         $form->setTitle("Error no file specified $error");
         break;
        }
       // Thumbnail upload error
       case 7: // Upload error
        {
         $_F['thumbnail_from_local']->setError(true);
         $form->setTitle("Upload error $error");
         break;
        }
       case 8: // File not allowed
        {
         $_F['thumbnail_from_local']->setError(true);
         $form->setTitle("File not allowed $error");
         break;
        }
       case 11: // File too big
        {
         $_F['thumbnail_from_local']->setError(true);
         $form->setTitle("File too big $error");
         break;
        }
       case 12: // Empty file given (no upload performed)
        {
         $_F['thumbnail_from_local']->setError(true);
         $form->setTitle("Empty file name $error");
         break;
        }
       case 13: // Invalid products
        {
         $form->setTitle("Invalid products");
         break;
        }
       default:
        {
         // Default values for the form
         $_F['categoryID']->setValue($w3->getVariable('categoryID','get'));       // Take categoryID from get
         $_F['subcategoryID']->setValue($w3->getVariable('subcategoryID','get')); // Take subcategoryID from get
         $_F['productID']->setValue($w3->getVariable('productID','get'));         // Take productID from get
         $_F['enabled']->setValue(WM3_cENABLED);
         $_F['picture_from']->setValue(WM3_cUPLOAD_FROM_LOCAL);
         $_F['thumbnail_from']->setValue(WM3_cUPLOAD_FROM_LOCAL);
       	}
      }

     // Operation to do before render the form
     $preview_image = $_FIELD['picture_from_remote']; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_ECOMMERCE); // Set due preview image
     $_F['picture_from_remote']->setExtraContentAfter(" ".wm3Util::renderImg($preview_image,$w3->getWord(893),120,90,WM3_cPATH_ECOMMERCE,1,'top','preview_image'));
     $preview_thumbnail = $_FIELD['thumbnail_from_remote']; if(!$preview_thumbnail) $preview_thumbnail = wm3Util::getFirstFile(WM3_cPATH_ECOMMERCE); // Set due preview image
     $_F['thumbnail_from_remote']->setExtraContentAfter(" ".wm3Util::renderImg($preview_thumbnail,$w3->getWord(893),120,90,WM3_cPATH_ECOMMERCE,1,'top','preview_thumbnail'));
	 if($_FIELD['picture_from'] == WM3_cUPLOAD_FROM_REMOTE) $_F['picture_from_remote']->setVisible(true);
	 else                                                   $_F['picture_from_local']->setVisible(true);
	 if($_FIELD['thumbnail_from'] == WM3_cUPLOAD_FROM_REMOTE) $_F['thumbnail_from_remote']->setVisible(true);
	 else                                                     $_F['thumbnail_from_local']->setVisible(true);

     return $form->render();
    }

   public static function saveEcommercePicture($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommercePictureFieldsArray(),WM3_cQUOTE_DB);
     //$_FIELD['message_ts'] = $_FIELD['ts'] = time();
     //$w3->getDBObj()->saveAllTableFields('_ecommerce_products',$_FIELD,array('update_ts'));
     if($_FIELD['picture_from']   == WM3_cUPLOAD_FROM_LOCAL) $_FIELD['picture']   = $_FILES['picture_from_local']['name'];   else $_FIELD['picture']   = $_FIELD['picture_from_remote'];
     if($_FIELD['thumbnail_from'] == WM3_cUPLOAD_FROM_LOCAL) $_FIELD['thumbnail'] = $_FILES['thumbnail_from_local']['name']; else $_FIELD['thumbnail'] = $_FIELD['thumbnail_from_remote'];
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_ecommerce_products_pictures',$_FIELD,array('categoryID','subcategoryID','picture_from_local','picture_from_remote','thumbnail_from_local','thumbnail_from_remote','picture_from','thumbnail_from'));
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function disableEcommercePicture($w3,$pictureID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures SET enabled = '".WM3_cDISABLED."' WHERE pictureID = '$pictureID'");
	}

   public static function enableEcommercePicture($w3,$pictureID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures SET enabled = '".WM3_cENABLED."' WHERE pictureID = '$pictureID'");
	}

   public static function deleteEcommercePicture($w3,$pictureID)
    {
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WHERE pictureID = '$pictureID'");
    }

   public static function acceptEcommerceOrder($w3,$orderID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
	                   SET status = '".WM3_cECOMMERCE_ORDER_ACCEPT."'
	                   WHERE orderID = '$orderID' AND status = '".WM3_cECOMMERCE_ORDER_WAITING."'");
	}

   public static function rejectEcommerceOrder($w3,$orderID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
	                   SET status = '".WM3_cECOMMERCE_ORDER_REJECT."'
	                   WHERE orderID = '$orderID' AND status = '".WM3_cECOMMERCE_ORDER_WAITING."'");
	}

   public static function sendEcommerceOrder($w3,$orderID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
	                   SET status = '".WM3_cECOMMERCE_ORDER_SENDED."'
	                   WHERE orderID = '$orderID' AND status = '".WM3_cECOMMERCE_ORDER_ACCEPT."'");
	}

   public static function waitEcommerceOrder($w3,$orderID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
	                   SET status = '".WM3_cECOMMERCE_ORDER_WAITING."'
	                   WHERE orderID = '$orderID' AND (status = '".WM3_cECOMMERCE_ORDER_ACCEPT."' OR status = '".WM3_cECOMMERCE_ORDER_REJECT."')");
	}

   public static function deleteEcommerceOrder($w3,$orderID)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products      WRITE,
                                   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE,
  		 		                   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items   WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders        WRITE");
	 $status = wm3Ecommerce::getEcommerceOrderStatus($w3,$orderID);
	 if($status == WM3_cECOMMERCE_ORDER_WAITING || $status == WM3_cECOMMERCE_ORDER_REJECT)
	  {
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items WHERE orderID = '$orderID'");
       $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders WHERE orderID = '$orderID'");
      }
	 $w3->getDBObj()->query("UNLOCK TABLES");
    }

   public static function getEcommerceProductCode($w3,$productID,$label = false)
    {
     // Get a product name
     $rs = $w3->getDBObj()->query("SELECT code FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE productID = '$productID'");
     if($w3->getDBObj()->totalRows($rs) != 1) if($label) return $label; else return "";
     $row = $w3->getDBObj()->fetch($rs);
     return $row->code;
    }

   public static function getEcommerceProductName($w3,$productID,$label = false)
    {
     // Get a product name
     $rs = $w3->getDBObj()->query("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE productID = '$productID'");
     if($w3->getDBObj()->totalRows($rs) != 1) if($label) return $label; else return "";
     $row = $w3->getDBObj()->fetch($rs);
     return $row->name;
    }

   public static function getEcommerceProductDescription($w3,$productID,$label = false)
    {
     // Get a product name
     $rs = $w3->getDBObj()->query("SELECT description FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE productID = '$productID'");
     if($w3->getDBObj()->totalRows($rs) != 1) if($label) return $label; else return "";
     $row = $w3->getDBObj()->fetch($rs);
     return $row->description;
    }

   public static function getEcommerceProductPrice($w3,$productID)
    {
     // Get a product price
     $rs = $w3->getDBObj()->query("SELECT price FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE productID = '$productID'");
     $row = $w3->getDBObj()->fetch($rs);
     return $row->price;
    }

   public static function getEcommerceProductDiscount($w3,$productID)
    {
     // Get a product discount
     $rs = $w3->getDBObj()->query("SELECT discount FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE productID = '$productID'");
     $row = $w3->getDBObj()->fetch($rs);
     return $row->discount;
    }

   public static function getEcommerceOrderUserID($w3,$orderID)
    {
     // Return userID from orderID
     $rs = $w3->getDBObj()->query("SELECT userID FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
                             WHERE orderID = '$orderID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->userID;
    }

   public static function getEcommerceOrderTotal($w3,$orderID)
    {
     // Get an order total price (with shipping costs)
     $rs = $w3->getDBObj()->query("SELECT SUM(price*quantity) AS total FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
                             WHERE orderID = '$orderID'");
     $row = $w3->getDBObj()->fetch($rs);
     return $row->total;//+$row->shipping_cost da tabella orders; TODO
    }

   public static function getEcommerceCustomFieldLabel($w3,$fieldID,$languageID)
    {
	 // Get actual language field label
	 $rs = $w3->getDBObj()->query("SELECT label FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels
	                         WHERE fieldID='$fieldID' AND languageID='$languageID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return "";
	 $row = $w3->getDBObj()->fetch($rs);
	 return $row->label;
	}

   public static function selectEcommerceProductOptions($w3,$options)
    {
     // Get ecommerce product options selects (home side)
     $i = 0; $token = strtok($options,"|");
     while($token)
	  {
	   $_ROW[$i] = $token;
       $token = strtok("|");
	   $i++;
      }
	 if($i == 0) return array();

     for($i = 0; $i < sizeof($_ROW); $i++)
      {
	   $j = 0; $token = strtok($_ROW[$i],","); $_ITEM = array();
       while($token)
	    {
	     if($j == 0) $label = $token; else $_ITEM[$j-1] = $token;
         $token = strtok(",");
	     $j++;
        }
	   $value = $w3->getVariable('option'.$i);
	   $fields['option'.$i]       = new wm3GUISelect     ('option'.$i,$value,$label,wm3Util::selectArrayEquals($_ITEM));
	   $fields['option_label'.$i] = new wm3GUIHiddenField('option_label'.$i,$label);
	  }
     return $fields;
    }

   public static function selectEcommerceProductAvailability($w3)
    {
     // Return an array of wm3GUIOption objects for ecommerce product availability select
     return wm3Util::selectArray(array($w3->getWord(679),$w3->getWord(680),$w3->getWord(681),$w3->getWord(682)),
                                 array(WM3_cECOMMERCE_AVAILABILITY_HEIGHT,WM3_cECOMMERCE_AVAILABILITY_EVERAGE,WM3_cECOMMERCE_AVAILABILITY_LOW,WM3_cECOMMERCE_AVAILABILITY_NONE));
    }

   public static function selectEcommercePictureFrom($w3)
    {
     // Return an array of wm3GUIOption objects for ecommerce picture from type select
     return wm3Util::selectArray(array($w3->getWord(-1)."From local drive",$w3->getWord(-1)."From remote folder"),
                                 array(WM3_cUPLOAD_FROM_LOCAL,WM3_cUPLOAD_FROM_REMOTE));
    }

   public static function renderEcommerceSpecialOffer($w3)
    {
     // Render ecommerce special offer panel (for home page)
	 $base_link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME;
     $pageID = $w3->getVariable('pageID');
     $page_link = "&pageID=$pageID";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID
                 AND  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".WM3_cLANGUAGE_ALL."')
				 AND  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.special = '".WM3_cENABLED."'
 			   ORDER BY RAND() LIMIT 1";
     $rs = $w3->getDBObj()->query($query);
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create special offer
     $_DATA = array();
     if($total_items == 1)
      {
       $link = $base_link.$page_link;
       $row = $w3->getDBObj()->fetch($rs);
	   $subcategoryID = $row->subcategoryID;
	   $categoryID = wm3Ecommerce::getEcommerceCategoryID($w3,$subcategoryID);
       $image = "<div align=\"center\"><a href=\"$link&categoryID=$categoryID&subcategoryID=$subcategoryID&productID=$row->productID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommercePictureFirst($w3,0,$row->subcategoryID,$row->productID)."</a></div>";
       $name = "<div align=\"center\"><a href=\"$link&categoryID=$categoryID&subcategoryID=$subcategoryID&productID=$row->productID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\">$row->name</a></div>";
       $_DATA[0]->content = $image;
       $_DATA[1]->content = $name;
	   $currency = $w3->getPreferences('ecommerce_currency');
	   if($row->discount > 0) $info = "<s>$row->price $currency $row->price_description</s><br>".($row->price-($row->price*$row->discount/100))." $currency $row->price_description <i>(".$w3->getWord(1500)." $row->discount %)</i>";
	   else                   $info = "$row->price $currency $row->price_description";
	   $info = "<div align=\"center\">$info</div>";
       $more = "<div align=\"center\"><a href=\"$link&action=".WM3_cACTION_SHOW_ECOMMERCE_SPECIAL_OFFER."\">".$w3->getWord(1640)." > </a></div>";
       $_DATA[2]->content = $info;
       $_DATA[3]->content = $more;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
     $list->setEmptyLabel($w3->getWord(1639));
     $list->setWidths(array(100));
     $list->setUseColors(false);
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public static function renderEcommerceCart($w3,$currentID = 0,$admin = true,$order = false)
    {
     // Get current user cart content (home side)

     wm3Ecommerce::expireEcommerceCart($w3);

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ); // Used to enable admin buttons in home stage
     $pg = $w3->getVariable('pg');
     $search_link = $query_filter = '';
	 $userID = $w3->getAuthenticateUserID();
     $query_filter = " WHERE userID = '$userID' AND orderID = '0'";
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MESSAGES;
     $id_link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'messageID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0 && $admin) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = $_COLSPAN = array(); $p = 0; $total = 0; $found = false;
	 $currency = $w3->getPreferences('ecommerce_currency');
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&cart_itemID=$row->cart_itemID";
       if($allowed) $allowed_link = $base_allowed_link."&productsID=$row->productID";
       $subcategoryID = wm3Ecommerce::getEcommerceSubcategoryID($w3,$row->productID);
       $categoryID    = wm3Ecommerce::getEcommerceCategoryID($w3,$subcategoryID);
	   $product = ($p+1).". ".wm3Util::makeLink(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&categoryID=$categoryID&subcategoryID=$subcategoryID&productID=$row->productID&section=".WM3_cSECTION_HOME."&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT,wm3Ecommerce::getEcommerceProductName($w3,$row->productID));
	   $date    = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
	   // TODO Discount
       $_DATA[$p]->product  = $product;
       $_DATA[$p]->quantity = $row->quantity;
	   $_DATA[$p]->price    = $row->price;
	   $_DATA[$p]->date     = $date;
       // Buttons
       $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_ECOMMERCE_CART_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(695));
       if($allowed) $_DATA[$p]->b2 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_ECOMMERCE_PRODUCT,"action_edit.png",$w3->getWord(178));
       if($row->cart_itemID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++; $total = $total + $row->price * $row->quantity; //TODO Discount
      }
     if(count($_DATA) > 0)
      {
	   if($order)
	    {
	     // Shipping cost
	     $shipping = $w3->getPreferences('ecommerce_shipping_cost');
	     if($shipping > 0)
	      {
           $_DATA[$p]->label    = $w3->getWord(1034)." ($currency)";
           $_DATA[$p]->shipping = $shipping;
           $_COLSPAN[$p] = array(2,4);
	       $total = $total + $shipping;
	       $p++;
          }
	     // Total
         $_DATA[$p]->label = "<b>".$w3->getWord(1395)." ($currency)</b>";
         $_DATA[$p]->total = "<b>".$total."</b>";
         $_COLSPAN[$p] = array(2,4);
         $p++;
        }
       // Other ecommerce cart buttons
       if(!$order)
	    {
	     $_DATA[$p]->button1 = "<br>".wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_PROCESS_ECOMMERCE_ORDER,"misc_cart_order.png","","",$w3->getWord(718))."<br><br>";
	     $_DATA[$p]->button2 = "<br>".wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_SHOW_ECOMMERCE_ORDER,"misc_orders.png","","",$w3->getWord(1662))."<br><br>";
	     $_COLSPAN[$p]= array(2,4);
        }
	   else
	    {
	     $_DATA[$p]->button1 = "<br>".wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_CONFIRM_ECOMMERCE_ORDER,"misc_cart_order.png","",$w3->getWord(759)." (".$w3->getWord(1395)." $total $currency)","Confirm ".$w3->getWord(718))."<br><br>";
	     $_DATA[$p]->button2 = "<br>".wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_SHOW_ECOMMERCE_CART,"misc_cart.png","","",$w3->getWord(692))."<br><br>";
	     $_COLSPAN[$p]= array(2,4);
        }
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'',$_COLSPAN);
     $list->setTotalItems($total_items);
     $list->setCaptionLabels(array($w3->getWord(737),$w3->getWord(677),$w3->getWord(674),$w3->getWord(807)));
     $list->setCaptionWidths(array(50,10,10,30));
     $list->setCaptionColspan(array(1,1,1,1,1));
     $list->setWidths(array(50,10,10,30));
     $list->setEmptyLabel($w3->getWord(691)."<br><br>".wm3Util::actionButton("$base_link&action=".WM3_cACTION_SHOW_ECOMMERCE_ORDER,"misc_orders.png","","",$w3->getWord(1662))."<br><br>");
     if($admin) {
                 require(WM3_cPATH_INCLUDE.'admin_message_search_form.inc');
		         $list->setSearchForm($search_form);
                 $list->setTitle($w3->getWord(1142));
		         if($found) $list->setCurrentID($currentID);
		         $list->setMaxPageItems($max_page_items);
                 $list->setPage($pg);
                 $list->setPagesNavigatorLink($base_link.$id_link.$search_link);
			    }
     else       {
		         $list->setTitle('');
		         $list->setRenderPagesNavigator(false);
                }
     return $list->render();
    }

   public static function deleteEcommerceCartItem($w3,$cart_itemID)
    {
	 //TODO gestire bene ritorno prodotti in magazzino...
	 $userID = $w3->getAuthenticateUserID();
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items WHERE cart_itemID = '$cart_itemID' AND userID = '$userID' AND orderID = '0'");
	}

   public static function expireEcommerceCart($w3)
    {
	 // Delete item cart when are expired due to "ecommerce_cart_expire" preference
	 //TODO gestire bene ritorno prodotti in magazzino...
	 $ts = time() - $w3->getPreferences('ecommerce_cart_expire') *  86400;
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items WHERE ts < '$ts' AND orderID = '0'");
	}


   public static function getEcommerceProductData($w3,$categoryID,$subcategoryID,$productID)
    {
     // Used in class wm3Social to retrive data for facebook og
	 $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled='".WM3_cENABLED."'";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.productID = '$productID'
               $query_filter";
     $rs = $w3->getDBObj()->query($query);
     $row = $w3->getDBObj()->fetch($rs);
     
     $rs2 = $w3->getDBObj()->query("SELECT *
                                    FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
                                    WHERE productID='$productID' AND enabled='".WM3_cENABLED."' AND (languageID='".$w3->getHomeLanguage()."' OR languageID='".WM3_cLANGUAGE_ALL."')
                                    ORDER BY ts LIMIT 0,1");
     $row2 = $w3->getDBObj()->fetch($rs2);
     if($row2) $row->image = $row2->thumbnail;
     else      $row->image = '';
     return $row;
    }

   public static function getEcommercePictureFirst($w3,$categoryID,$subcategoryID,$productID,$pictureID = '',$thumbnail = true,$msg = 592)
    {
     // Get first picture or thumbnail (or $pictureID if defined) for a products (home side)
	 $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.languageID='".WM3_cLANGUAGE_ALL."')";
	 if($pictureID) $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.pictureID = '$pictureID'";
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.ts";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.productID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.productID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.productID = '$productID'
               $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by." LIMIT 0,1"); // Do the query limited to the first row
     $total_items = $w3->getDBObj()->totalRows($rs);
     if($total_items != 1)
	  {
	   return $w3->getWord($msg); // No picture
      }
     else
	  {
	   $row = $w3->getDBObj()->fetch($rs);
	   if($thumbnail) $picture = $row->thumbnail; else $picture = $row->picture;
	   return "<img src=\"".WM3_cPATH_ECOMMERCE."$picture\" border=\"0\" alt=\"$row->description\" title=\"$row->description\">";
      }
    }

   public static function getEcommerceProductCustomFieldLabel($w3,$fieldID,$admin = false)
    {
     // Get label for a custom ecommerce field (for actual languageID)
	 if($admin) $languageID = $w3->getAdminLanguage(); else $languageID = $w3->getHomeLanguage();
     $query = "SELECT *
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels
               WHERE  fieldID = '$fieldID' AND languageID = '$languageID'";
     $rs = $w3->getDBObj()->query($query);
     if($w3->getDBObj()->totalRows($rs) != 1) return '';
     $row = $w3->getDBObj()->fetch($rs);
     return $row->label;
	}

   public static function saveEcommerceCartItem($w3)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products      WRITE,
                                   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE,
  		 		                   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items   WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders        WRITE");
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceCartItemFieldsArray(),WM3_cQUOTE_DB);
	 if($_FIELD['quantity'] <= 0) { $w3->getDBObj()->query("UNLOCK TABLES"); return 1; } // Bad quantity
	 if(!wm3Ecommerce::existsEcommerceProduct($w3,$_FIELD['productID'])) { $w3->getDBObj()->query("UNLOCK TABLES"); return 2; } // Invalid product
	 $_FIELD['enabled']  = WM3_cENABLED;
	 $_FIELD['orderID']  = 0;
	 $_FIELD['userID']   = $w3->getAuthenticateUserID();
	 $_FIELD['price']    = wm3Ecommerce::getEcommerceProductPrice($w3,$_FIELD['productID']);
	 $_FIELD['discount'] = wm3Ecommerce::getEcommerceProductDiscount($w3,$_FIELD['productID']);

     $i = 0;
     while($w3->getVariable('option_label'.$i))
	  {
	   if($i == 0) $_FIELD['options'] .= $w3->getVariable('option_label'.$i);
	   else        $_FIELD['options'] .= "|".$w3->getVariable('option_label'.$i);
	   $_FIELD['options'] .= ",".$w3->getVariable('option'.$i);
	   $i++;
      }

     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_ecommerce_carts_items',$_FIELD);
	 
	 $w3->getDBObj()->query("UNLOCK TABLES");
     return 0;
    }

   public static function saveEcommerceCartOrder($w3)
    {
	 //TODO fare protezione da "reinvio form a causa di doppio click" (serve davvero visto che non si puo' ordinare se il carrello è vuoto?)
	 $userID = $w3->getAuthenticateUserID();
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products      WRITE,
                                   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE,
  		 		                   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items   WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders        WRITE");
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceOrderItemFieldsArray(),WM3_cQUOTE_DB);
	 //if($_FIELD['quantity'] <= 0) return 0; // Bad quantity
	 $_FIELD['userID']        = $userID;
	 $_FIELD['status']        = WM3_cECOMMERCE_ORDER_WAITING;
	 $_FIELD['shipping_cost'] = $w3->getPreferences('ecommerce_shipping_cost');
	 $_FIELD['enabled']       = WM3_cENABLED;
	 $_FIELD['ts'] = $_FIELD['order_ts'] = time();

     // Check if cart its empty and an user try to order
     $rs = $w3->getDBObj()->query("SELECT productID FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
                             WHERE orderID = '0' AND userID = '$userID'");
     if($w3->getDBObj()->totalRows($rs) < 1)
      {
       $w3->getDBObj()->query("UNLOCK TABLES");
       return "Order already processed!";
      }
     // Save order
     $w3->getDBObj()->saveAllTableFields('_ecommerce_orders',$_FIELD);
	 $orderID = $w3->getDBObj()->getLastInsertID();
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
	                   SET orderID = '$orderID' WHERE orderID = '0' AND userID = '$userID'");
     // Update product informations in the carts items
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
                             WHERE orderID = '$orderID' AND userID = '$userID'");
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   $product_code        = wm3Util::quoteDB(wm3Ecommerce::getEcommerceProductCode($w3,$row->productID));
	   $product_name        = wm3Util::quoteDB(wm3Ecommerce::getEcommerceProductName($w3,$row->productID));
	   $product_description = wm3Util::quoteDB(wm3Ecommerce::getEcommerceProductDescription($w3,$row->productID));
	   $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
	                        SET product_code        = '$product_code',
		  				        product_name        = '$product_name',
						        product_description = '$product_description'
					      WHERE cart_itemID = '$row->cart_itemID' AND orderID = '$orderID' AND userID = '$userID'");
      }

     // Create items
	 $_DATA = array();
	 $_DATA[0]->label = "Order number";
	 $_DATA[0]->value = "<b>$orderID</b>";
	 $_DATA[1]->label = "Order date";
	 $_DATA[1]->value = "<b>".wm3Util::renderDate($w3,$_FIELD['order_ts'],$w3->getHomeLanguage())."</b>";
	 $currency = $w3->getPreferences('ecommerce_currency');
	 $total = wm3Ecommerce::getEcommerceOrderTotal($w3,$orderID);
	 $_DATA[2]->label = "Order total";
	 $_DATA[2]->value = "<b>$total $currency</b>";
	 $url = $w3->getPreferences('ecommerce_credit_card_url')."?".$w3->getPreferences('ecommerce_variable_id')."=$orderID&".$w3->getPreferences('ecommerce_variable_price')."=$total";
	 $_DATA[3]->label = "<br>".$w3->getWord(761)." ".wm3Util::actionButton($url,"misc_cart.png","","",$w3->getWord(762),0,24,24,"absmiddle","_blank")."<br><br>";
     $_COLSPAN[3] = array(2);

     // Render List
     $list = new wm3GUIList($w3,$_DATA,"Order confirmed:<br><br>",$_COLSPAN);
     $list->setWidths(array(30,70));
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $w3->getDBObj()->query("UNLOCK TABLES");
     return $list->render();
    }

   public static function getCustomFieldStringName($lenght = false)
    {
	 $str = "custom_field";
	 if($lenght) return strlen($str);
	 else        return $str;
	}

   public static function getEcommerceOrderStatus($w3,$orderID)
    {
     // Get order status from orderID
     $rs = $w3->getDBObj()->query("SELECT status FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
                             WHERE  orderID = '$orderID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->status;
	}

   private static function existsEcommerceProduct($w3,$productID)
    {
     // Return true if the product with productID exists else return false
     $rs = $w3->getDBObj()->query("SELECT productID FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE  productID = '$productID'");
     if($w3->getDBObj()->totalRows($rs) == 1) return true;
	 else                         return false;
	}

   public static function isUsedEcommercePicture($w3,$file)
    {
	 // Return true if a picture its used in a row
	 $rs = $w3->getDBObj()->query("SELECT pictureID
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
							 WHERE  picture = '$file' OR  thumbnail = '$file'");
     if($w3->getDBObj()->totalRows($rs) == 0) return false;
	 else                         return true;
    }

  }

?>
