<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Expansion
  {
   private $path,$folder,$index,$type;
   private $version,$db_version,$wm_version;
   private $_CONFIG,$config_file,$exec_file;
   private $_PARAMETERS,$expansion_config;
   private $enabled,$error;

   function __construct($w3,$folder,$index,$type,$expansion_config,$id = 0,$admin = false)
    {
	 $this->index            = $index;
	 $this->type             = $type;
	 $this->expansion_config = $expansion_config;
	 if($id) $this->folder = $this->getExpansionFolderFromID($id); // Take expansion folder name from expansion ID
	 else    $this->folder = $folder;
	 $this->path             = WM3_cPATH_EXPANSION.$this->folder.'/';
	 $this->error            = $this->check($w3,$id,$admin);
	}

   public function exec($w3)
    {
     switch($this->error)
      {
       case 1: return "<br><b>Error: \"config.php\" file not found!</b><br>"; //TODO
	   case 2: return "<br><b>Expansion disabled!</b><br>"; //TODO;
	   case 3: return "<br><b>Error: expansion configuration error!</b><br>"; //TODO;
	   case 5: return "<br><b>Error: The minimum Webmatic version needed to use this expansion is ".$this->wm_version." </b><br>"; //TODO;
	   default:
	    {
		 // Get parameters from expansion_config
		 $this->_PARAMETERS = wm3Expansion::parseParameters($this->expansion_config);

         // Execute the expansion
         ob_start();
         require($this->exec_file);
	     $output = ob_get_contents();
	     ob_end_clean();
	     return $output;
        }
      }
	}

   private static function parseParameters($str)
    {
	 $_ARRAY = array();
	 $_TMP   = explode("\n",$str);
	 $len    = count($_TMP) - 1;
	 for($i = 0; $i < $len; $i++)
	  {
	   $p = trim(trim($_TMP[$i]),'[]');
	   $i++;
       $_ARRAY[$p] = trim($_TMP[$i]);
	  }
	 return $_ARRAY;
	}

   private function check($w3,$id,$admin)
    {
     // Check if there are some error in the expansion
     $this->config_file = $this->path.'config.php';
     if(!file_exists($this->config_file)) return 1; // No config file

     // Expansion configuration file exists and load it
     require($this->config_file);
     $this->_CONFIG = $_EXPANSION;
     if($this->type == WM3_cEXPANSION_TYPE_PANEL || $this->type == WM3_cEXPANSION_TYPE_PAGE)
      {
       $this->enabled   = $this->_CONFIG[$this->index][$this->type]['enabled'];
       if(!$this->enabled) return 2; // Expansion disabled
       $this->exec_file = $this->path.$this->_CONFIG[$this->index][$this->type]['exec'];
      }
     else
      {
	   $this->enabled = $this->_CONFIG[$this->type]['enabled'];
       if(!$this->enabled) return 2; // Expansion disabled
       $this->exec_file = $this->path.$this->_CONFIG[$this->type]['exec'];
      }
	 if(!file_exists($this->exec_file)) return 3; // Generic expansion exec error
	 if($id) if($this->folder == '')    return 4; // ID not found (for admin and user section only)
     $this->version    = $this->_CONFIG['version'];
     if(isset($this->_CONFIG['db_version'])) $this->db_version = $this->_CONFIG['db_version']; else $this->db_version = '0';
     $this->wm_version = $this->_CONFIG['wm_version'];
     if(!wm3Util::checkMinimumVersion(WM3_cVERSION,$this->wm_version)) return 5; // Current Webmatic version is too old to use this expansion

     // Load expansion language file
	 if($admin) $languageID = $w3->getAdminLanguage();
	 else       $languageID = $w3->getHomeLanguage();
     wm3Language::getLanguageFile($w3,$languageID,$this->path.$this->_CONFIG['language_path']);
     if(isset($this->_WORD_EXPANSION)) $w3->getLanguageObj()->setWordEpansionArray($this->_WORD_EXPANSION);

	 return 0; // No error
	}

   public function checkPermission($w3,$type)
    {
	 if($type == WM3_cEXPANSION_TYPE_ADMIN)
	  {
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                               WHERE userID = '".$w3->getAuthenticateAdminID()."' AND deleted = '".WM3_cDISABLED."' AND enabled = '".WM3_cENABLED."' AND admin = '".WM3_cENABLED."'");
       if($w3->getDBObj()->totalRows($rs) != 1) return false;
       $row = $w3->getDBObj()->fetch($rs);
       if($row->superuser)          return true;  // Superuser can access
       if($this->getSuOnly())       return false; // No other admin can access
       if($this->getGroupID() == 0) return true;  // No group specified, any administrator can access
       if($this->getGroupID() == $row->groupID) return true; else return false; // Only admin in groupID can access
      }
     if($type == WM3_cEXPANSION_TYPE_USER)
      {
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                               WHERE userID = '".$w3->getAuthenticateUserID()."' AND deleted = '".WM3_cDISABLED."' AND enabled = '".WM3_cENABLED."'");
       if($w3->getDBObj()->totalRows($rs) != 1) return false;
       $row = $w3->getDBObj()->fetch($rs);
       if($this->getGroupID() == 0) return true; // No group specified, any user can access
       if($this->getGroupID() == $row->groupID) return true; else return false; // Only user in groupID can access
	  }
	 return false;
	}

   private function getExpansionFolderFromID($id)
    {
     // Search an expansion with given ID
     $path     = WM3_cPATH_EXPANSION;
     $fd       = opendir($path);
     while(($file = readdir($fd)))
      {
       if($file != "." && $file != ".." && is_dir($path.$file)) // Do not render ".", ".."
        {
         $config_file = WM3_cPATH_EXPANSION.$file.'/config.php';
         if(file_exists($config_file))
          {
	       require($config_file);
           if($_EXPANSION['id'] == $id && $_EXPANSION[$this->type]['enabled']) return $file; // ID found, return the expansion folder name
          }
        }
      }
     closedir($fd);
     return ''; // ID not found (return empty string)
	}

   public static function getExpansionDataArray($w3,$type,$admin)
    {
     // Get all expansions installed in the expansion folder and return an array with expansion data
     $path = WM3_cPATH_EXPANSION;
     $fd   = opendir($path);
     $i = 0; $_DATA = array();
     while(($file = readdir($fd)))
      {
       if($file != "." && $file != ".." && is_dir($path.$file)) // Do not render ".", ".."
        {
         $_expansion = new wm3Expansion($w3,$file,0,$type,'',0,$admin);

         if($_expansion->getError() == 0)
          {
		   if($type == WM3_cEXPANSION_TYPE_PANEL || $type == WM3_cEXPANSION_TYPE_PAGE)
            {
			 $j = 0;
			 while(isset($_expansion->_CONFIG[$j][$type]['enabled']))
			  {
			   if($_expansion->_CONFIG[$j][$type]['enabled'])
				{
                 $_DATA['title'][$i]  = $_expansion->getTitle($w3)." (".$_expansion->getLabel($w3,$j).")";
                 $_DATA['folder'][$i] = $j."_".$file;
				 $i++;
			    }
			   $j++;
			  }
			 if($j==1 && !isset($_expansion->_CONFIG[0][$type]['label_index'])) $_DATA['title'][$i-1] = $_expansion->getTitle($w3);
			}
           else
		    { 
             if($_expansion->isEnabled() && $_expansion->checkPermission($w3,$type))
              {
               $_DATA['img'][$i]     = $_expansion->getIcon();
               $_DATA['title'][$i]   = $_expansion->getTitle($w3);
               $_DATA['alt'][$i]     = $_expansion->getLabel($w3);
               $_DATA['render'][$i]  = WM3_cENABLED;
	           $_DATA['section'][$i] = $_expansion->getID();
	           $_DATA['folder'][$i]  = $file;
	           $i++;
	          }
		    }
          }
        }
      }
     closedir($fd);
     return $_DATA;
    }

   public static function selectExpansion($w3,$type,$admin)
    {
     // Return an array of wm3GUIOption objects for expansions select
     $array = array(); $i = 0;
	 $_DATA = wm3Expansion::getExpansionDataArray($w3,$type,$admin);
	 if(count($_DATA) != 0)
      foreach($_DATA['title'] as $label)
	   {
	    array_push($array,new wm3GUIOption($label,$_DATA['folder'][$i]));
	    $i++;
       }
     return $array;
	}

   public function isEnabled() { return $this->enabled; }
   
   public function getID() { return $this->_CONFIG['id']; }

   public function getTitle($w3)
    {
	 if(isset($this->_CONFIG['title_index'])) return $w3->getWordExpansion($this->_CONFIG['title_index']);
	 else                                     return $w3->getWordExpansion(0);
	}

   public function getLabel($w3,$i = 0)
    {
	 if($this->type == WM3_cEXPANSION_TYPE_PANEL || $this->type == WM3_cEXPANSION_TYPE_PAGE)
	  {
       if(isset($this->_CONFIG[$i][$this->type]['label_index'])) return $w3->getWordExpansion($this->_CONFIG[$i][$this->type]['label_index']);
       else                                                      return $i;
	  }
	 if(isset($this->_CONFIG[$this->type]['label_index'])) return $w3->getWordExpansion($this->_CONFIG[$this->type]['label_index']);
	 else
	  {
	   if($this->type == WM3_cEXPANSION_TYPE_ADMIN) return $w3->getWordExpansion(1);
	   if($this->type == WM3_cEXPANSION_TYPE_USER)  return $w3->getWordExpansion(2);
      }
    }

   public function getHelpButton($w3)
    {
	 if(isset($this->_CONFIG[$this->type]['help_index'])) return " ".wm3Util::helpButton('misc_help.png',$w3->getWordExpansion($this->_CONFIG[$this->type]['help_index']),$w3->getWord(65));
	 else                                                 return '';
	}

   public function getParametersArray() { return $this->_PARAMETERS; }

   public function getParameter($name,$default = '')
    {
	 if(isset($this->_PARAMETERS[$name])) return $this->_PARAMETERS[$name];
	 return $default;
	}

   public function getPath()   { return $this->path; }

   public function getFolder() { return $this->folder; }
   
   public function getError()  { return $this->error; }
   
   public function getVersion()   { return $this->version; }
   
   public function getDbVersion() { return $this->db_version; }
   
   public function getWmVersion() { return $this->wm_version; }

   public function getSubMenu()
    {
	 // Return expansion submenu with path from WM3_cPATH_EXPANSION
     if(isset($this->_CONFIG[$this->type]['submenu']))
      {
       if($this->_CONFIG[$this->type]['submenu']) return $this->folder.'/'.$this->_CONFIG[$this->type]['submenu'];
       else                                       return '';
      }
    }

   public function getSuOnly()
    {
     if(isset($this->_CONFIG[$this->type]['su_only'])) return $this->_CONFIG[$this->type]['su_only'];
     else                                              return false;
    }

   public function getGroupID()
    {
     if(isset($this->_CONFIG[$this->type]['groupID'])) return $this->_CONFIG[$this->type]['groupID'];
     else                                              return 0;
    }

   public function getIcon()
    {
     if(isset($this->_CONFIG[$this->type]['icon'])) return $this->_CONFIG[$this->type]['icon'];
     else                                           return 'icon.png';
    }

   public function getBigIcon()
    {
     if(isset($this->_CONFIG[$this->type]['big_icon'])) return $this->_CONFIG[$this->type]['big_icon'];
     else                                               return 'icon.png';
    }

  }

?>
