<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Message
  {

   function __construct() { }

   public static function getMessageFieldsArray()
    {
     return array('messageID','render_mode','message','enabled','languageID','update_ts','categoryID','message_ts','ts');
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_MESSAGE:
        {
         wm3Message::disableMessage($w3,$w3->getVariable('messageID','get'));
         return wm3Message::getMessageList($w3,$w3->getVariable('messageID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MESSAGE:
        {
         wm3Message::enableMessage($w3,$w3->getVariable('messageID','get'));
         return wm3Message::getMessageList($w3,$w3->getVariable('messageID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MESSAGE:
        {
         wm3Message::deleteMessage($w3,$w3->getVariable('messageID','get'));
         return wm3Message::getMessageList($w3);
         break;
        }
       case WM3_cACTION_ADD_MESSAGE:
        {
         return wm3Message::addMessage($w3);
         break;
        }
       case WM3_cACTION_EDIT_MESSAGE:
        {
         return wm3Message::editMessage($w3);
         break;
        }
       case WM3_cACTION_DUPLICATE_MESSAGE:
        {
         $lastID = wm3Message::duplicateMessage($w3);
         // $msg= message duplicated... //TODO
         return wm3Message::getMessageList($w3,$lastID);
         break;
        }
       default:
        {
         return wm3Message::getMessageList($w3);
        }
      }
    }

   public static function getMessageList($w3,$currentID = 0,$admin = true)
    {
     // Get messages list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ); // Used to enable admin buttons in home stage
     $pg      = $w3->getVariable('pg');
     $filter  = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE message LIKE '%$filter%'";
      }
     else $search_link = $query_filter = '';
     if($admin)
      {
	   $search_form_link = WM3_cCONFIG_ADMIN_FILE;
      }
     else
      {
       if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
       $query_filter .= "enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'";
      }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MESSAGES;
     $id_link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_messages.message_ts DESC";
     $query    = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'messageID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0 && $admin) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&messageID=$row->messageID";
       if($allowed) $allowed_link = $base_allowed_link."&messageID=$row->messageID";
       $_DATA[$p]->message = wm3Util::renderContent($w3,$row->message,$row->render_mode);
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $_DATA[$p]->info = $lang_flag;
         // Buttons
         if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_MESSAGE,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_MESSAGE,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_MESSAGE,"action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DUPLICATE_MESSAGE,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1416));
         $_DATA[$p]->b4 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_MESSAGE,"action_delete.png",$w3->getWord(179),$w3->getWord(774));
        }
       else
        {
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MESSAGE,"action_edit.png",$w3->getWord(178));
        }
       if($row->messageID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1142));
     $list->setTotalItems($total_items);
     if($admin) {
		         require(WM3_cPATH_INCLUDE.'admin_message_search_form.inc');
		         $list->setSearchForm($search_form);
		         if($found) $list->setCurrentID($currentID);
		         $list->setMaxPageItems($max_page_items);
                 $list->setPage($pg);
                 $list->setPagesNavigatorLink($base_link.$id_link.$search_link);
                 $list->setCaptionLabels(array($w3->getWord(228),$w3->getWord(1671)));
                 $list->setCaptionWidths(array(70,30));
                 $list->setCaptionColspan(array(1,1,4));
                 $list->setWidths(array(70,30));
			    }
     else       {
		         $list->setTitle('');
		         $list->setRenderCaption(false);
		         $list->setRenderPagesNavigator(false);
                 $list->setWidths(array(100));
                }
     return $list->render();
    }

   public static function addMessage($w3)
    {
	 // Initialize form
	 $_FIELD = webmatic3::getPostValueArray(wm3Message::getMessageFieldsArray());
	 $action = WM3_cACTION_ADD_MESSAGE;
	 require(WM3_cPATH_INCLUDE.'admin_message_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(351));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3Message::saveMessage($w3);
         return wm3Message::getMessageList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function editMessage($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_MESSAGE;
	 require(WM3_cPATH_INCLUDE.'admin_message_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord(130));

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages
                                     WHERE messageID = '".$w3->getVariable('messageID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Message::getMessageFieldsArray(),$row);

       // Default value for fields not in $row object
       $_FIELD['update_ts'] = '';

       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Message::getMessageFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = wm3Message::updateMessage($w3);
         return wm3Message::getMessageList($w3,$lastID);
		}
      }

     // Operation to do before render the form
     $_F['update_ts']->setEnabled(true);

     return $form->render();
    }

   public static function saveMessage($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Message::getMessageFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['message_ts'] = $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_messages',$_FIELD,array('update_ts'));
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateMessage($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Message::getMessageFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['update_ts']) $message_ts = time(); else $message_ts = $_FIELD['message_ts'];     
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_messages
                       SET message     = '".$_FIELD['message']."',
					       render_mode = '".$_FIELD['render_mode']."',
                           message_ts  = '$message_ts',
                           enabled     = '".$_FIELD['enabled']."',
                           languageID  = '".$_FIELD['languageID']."'
                       WHERE messageID = '".$_FIELD['messageID']."'");
     return $_FIELD['messageID'];
    }

   public static function duplicateMessage($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages
                             WHERE messageID = '".$w3->getVariable('messageID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Message::getMessageFieldsArray(),$row,WM3_cQUOTE_DB);
       $_FIELD['message']    = $w3->getWord(1417).$_FIELD['message'];
       $_FIELD['enabled']    = WM3_cDISABLED;
       $_FIELD['message_ts'] = $_FIELD['ts'] = time();
       $w3->getDBObj()->saveAllTableFields('_messages',$_FIELD,array('update_ts'));
       return $w3->getDBObj()->getLastInsertID();
      }
    }

   public static function disableMessage($w3,$messageID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_messages SET enabled = '".WM3_cDISABLED."' WHERE messageID = '$messageID'");
	}

   public static function enableMessage($w3,$messageID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_messages SET enabled = '".WM3_cENABLED."' WHERE messageID = '$messageID'");
	}
   
   public static function deleteMessage($w3,$messageID)
    {
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_messages WHERE messageID = '$messageID'");
	}

  }

?>
