<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Page
  {
   private $pageID;
   private $title,$subtitle,$icon,$label,$submenu,$content;
   private $html;
   private $column_empty_left,$column_empty_right;
   private $render_home_content,$render_page_content,$render_news,$render_channels,$render_center_panels;

   function __construct()
    {
     $this->pageID   = 0;
     $this->title    = "";
     $this->subtitle = "";
	 $this->icon     = "";
	 $this->label    = "";
	 $this->submenu  = "";
	 $this->content  = "";
	 $this->render_head_foot    = true;
     $this->column_empty_left   = $this->column_empty_right = false;
     $this->render_home_content = $this->render_page_content = $this->render_news = $this->render_channels = $this->render_center_panels = false;
    }

   public static function getPageFieldsArray()
    {
     return array('pageID','title','subtitle','enabled','categoryID','page_type','visibility','groupID','backID','left_panels_enabled','right_panels_enabled','render_mode','head','body','foot','expansion','expansion_index','expansion_config','backID','hits','languageID','ts');
    }

   public function createHomePage($w3)
    {
     // Get home page content following the action
     switch($w3->getSection())
      {
       case WM3_cSECTION_PAGES:
        {
         // Get a dynamic page from db
         $w3->getPageObj()->setPageID($w3->getVariable('pageID'));
         $this->render_page_content = true;
         $this->getHomePage($w3);
         break;
        }
       case WM3_cSECTION_NEWS:
        {
         // Show single news/comments and more (for home page)
		 $this->hidePanelsActionHome($w3);
         $this->render_news = true;
         break;
        }
       case WM3_cSECTION_CHANNELS:
        {
         // Show subchannel blocks (for home page)
		 $this->hidePanelsActionHome($w3);
         $this->render_channels = true;
         break;
        }        
       default: // No section specified
        {
         switch($w3->getAction())
          {
		   case WM3_cACTION_CLICK_BANNER_EXCHANGE:
		    {
			 wm3Banner::clickBannerExchange($w3);
			 $this->renderDefaultHomeContent($w3);
			 break;
		    }
           case WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY:
            {
             // Show ecommerce subcategory (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = ""; // TODO
             $this->subtitle = "&nbsp;"; // TODO
             $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
             $this->html     = wm3Ecommerce::renderEcommerceSubcategoryList($w3,$w3->getVariable('subcategoryID'),false,false,true,true,true,true,false);
             break;
            }
           case WM3_cACTION_SHOW_ECOMMERCE_SPECIAL_OFFER:
            {
             // Show ecommerce special offer (for home page)
             $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = ""; // TODO
             $this->subtitle = "&nbsp;"; // TODO
             $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
             $this->html     = wm3Ecommerce::renderEcommerceProductList($w3,$w3->getVariable('productID'),false,true,true,true);
             break;
            }
           case WM3_cACTION_SHOW_ECOMMERCE_PRODUCT:
            {
             // Show ecommerce subcategory (for home page)
             $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = ""; // TODO
             $this->subtitle = "&nbsp;"; // TODO
             $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
             $this->html     = wm3Ecommerce::renderEcommerceProductList($w3,$w3->getVariable('productID'));
             break;
            }
           case WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT:
            {
             // Show ecommerce product (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = '';//TODO
             $this->subtitle = '&nbsp;';//TODO
             $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
             $this->html     = wm3Ecommerce::renderEcommerceSingleProduct($w3);
             break;
            }
           case WM3_cACTION_INFORMATIONS_SINGLE_ECOMMERCE_PRODUCT:
            {
             // More informations form for an ecommerce product (for home page)
			 $this->hidePanelsActionHome($w3);
			 if($w3->getPreferences('ecommerce_show_extra') == WM3_cENABLED)
			  {
               $this->render_page_content = true;
               $this->title    = '';//TODO
               $this->subtitle = '&nbsp;';//TODO
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
               $this->html     = wm3Ecommerce::renderEcommerceSingleProduct($w3,0,false,true,0,true);
		      }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_SEND_TO_FRIEND_SINGLE_ECOMMERCE_PRODUCT:
            {
             // Send to friend form for an ecommerce product (for home page)
			 $this->hidePanelsActionHome($w3);
			 if($w3->getPreferences('ecommerce_show_extra') == WM3_cENABLED)
			  {
               $this->render_page_content = true;
               $this->title    = '';//TODO
               $this->subtitle = '&nbsp;';//TODO
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
               $this->html     = wm3Ecommerce::renderEcommerceSingleProduct($w3,0,false,true,0,false,true);
		      }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_PRINTABLE_SINGLE_ECOMMERCE_PRODUCT:
            {
             // Show printable version of ecommerce product (for home page)
			 if($w3->getPreferences('ecommerce_show_extra') == WM3_cENABLED)
			  {
			   $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "";//TODO
               $this->subtitle = "&nbsp;";//TODO
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
			   wm3Ecommerce::renderEcommerceSingleProductPrintable($w3);
		      }
             break;
            }
           case WM3_cACTION_ADD_ECOMMERCE_CART_ITEM:
            {
             // Add ecommerce item cart and show current users cart (for home page)
			 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
              {
               if(!$w3->getAuthenticateUserID()) { header("Location: ".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER); die; } // Redirect to user login panel
               $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "Cart";//TODO
               $this->subtitle = "Item added to cart";//TODO
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
			   $error = wm3Ecommerce::saveEcommerceCartItem($w3);
			   if(!$error)
                $this->html = wm3Ecommerce::renderEcommerceCart($w3,0,false);
			   else
			    $this->html = wm3Ecommerce::renderEcommerceSingleProduct($w3,0,false,true,$error);
			  }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_DELETE_ECOMMERCE_CART_ITEM:
            {
             // Delete ecommerce item cart and show current users cart (for home page)
			 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
              {
               if(!$w3->getAuthenticateUserID()) { header("Location: ".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER); die; } // Redirect to user login panel
			   $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "Cart";//TODO
               $this->subtitle = "Item removed from cart";//TODO
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
		       wm3Ecommerce::deleteEcommerceCartItem($w3,$w3->getVariable('cart_itemID'));
               $this->html = wm3Ecommerce::renderEcommerceCart($w3,0,false);
			  }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_SHOW_ECOMMERCE_ORDER_ITEM:
            {
             // Show current user orders list (for home page)
			 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
              {
               if(!$w3->getAuthenticateUserID()) { header("Location: ".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER); die; } // Redirect to user login panel
               $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "Orders";//TODO
               $this->subtitle = "Order details";
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
               $this->html     = wm3Ecommerce::getEcommerceOrderItemList($w3,0,false);
		      }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_SHOW_ECOMMERCE_ORDER:
            {
             // Show current user orders list (for home page)
			 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
              {
               if(!$w3->getAuthenticateUserID()) { header("Location: ".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER); die; } // Redirect to user login panel
			   $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "Orders"; // TODO
               $this->subtitle = $w3->getWord(794);
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
               $this->html     = wm3Ecommerce::getEcommerceOrderList($w3,0,false);
		      }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_SHOW_ECOMMERCE_CART:
            {
			 // Show current user ecommerce cart (for home page)
			 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
              {
               if(!$w3->getAuthenticateUserID()) { header("Location: ".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER); die; } // Redirect to user login panel
               $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "Cart";//TODO
               $this->subtitle = $w3->getWord(734).wm3User::getUserLogin($w3,$w3->getAuthenticateUserID());
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
               $this->html     = wm3Ecommerce::renderEcommerceCart($w3,0,false);
		      }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_PROCESS_ECOMMERCE_ORDER:
            {
             // Process current user ecommerce cart to make an order (for home page)
			 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
              {
               if(!$w3->getAuthenticateUserID()) { header("Location: ".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER); die; } // Redirect to user login panel
			   $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "Order";//TODO
               $this->subtitle = "Current order details";//TODO
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
               $this->html     = wm3Ecommerce::renderEcommerceCart($w3,0,false,true);
		      }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_CONFIRM_ECOMMERCE_ORDER:
            {
             // Confirm and add an order from current user ecommerce cart (for home page)
			 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
              {
               if(!$w3->getAuthenticateUserID()) { header("Location: ".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER); die; } // Redirect to user login panel
			   $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "Order";//TODO
               $this->subtitle = "Complete current order";//TODO
               //$w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
	           $this->html     = wm3Ecommerce::saveEcommerceCartOrder($w3);
		      }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_SEARCH:
            {
             // Search function (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = $w3->getWord(527);
             $this->subtitle = ""; // Taked from next line
             $this->html     = wm3SearchEngine::renderUserSearchResult($w3);
             break;
            }
           case WM3_cACTION_SEND_TO_FRIEND:
            {
             // Send to friend function (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = "Send to friend";//TODO
             $this->subtitle = "Send to friend this website";//TODO
             $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WRITE,
	    	                               ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
		                                   ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
			 $error = wm3Newsletter::checkSendToFriendError($w3);
             if(!$error) {
                          $allowed = wm3Newsletter::addToNewsletterSendToFriend($w3);
		                  $w3->getDBObj()->query("UNLOCK TABLES");
                          $this->html = wm3Newsletter::sendSendToFriend($w3,$allowed);
                         }
             else        {
			              $w3->getDBObj()->query("UNLOCK TABLES");
			              $this->html = wm3Newsletter::renderSendToFriendError($w3,$error);
		                 }
             break;
            }
           case WM3_cACTION_NEWSLETTER_JOIN:
            {
             // Subscribe to the newsletter (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = $w3->getWord(374);
             $this->subtitle = "Join our newsletter";//TODO
             $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WRITE");
             $this->html     = wm3Newsletter::joinNewsletter($w3);
			 $w3->getDBObj()->query("UNLOCK TABLES");
             break;
            }
           case WM3_cACTION_NEWSLETTER://TODO serve???
            {
             // Add/remove newsletter function (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = "Email added";//TODO
             $this->subtitle = "added???";//TODO
             $this->html     = "Grazie email??? per esserti iscritto TODO"; //wm3SearchEngine::getSearchEngineItemList($w3); 
             break;
            }
           case WM3_cACTION_CHANGE_LANGUAGE:
            {
             // Switch to another home language and set cookie
             $this->render_home_content  = true;
             $this->render_news          = $w3->getPreferences('show_home_news');
             $this->render_center_panels = true;
             $languageID = wm3Language::writeCookieHomeLanguageID($w3,$_POST['languageID']);
             $w3->setHomeLanguage($languageID);
             $w3->getLanguageObj()->getLanguageFile($w3,$languageID);
             $w3->setPreferencesContents($w3);
             $this->html = $w3->getPreferencesContents('home');
			 $w3->setMenusArray(wm3Menu::getMenusDataArray($w3)); // Reload menus data from database
             break;
            }
           case WM3_cACTION_SURVEY_VOTE:
            {
             // Vote for a survey (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = "Vatazione sondaggio";//TODO
             $this->subtitle = "Voto registrato correttamente";//TODO
             $this->html     = wm3Survey::voteSurvey($w3);
             break;
            }
           case WM3_cACTION_SURVEY_RESULTS:
            {
             // Vote for a survey (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = $w3->getWord(887);
             $this->subtitle = $w3->getWord(841);
             $this->html     = wm3Survey::renderSurveyResult($w3);
             break;
            }
           case WM3_cACTION_CONSULT_HOROSCOPE:
            {
             // Consult horoscope (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = $w3->getWord(1752);
             $this->subtitle = "Daily horoscope";//TODO
             $this->html     = wm3Horoscope::renderHoroscopeConsult($w3);
             break;
            }
           case WM3_cACTION_RETRIEVE_PASSWORD:
            {
             // Retrieve a password from email (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = "Retrieve password";//TODO
             $this->subtitle = "Retrieve password from email";//TODO
             $this->html     = wm3User::renderRetrievePassword($w3);
             break;
            }
           case WM3_cACTION_SHOW_USER_INFORMATIONS:
            {
             // Show informations about an user (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = "User informations";//TODO
             $this->subtitle = "User informations";//TODO
			 if(!$w3->getAuthenticateAdminUserID()) $this->html = "<div align=\"center\"><img src=\"".WM3_cPATH_DATA."misc_stop.png\" width=\"48\" height=\"48\" border=\"0\"><br><br>".$w3->getWord(554)."</div>";
			 else                                   $this->html = wm3User::getSingleUserInformation($w3,0,$w3->getVariable('userID','get'),false);
             break;
            }
           default: // No section and no action specified
            {
			 $this->renderDefaultHomeContent($w3);
            }
          }
        }
      }
    }

   public function renderDefaultHomeContent($w3)
    {
	 // Get home page content from db and render it
     $this->render_home_content  = true;
     $this->render_news          = $w3->getPreferences('show_home_news');
     $this->render_center_panels = true;
     $this->html = $w3->getPreferencesContents('home');
	}

   public function createUserPage($w3)
    {
     // Get user page content
	 $this->render_home_content  = false;
     $this->render_page_content  = true;
     $this->render_news          = false;
     $this->render_channels      = false;
     $this->render_center_panels = false;
     if($w3->getAuthenticateUserID()) // User can access
      {
	   $_SEP  = $w3->getSkinObj()->getSeparator();
       $this->title    = $w3->getSkinObj()->getLeftPageTitle()."Webmatic ".WM3_cVERSION." (User control panel)".$w3->getSkinObj()->getRightPageTitle();
	   $this->subtitle = wm3Util::renderDate($w3,time(),$w3->getHomeLanguage(),true,'',false,true)." ".$w3->getWord(1528)." ".wm3User::getUserLogin($w3,$w3->getAuthenticateUserID())." $_SEP <a href=\"".WM3_cCONFIG_ADMIN_FILE."\">home</a> $_SEP <a href=\"".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER."&action=".WM3_cACTION_LOGOUT."\">logout</a>";
       switch($w3->getSection())
        {
         case WM3_cSECTION_USER_MESSAGES:
          {
           if(wm3User::checkUserPermission($w3,3)) // User messages
            {
             $w3->getSectionObj()->setParameters(wm3News::getSectionParameters());
             $this->label   = $w3->getWord(600);
             $this->icon    = wm3Util::renderImg("big_icon_users_messages.png",'',48,48);
             $this->submenu = "user_user_message_submenu.inc";
             $this->content = wm3UserMessage::executeUserAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_NEWS:
          {
           if(wm3User::checkUserPermission($w3,1)) // News
            {
             $w3->getSectionObj()->setParameters(wm3News::getSectionParameters());
             $this->label   = $w3->getWord(511);
             $this->icon    = wm3Util::renderImg("big_icon_news.png",'',48,48);
             $this->submenu = "user_news_submenu.inc";
             $this->content = wm3News::executeUserAction($w3,wm3User::checkUserPermission($w3,2));
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_FORUMS:
          {
           if(wm3User::checkUserPermission($w3,4)) // Forums
            {
             $w3->getSectionObj()->setParameters(wm3Forum::getSectionParameters());
             $this->label   = $w3->getWord(1375);
             $this->icon    = wm3Util::renderImg("big_icon_forum.png",'',48,48);
             $this->submenu = "user_forum_submenu.inc";
             $this->content = wm3Forum::executeUserAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_BANNERS:
          {
           if(wm3User::checkUserPermission($w3,5)) // Banners
            {
             //$w3->getSectionObj()->setParameters(wm3News::getSectionParameters());
             $this->label   = $w3->getWord(510);
             $this->icon    = wm3Util::renderImg("big_icon_banners.png",'',48,48);
             $this->submenu = "user_banner_submenu.inc";
             $this->content = wm3Banner::executeUserAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_MARKET:
          {
           if(wm3User::checkUserPermission($w3,6)) // Little market
            {
             $w3->getSectionObj()->setParameters(wm3Market::getSectionParameters());
             $this->label   = $w3->getWord(509);
             $this->icon    = wm3Util::renderImg("big_icon_market.png",'',48,48);
             $this->submenu = "user_market_submenu.inc";
             $this->content = wm3Market::executeUserAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_USER_INFORMATIONS:
          {
           $this->label   = $w3->getWord(398);
           $this->icon    = wm3Util::renderImg("quick_info_user.png",'',48,48);
           $this->submenu = "admin_user_information_submenu.inc";
           $this->content = wm3User::executeUserInformationUserAction($w3);
		   break;
          }
         default:
          {
           if($w3->getSection() >= WM3_cEXPANSION_SECTION_MIN) // Its an expansion ID
            {
             $_expansion = new wm3Expansion($w3,'',0,WM3_cEXPANSION_TYPE_USER,'',$w3->getSection());

             if(!$_expansion->getError() && $_expansion->checkPermission($w3,WM3_cEXPANSION_TYPE_USER))
              {
               // ID found and no errors, execute the expansion
               $this->label   = $_expansion->getLabel($w3).$_expansion->getHelpButton($w3);
               $this->icon    = wm3Util::renderImg($_expansion->getBigIcon(),'',48,48,$path = $_expansion->getPath());
               $this->submenu = $_expansion->getSubMenu();
               $this->content = $_expansion->exec($w3);
               break;
		      }
			}
           // No expansion ID found or expansion error (render admin homepage)
           $this->label   = $w3->getWord(501);
           $this->icon    = wm3Util::renderImg("big_icon_home_user.png",'',48,48);
           $this->submenu = "";
           $this->content = wm3Page::getUserHomepage($w3);
          }          
        }
      }
     else
      {
       switch($w3->getAction())
        {
         case WM3_cACTION_LOGIN: { $this->getUserLoginPage($w3,1); break; }
         default:                { $this->getUserLoginPage($w3); }
        } 
      }
    }

   public function createAdminPage($w3)
    {
     // Get admin page content
	 $this->render_home_content  = false;
     $this->render_page_content  = true;
     $this->render_news          = false;
     $this->render_channels      = false;
     $this->render_center_panels = false;
     if($w3->getAuthenticateAdminID()) // Administrator can access
      {
	   $_SEP  = $w3->getSkinObj()->getSeparator();
       $this->title    = $w3->getSkinObj()->getLeftPageTitle()."Webmatic ".WM3_cVERSION." (Admin control panel)".$w3->getSkinObj()->getRightPageTitle();
       $this->subtitle = wm3Util::renderDate($w3,time(),$w3->getAdminLanguage(),true,'',false,true)." ".$w3->getWord(1528)." ".wm3User::getUserLogin($w3,$w3->getAuthenticateAdminID())." $_SEP <a href=\"".WM3_cCONFIG_ADMIN_FILE."\">home</a> $_SEP <a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&action=".WM3_cACTION_LOGOUT."\">logout</a>";
       switch($w3->getSection())
        {
         case WM3_cSECTION_USER_MESSAGES:
          {
		   // No permission needed here
           $w3->getSectionObj()->setParameters(wm3News::getSectionParameters());
           $this->label   = $w3->getWord(600);
           $this->icon    = wm3Util::renderImg("big_icon_users_messages.png",'',48,48);
           $this->submenu = "admin_user_message_submenu.inc";
           $this->content = wm3UserMessage::executeAdminAction($w3);
		   break;
          }
         case WM3_cSECTION_FAQ:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ))
            {
             $w3->getSectionObj()->setParameters(wm3Faq::getSectionParameters());
             $this->label   = $w3->getWord(506)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(3),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_faq.png",'',48,48);
             $this->submenu = "admin_faq_submenu.inc";
             $this->content = wm3Faq::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_SEARCH_ENGINE:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_SEARCH_ENGINE))
            {
             $this->label   = $w3->getWord(507)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(4),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_searchengine.png",'',48,48);
             $this->submenu = "admin_search_engine_submenu.inc";
             $this->content = wm3SearchEngine::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_MARKET:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_MARKET))
            {
             $w3->getSectionObj()->setParameters(wm3Market::getSectionParameters());            	
             $this->label   = $w3->getWord(509)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(6),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_market.png",'',48,48);
             $this->submenu = "admin_market_submenu.inc";
             $this->content = wm3Market::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_BANNERS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_BANNERS))
            {
             $this->label   = $w3->getWord(510);
             $this->icon    = wm3Util::renderImg("big_icon_banners.png",'',48,48);
             $this->submenu = "admin_banner_submenu.inc";
             $this->content = wm3Banner::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_NEWS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS))
            {
             $w3->getSectionObj()->setParameters(wm3News::getSectionParameters());
             $this->label   = $w3->getWord(511)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(8),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_news.png",'',48,48);
             $this->submenu = "admin_news_submenu.inc";
             $this->content = wm3News::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_LINKS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_LINKS))
            {
             $w3->getSectionObj()->setParameters(wm3Link::getSectionParameters());
             $this->label   = $w3->getWord(512)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(9),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_links.png",'',48,48);
             $this->submenu = "admin_link_submenu.inc";
             $this->content = wm3Link::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }          
         case WM3_cSECTION_NEWSLETTER:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWSLETTER))
            {
             $this->label   = $w3->getWord(508)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(5),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_banners.png",'',48,48);
             $this->submenu = "admin_newsletter_submenu.inc";
             $this->content = wm3Newsletter::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_HOROSCOPE:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_HOROSCOPE))
            {
             $this->label   = $w3->getWord(514)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(11),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_horoscope.png",'',48,48);
             $this->submenu = "admin_horoscope_submenu.inc";
             $this->content = wm3Horoscope::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_MESSAGES:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_MESSAGES))
            {
             $this->label   = $w3->getWord(515);
             $this->icon    = wm3Util::renderImg("big_icon_messages.png",'',48,48);
             $this->submenu = "admin_message_submenu.inc";
             $this->content = wm3Message::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_MENUS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_MENUS))
            {
		     $w3->getSectionObj()->setParameters(wm3Channel::getSectionParameters());//???
             $this->label   = $w3->getWord(519);
             $this->icon    = wm3Util::renderImg("big_icon_menu.png",'',48,48);
             $this->submenu = "admin_menu_submenu.inc";
             $this->content = wm3Menu::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_PANELS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_PANELS))
            {
             $this->label   = $w3->getWord(516);
             $this->icon    = wm3Util::renderImg("big_icon_panels.png",'',48,48);
             $this->submenu = "admin_panel_submenu.inc";
             $this->content = wm3Panel::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_CHANNELS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_CHANNELS))
            {
             $w3->getSectionObj()->setParameters(wm3Channel::getSectionParameters());
             $this->label   = $w3->getWord(517)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(14),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_channels.png",'',48,48);
             $this->submenu = "admin_channel_submenu.inc";
             $this->content = wm3Channel::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_USERS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_USERS))
            {
             $this->label   = $w3->getWord(513);
             $this->icon    = wm3Util::renderImg("big_icon_users.png",'',48,48);
             $this->submenu = "admin_user_submenu.inc";
             $this->content = wm3User::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_PAGES:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES))
            {
             $this->label   = $w3->getWord(518)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(15),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_pages.png",'',48,48);
             $this->submenu = "admin_page_submenu.inc";
             $this->content = wm3Page::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_ECOMMERCE:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_ECOMMERCE))
            {
             $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
             $this->label   = $w3->getWord(656);
             $this->icon    = wm3Util::renderImg("big_icon_ecommerce.png",'',48,48);
             $this->submenu = "admin_ecommerce_submenu.inc";
             $this->content = wm3Ecommerce::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_SURVEYS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_SURVEYS))
            {
             $this->label   = $w3->getWord(835);
             $this->icon    = wm3Util::renderImg("big_icon_surveys.png",'',48,48);
             $this->submenu = "admin_survey_submenu.inc";
             $this->content = wm3Survey::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_FORUMS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS))
            {
             $w3->getSectionObj()->setParameters(wm3Forum::getSectionParameters());
             $this->label   = $w3->getWord(973);
             $this->icon    = wm3Util::renderImg("big_icon_forum.png",'',48,48);
             $this->submenu = "admin_forum_submenu.inc";
             $this->content = wm3Forum::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_DOWNLOADS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_DOWNLOADS))
            {
             $w3->getSectionObj()->setParameters(wm3Download::getSectionParameters());
             $this->label   = $w3->getWord(1036);
             $this->icon    = wm3Util::renderImg("big_icon_downloads.png",'',48,48);
             $this->submenu = "admin_download_submenu.inc";
             $this->content = wm3Download::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_DIRECTORIES:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_DIRECTORIES))
            {
             //$w3->getSectionObj()->setParameters(wm3Directory::getSectionParameters());
             $this->label   = $w3->getWord(1037);
             $this->icon    = wm3Util::renderImg("big_icon_directories.png",'',48,48);
             $this->submenu = "admin_directory_submenu.inc";
             $this->content = wm3Directory::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_MEDIA_ALBUMS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_MEDIA_ALBUMS))
            {
             $w3->getSectionObj()->setParameters(wm3MediaAlbum::getSectionParameters());
             $this->label   = $w3->getWord(1335);
             $this->icon    = wm3Util::renderImg("big_icon_albums.png",'',48,48);
             $this->submenu = "admin_media_album_submenu.inc";
             $this->content = wm3MediaAlbum::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_PREFERENCES:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_PREFERENCES))
            {
             $this->label   = $w3->getWord(27);
             $this->icon    = wm3Util::renderImg("big_icon_preferences.png",'',48,48);
             $this->submenu = "admin_preferences_submenu.inc";
             $this->content = wm3Preferences::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_METATAGS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_METATAGS))
            {
             $this->label   = $w3->getWord(1373);
             $this->icon    = wm3Util::renderImg("big_icon_metatags.png",'',48,48);
             $this->submenu = "admin_metatag_submenu.inc";
             $this->content = wm3Metatag::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_FOLDERS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_FOLDERS))
            {
             $this->label   = $w3->getWord(1374);
             $this->icon    = wm3Util::renderImg("big_icon_folders.png",'',48,48);
             $this->submenu = "admin_folder_submenu.inc";
             $this->content = wm3Folder::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_WEBMAIL:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_WEBMAIL))
            {
             $this->label   = $w3->getWord(1454);
             $this->icon    = wm3Util::renderImg("big_icon_webmail.png",'',48,48);
             $this->submenu = "admin_webmail_submenu.inc";
             $this->content = wm3Webmail::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_LANGUAGES:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_LANGUAGES))
            {
             $this->label   = $w3->getWord(1291);
             $this->icon    = wm3Util::renderImg("big_icon_languages.png",'',48,48);
             $this->submenu = "admin_language_submenu.inc";
             $this->content = wm3Language::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_STATISTICS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_STATISTICS))
            {
             $this->label   = $w3->getWord(54);
             $this->icon    = wm3Util::renderImg("big_icon_statistics.png",'',48,48);
             $this->submenu = "admin_statistic_submenu.inc";
             $this->content = wm3Statistic::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }

         case WM3_cSECTION_DATABASE: // Only superuser can manage database (backup and restore)
          {
           if(wm3User::isSuperUser($w3,$w3->getAuthenticateAdminID()) &&
              WM3_cCONFIG_USE_SUPERUSER_DATABASE_MANAGEMENT)
            {
             $this->label   = $w3->getWord(1281)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(26),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_database.png",'',48,48);
             $this->submenu = "admin_database_submenu.inc";
             $this->content = wm3Backup::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }

         case WM3_cSECTION_USER_INFORMATIONS:
          {
           $this->label   = $w3->getWord(398);
           $this->icon    = wm3Util::renderImg("quick_info_user.png",'',48,48);
           $this->submenu = "admin_user_information_submenu.inc";
           $this->content = wm3User::executeUserInformationAdminAction($w3);
		   break;
          }
         case WM3_cSECTION_WEBMATIC_INFORMATIONS:
          {
           $this->label   = "Webmatic informations";//$w3->getWord(398);
           $this->icon    = wm3Util::renderImg("big_icon_info.png",'',48,48);
           $this->submenu = "admin_webmatic_information_submenu.inc";   
           $this->content = wm3Statistic::executeWebmaticInformationAdminAction($w3);
		   break;
          }
         default:
          {
           if($w3->getSection() >= WM3_cEXPANSION_SECTION_MIN) // Its an expansion ID
            {
             $_expansion = new wm3Expansion($w3,'',0,WM3_cEXPANSION_TYPE_ADMIN,'',$w3->getSection(),true);

             if(!$_expansion->getError() && $_expansion->checkPermission($w3,WM3_cEXPANSION_TYPE_ADMIN))
              {
               // ID found and no errors, execute the expansion
               $this->label   = $_expansion->getLabel($w3).$_expansion->getHelpButton($w3);
               $this->icon    = wm3Util::renderImg($_expansion->getBigIcon(),'',48,48,$path = $_expansion->getPath());
               $this->submenu = $_expansion->getSubMenu();
               $this->content = $_expansion->exec($w3);
               break;
		      }
			}
           // No expansion ID found or expansion error (render admin homepage)
           $this->label   = $w3->getWord(501);
           $this->icon    = wm3Util::renderImg("big_icon_home_admin.png",'',48,48);
           $this->submenu = '';
           $this->content = wm3Page::getAdminHomepage($w3);
          }
        }
      }
     else
      {
       switch($w3->getAction())
        {
         case WM3_cACTION_LOGIN: { $this->getAdminLoginPage($w3,1); break; }
         default:                { $this->getAdminLoginPage($w3); }
        } 
      }
    }

   public function createChatPage($w3)
    {
     // Get chat page content following the action
     $this->render_home_content  = true;
     $this->render_page_content  = false;
     $this->render_news          = false;
     $this->render_channels      = false;
     $this->render_center_panels = false;
     wm3Chatroom::deleteChatroomExpiredSentences($w3);
     switch($w3->getAction())
      {
       case WM3_cACTION_JOIN_CHATROOM:
        {
         // Join an user in a chatroom
	     $this->html =  wm3Chatroom::joinChatroom($w3);
		 if(wm3Chatroom::isChatroomAllowed($w3))
		  $this->html .= wm3Util::metaRefresh(5,WM3_cCONFIG_CHAT_FILE."?stage=".WM3_cSTAGE_CHAT."&action=".WM3_cACTION_SHOW_CHATROOM_SENTENCE."&chatroomID=".$w3->getVariable('chatroomID','get')."&nickname=".$w3->getVariable('nickname','get'));
         break;
        }
       case WM3_cACTION_SHOW_CHATROOM_USER:
        {
         // Show chatroom current users
		 if(wm3Chatroom::isChatroomAllowed($w3) && wm3Session::chatroomSessionExists($w3))
		  {
           $this->html =  wm3Chatroom::renderChatroomUserList($w3);
		   $this->html .= wm3Util::metaRefresh(5,WM3_cCONFIG_CHAT_FILE."?stage=".WM3_cSTAGE_CHAT."&action=".WM3_cACTION_SHOW_CHATROOM_USER."&chatroomID=".$w3->getVariable('chatroomID','get')."&nickname=".$w3->getVariable('nickname','get'));
	      }
		 else $this->html = "";
         break;
        }
       case WM3_cACTION_SEND_CHATROOM_SENTENCE:
        {
         // Send a sentence in a chatroom
		 if(wm3Chatroom::isChatroomAllowed($w3) && wm3Session::chatroomSessionExists($w3))
		  {
	       $this->html =  wm3Chatroom::renderChatroomSentenceList($w3,wm3Chatroom::saveChatroomSentence($w3));
		   $this->html .= wm3Util::metaRefresh(5,WM3_cCONFIG_CHAT_FILE."?stage=".WM3_cSTAGE_CHAT."&action=".WM3_cACTION_SHOW_CHATROOM_SENTENCE."&chatroomID=".$w3->getVariable('chatroomID','get')."&nickname=".$w3->getVariable('nickname','get'));
	      }
		 else $this->html = "";
         break;
        }
       case WM3_cACTION_SHOW_CHATROOM_SENTENCE:
        {
         // Get chatroom sentences and render it
    	 if(wm3Chatroom::isChatroomAllowed($w3) && wm3Session::chatroomSessionExists($w3))
		  {
		   wm3Session::chatroomSessionUpdate($w3);
           $this->html =  wm3Chatroom::renderChatroomSentenceList($w3);
		   $this->html .= wm3Util::metaRefresh(5,WM3_cCONFIG_CHAT_FILE."?stage=".WM3_cSTAGE_CHAT."&action=".WM3_cACTION_SHOW_CHATROOM_SENTENCE."&chatroomID=".$w3->getVariable('chatroomID','get')."&nickname=".$w3->getVariable('nickname','get'));
	      }
	     else $this->html = "";
         break;
        }
       default: // No action specified
        {
         // Do nothing
         $this->html = "";
        }
      }
    }

   public function createRssPage($w3)
    {
     // Get rss page content following the action
     //TODO evitare aumento contatori quando si richiamano gli RSS? (evitare anche logs???)
	 $w3->getSectionObj()->setParameters(wm3News::getSectionParameters());
     $this->render_home_content  = true;
     $this->render_page_content  = false;
     $this->render_news          = false;
     $this->render_channels      = false;
     $this->render_center_panels = false;
     switch($w3->getAction())
      {
       case WM3_cACTION_SHOW_RSS_CATEGORY:
        {
         // Get news rss by category (for a certain language)
		 $this->html = wm3News::renderRssNews($w3);
         require(WM3_cPATH_INCLUDE."home_rss.inc");
         break;
        }
       case WM3_cACTION_SHOW_RSS_AUTHOR:
        {
         // Get news rss by author (for a certain language)
		 $this->html = wm3News::renderRssNews($w3);
		 require(WM3_cPATH_INCLUDE."home_rss.inc");
         break;
        }
       default: // No action specified
        {
		 // Get all news rss (for a certain language)
		 $this->html = wm3News::renderRssNews($w3);
		 require(WM3_cPATH_INCLUDE."home_rss.inc");
        }
      }
    }

   public function createBannerExchangePage($w3)
    {
     // Get banner exchange page content following the action
     //TODO evitare aumento contatori quando si richiamano gli RSS? (evitare anche logs???)
	 $w3->getSectionObj()->setParameters(wm3News::getSectionParameters());// Questo qui serve???
     $this->render_home_content  = true;
     $this->render_page_content  = false;
     $this->render_news          = false;
     $this->render_channels      = false;
     $this->render_center_panels = false;
     switch($w3->getAction())
      {
       default: // No action specified
        {
		 // Get a random banner (for a certain language)
		 $this->html = wm3Banner::renderBannerExchange($w3,true,true);
		 require(WM3_cPATH_INCLUDE."home_banner_exchange.inc");
        }
      }
    }

   public function createCaptchaPage($w3)
    {
     // Captcha page content following the action
     //TODO evitare aumento contatori quando si richiamano gli RSS? (evitare anche logs???)
     $this->render_home_content  = true;
     $this->render_page_content  = false;
     $this->render_news          = false;
     $this->render_channels      = false;
     $this->render_center_panels = false;
     switch($w3->getAction())
      {
       default: // No action specified
        {
		 // Output a captcha image
		 $this->html = wm3Captcha::makeCaptcha();
		 require(WM3_cPATH_INCLUDE."home_captcha.inc");
        }
      }
    }

   public function createKernelPage($w3)
    {
     // Execute a kernel action
     //TODO evitare aumento contatori quando si richiamano gli RSS? (evitare anche logs???)
     $this->render_home_content  = false;
     $this->render_page_content  = true;
     $this->render_news          = false;
     $this->render_channels      = false;
     $this->render_center_panels = false;
	 $this->html = wm3Kernel::execute($w3,$w3->getAction());
	 require(WM3_cPATH_INCLUDE."home_kernel.inc");
    }

   public function renderHomePage($w3)
    {
     // Render home page content with $w3->_skin
     if(wm3Section::isActionPrintable($w3)) // Render a printable content for home page
      {
       $title    = $this->title;
       $content  = $this->html;
       $subtitle = $this->subtitle;
      }
	 else
	  {
       $title    = $this->title; if($title) $title = $w3->getSkinObj()->getLeftPageTitle().$title.$w3->getSkinObj()->getRightPageTitle();
       $subtitle = $this->subtitle;
       $content  = $this->html;
	  }
     if($this->render_home_content)
	  {
	   if($w3->getStage() == WM3_cSTAGE_HOME) { if($w3->getPreferencesContents('home')) require($w3->getSkinObj()->getHome()); }
	   else                                   { require($w3->getSkinObj()->getHome()); }
      }
     if($this->render_page_content)  require($w3->getSkinObj()->getPage($w3));
     if($this->render_center_panels) $w3->getPanelObj()->renderPanels($w3,WM3_cPANEL_CENTER);
     if($this->render_news)
      {
       $w3->getSkinObj()->setCurrentSkinRender(WM3_cSKIN_RENDER_NEWS); // Set current skin render to news render
       $w3->getSectionObj()->setParameters(wm3News::getSectionParameters());
       wm3News::executeHomeAction($w3);
      }
     if($this->render_channels)
      {
       $w3->getSectionObj()->setParameters(wm3Channel::getSectionParameters());
       wm3Channel::renderChannelBlocks($w3);
      }
    }

   public function renderUserPage($w3)
    {
     // Render user page content with $w3->_skin
	 // TODO Se serve fare if per action printable (contenuto printabile per sezione utenti, vedi renderAdminPage qui sotto)
     $title    = $this->title;
     $subtitle = $this->subtitle;
	 $icon     = $this->icon;
     $label    = $this->label;
     $submenu  = $this->submenu;
     $content  = $this->content;
     require($w3->getSkinObj()->getUserPage($w3));
    }

   public function renderAdminPage($w3)
    {
     // Render admin page content with $w3->_skin
	 if(wm3Section::isActionPrintable($w3))
	  {
       $title    = $this->title;
	   $content  = $this->content;
	   $subtitle = $this->subtitle;
	   require($w3->getSkinObj()->getAdminPage($w3));
      }
	 else
	  {
       $title    = $this->title;
       $subtitle = $this->subtitle;
       $icon     = $this->icon;
       $label    = $this->label;
       $submenu  = $this->submenu;
       $content  = $this->content;
       require($w3->getSkinObj()->getAdminPage($w3));
      }
    }

   public static function renderPageExpansion($w3,$pageID)
    {
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages
                                   WHERE pageID = '$pageID' AND categoryID = '".WM3_cPAGE_CATEGORY_EXPANSION."'");
     if($w3->getDBObj()->totalRows($rs) != 1) return '';
     $row = $w3->getDBObj()->fetch($rs);

     $folder     = $row->expansion;
     $index      = $row->expansion_index; // Page index
     $parameters = $row->expansion_config;
     $_expansion = new wm3Expansion($w3,$folder,$index,WM3_cEXPANSION_TYPE_PAGE,$parameters);
     return $_expansion->exec($w3);
	}

   public function getHomePage($w3)
    {
     // Get page from db or make an error/denied access

     $error = wm3Page::checkPageAccessError($w3,$this->pageID);
     if(!$error) // Page exist and access granted
      {
	   wm3Page::hitPage($w3);
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages
                                     WHERE pageID = '$this->pageID'");
       $row = $w3->getDBObj()->fetch($rs);

       // Fast edit page button for admin
       if(wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES)) { $edit_button = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_PAGES."&action=".WM3_cACTION_EDIT_PAGE."&pageID=".$w3->getVariable('pageID'),"action_edit.png",$w3->getWord(178))." "; $hits = "<b> ($row->hits)</b>"; }
       else                                                      { $edit_button = ""; $hits = ""; }
       switch($row->categoryID)
        {
         case WM3_cPAGE_CATEGORY_MARKET:
          {
           $w3->getSectionObj()->setParameters(wm3Market::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Market::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_FAQ:
          {
           $w3->getSectionObj()->setParameters(wm3Faq::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Faq::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_SEARCH_ENGINE:
          {
           //$w3->getSectionObj()->setParameters(wm3SearchEngine::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3SearchEngine::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_USER_REGISTRATION:
          {
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3User::executeHomeAction($w3);
           break;
          }          
         case WM3_cPAGE_CATEGORY_LINKS:
          {
           $w3->getSectionObj()->setParameters(wm3Link::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Link::executeHomeAction($w3,$this->pageID); //TODO
           break;
          }
         case WM3_cPAGE_CATEGORY_STATISTICS:
          {
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Statistic::getStatisticBase($w3);
           break;
          }
         case WM3_cPAGE_CATEGORY_USER_INFORMATIONS:
          {
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3User::getPageUserInfo($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_FORUMS:
          {
           $w3->getSectionObj()->setParameters(wm3Forum::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Forum::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_DOWNLOADS:
          {
           $w3->getSectionObj()->setParameters(wm3Download::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Download::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_GUESTBOOKS:
          {
           //$w3->getSectionObj()->setParameters(wm3Guestbook::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Guestbook::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_DIRECTORIES:
          {
           //$w3->getSectionObj()->setParameters(wm3Directory::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Directory::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_MEDIA_ALBUMS:
          {
           $w3->getSectionObj()->setParameters(wm3MediaAlbum::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3MediaAlbum::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_CONTACT:
          {
           //$w3->getSectionObj()->setParameters(wm3Newsletter::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Newsletter::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_CHAT:
          {
           //$w3->getSectionObj()->setParameters(wm3Newsletter::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Chatroom::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_WEBMAIL:
          {
           //$w3->getSectionObj()->setParameters(wm3Newsletter::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Webmail::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_EXPANSION:
          {
           //$w3->getSectionObj()->setParameters(wm3Newsletter::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Page::renderPageExpansion($w3,$this->pageID);
           break;
          }
         default: // WM3_cPAGE_CATEGORY_CUSTOM
          {
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle =  $row->subtitle;
           $this->html     = wm3Util::renderContent($w3,$row->body,$row->render_mode);
          }
        }
       if($this->render_head_foot)
	    {
	     $this->html = wm3Util::renderContent($w3,$row->head,$row->render_mode).
	                   $this->html.
                       wm3Util::renderContent($w3,$row->foot,$row->render_mode);
        }

       // Render pages sequence links
       $this->html .= wm3Page::makePagesSequence($w3,$row->pageID);

       // Disable left or right columns if are off for the page
       if($row->left_panels_enabled == WM3_cDISABLED) // Left panels off
        {
         $this->column_empty_left = true;
         $w3->getPanelObj()->setColumnEmpty(WM3_cPANEL_LEFT,true);
        }
       if($row->right_panels_enabled == WM3_cDISABLED) // Right panels off
        {
         $this->column_empty_right = true;
         $w3->getPanelObj()->setColumnEmpty(WM3_cPANEL_RIGHT,true);
        }
      }
     else
      {
       // Page not exist or access denied
	   if($error == 1) // Page do not exists
	    {
		 $this->title = $this->subtitle = $w3->getWord(555);
		 $this->html = "<div align=\"center\"><img src=\"".WM3_cPATH_DATA."misc_error.png\" width=\"48\" height=\"48\" border=\"0\"><br><br><b>".$w3->getWord(553)."</b></div>";
		}
	   else // Page disabled or access denied
	    {
         $this->title = $this->subtitle = $w3->getWord(556);
         $this->html = "<div align=\"center\"><img src=\"".WM3_cPATH_DATA."misc_stop.png\" width=\"48\" height=\"48\" border=\"0\"><br><br><b>".$w3->getWord(554)."</b></div>";
         $this->html .= wm3Page::makePagesSequence($w3,$this->pageID);
		}
       $w3->getPanelObj()->setColumnEmpty(WM3_cPANEL_LEFT, true);
       $this->column_empty_left  = true;
       $w3->getPanelObj()->setColumnEmpty(WM3_cPANEL_RIGHT,true);       
       $this->column_empty_right = true;
      }
    }

   public function accessDeniedSection($w3)
    {
     $this->label   = "Access denied"; // TODO $w3->getWord(1010);
     $this->icon    = wm3Util::renderImg("misc_stop.png",'',48,48);
     $this->submenu = "admin_denied_submenu.inc";
     $this->content = "You do not have permission to enter in this section"; // TODO $w3->getWord(1010);
    }

   public function getUserLoginPage($w3,$error = 0)
    {
     // Make login page title and content
     $login_redirect = '';//TODO
     require(WM3_cPATH_INCLUDE.'user_login.inc'); // Login form
     $form->setSubmitLabel($w3->getWord(1240));
     $this->title    = "User login";
     $this->subtitle = "Insert login and password <a href=\"".WM3_cCONFIG_ADMIN_FILE."\">&lt;&lt;&lt;</a>";

     // Take variables value and set correct form style    
	 if($error)
	  {
	   $form->setError(true);
	   $form->setTitle($w3->getWord(289));
      }
     $this->html = $form->render();
    }

   public function getAdminLoginPage($w3,$error = 0)
    {
     // Make admin login page title and content
     $login_redirect = '';//TODO
     require(WM3_cPATH_INCLUDE.'admin_login.inc'); // Login form
     $form->setSubmitLabel($w3->getWord(1240));
     $this->title    = "Administrator login";
     $this->subtitle = "Insert login and password <a href=\"".WM3_cCONFIG_ADMIN_FILE."\">&lt;&lt;&lt;</a>";

     // Take variables value and set correct form style    
	 if($error)
	  {
	   $form->setError(true);
	   $form->setTitle($w3->getWord(289));
      }
     $this->html = $form->render();
    }

   public static function makePageLink($pageID,$title,$link_only = false)
    {
     // Make a link to a page (for a menu or for page list)
     $link = wm3Url::renderUrl($pageID);
     if($link_only) return $link;
     else           return wm3Util::makeLink($link,$title);
    }

   public static function makePagesSequence($w3,$pageID)
    {
     // Make pages sequence links for a page
     $icon_prev = "<img src=\"".WM3_cPATH_DATA."misc_prev.png\" width=\"14\" height=\"14\" align=\"absmiddle\" border=\"0\">";
     $icon_next = "<img src=\"".WM3_cPATH_DATA."misc_next.png\" width=\"14\" height=\"14\" align=\"absmiddle\" border=\"0\">";

     // Previous link
     $rs = $w3->getDBObj()->query("SELECT backID FROM ".WM3_cCONFIG_DB_PREFIX."_pages WHERE pageID = '$pageID'");
     $row = $w3->getDBObj()->fetch($rs); if(isset($row->backID)) $backID = $row->backID; else $backID = 0;
     $prev = '';
     if($backID)
      {
       $rs = $w3->getDBObj()->query("SELECT title FROM ".WM3_cCONFIG_DB_PREFIX."_pages WHERE pageID = '$backID'");
       if($w3->getDBObj()->totalRows($rs) == 1)
        {
	     $row = $w3->getDBObj()->fetch($rs);
         $prev .= "<nobr><a href=\"".wm3Page::makePageLink($backID,'',true)."\">$icon_prev $row->title</a></nobr>";
	    }
      }

     // Next links
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages WHERE backID = '$pageID' ORDER BY pageID");
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0;
     if($total_items == 0) // Check if there are any next links
      {
	   if($prev) { $_DATA[$p]->prev = $prev; $_DATA[$p]->center = $_DATA[$p]->next = ''; }
	   else      return '';
	  }
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $next = "<nobr><a href=\"".wm3Page::makePageLink($row->pageID,'',true)."\">$row->title $icon_next</a></nobr>";
       if($p == 0) { $_DATA[$p]->prev = $prev; $_DATA[$p]->center = ''; $_DATA[$p]->next = $next; }
       else        { $_DATA[$p]->prev = $_DATA[$p]->center = ''; $_DATA[$p]->next = $next; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setWidths(array(1,98,1));
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public static function getUserHomepage($w3)
    {
     // Render user home page
     $welcome        = "Welcome ".wm3User::getUserLogin($w3,$w3->getAuthenticateUserID());//.", you are administrator";
     $previous_login = "Previous login: ".wm3Util::renderDate($w3,wm3User::getUserLastLoginTimeStamp($w3,$w3->getAuthenticateUserID(),true),$w3->getHomeLanguage(),false,"Never logged");

     // Prepare variables and quick links array
     $columns = 4; $n = 0; // Quick links total number
     $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER."&section=".WM3_cSECTION_USER_INFORMATIONS,"quick_info_user.png","","",$w3->getWord(398),0,48,48);
     if(wm3User::checkUserPermission($w3,1))//TODO costanti WM3_cSECTION_NEWS...
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER."&section=".WM3_cSECTION_NEWS."&action=".WM3_cACTION_ADD_NEWS,"quick_add_news.png","","",$w3->getWord(347),0,48,48);
     $rows = (int)($n / $columns) + 1;

     // User home bar
     $_DATA = $_COLSPAN = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     $user_messages_label = wm3UserMessage::makeNotReadUserMessage($w3,889,$w3->getAuthenticateUserID());
     $user_messages = wm3Util::actionButton(WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER."&section=".WM3_cSECTION_USER_MESSAGES,"misc_message.png","","",$user_messages_label,0,15,10);
     $_DATA[0]->content = $user_messages."<br><br>"; $_COLSPAN[0] = array(4);

	 // Render quick links
     for($i = 0; $i < $rows; $i++)
      {
       for($j = 0; $j < $columns; $j++)
        {
		 $p = $j + $i * $columns; $quick = "quick$j";
         if($p < $n) $_DATA[$i+1]->$quick = $_QUICK_MENU[$p];
         else        $_DATA[$i+1]->$quick = '';
        }
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,"$welcome $_SEP $previous_login",$_COLSPAN);
     $list->setColumns($columns);
     $list->setRenderPagesNavigator(false);
     $list->setCaptionLabels(array("Quick link menu"));
     $list->setCaptionWidths(array(25,25,25,25));
     $list->setCaptionColspan(array(4));
     $list->setWidths(array(25,25,25,25));
     $list->setUseColors(false);
     return $list->render();
    }

   public static function getAdminHomepage($w3)
    {
     // Render admin home page
     switch($w3->getAction())
      {
       case WM3_cACTION_CHANGE_LANGUAGE:
        {
         // Switch to another admin language and set cookie
         $languageID = wm3Language::writeCookieAdminLanguageID($w3,$_POST['languageID']);
         $w3->setAdminLanguage($languageID);
         $w3->getLanguageObj()->getLanguageFile($w3,$languageID);
         break;
        }
      }
     $welcome        = "Welcome ".wm3User::getUserLogin($w3,$w3->getAuthenticateAdminID()).", you are administrator";
     $previous_login = "Previous login: ".wm3Util::renderDate($w3,wm3User::getAdminLastLoginTimeStamp($w3,$w3->getAuthenticateAdminID(),true),$w3->getAdminLanguage(),false,"Never logged");

     // Prepare variables and quick links array
     $columns = 4; $n = 0; // Quick links total number
     $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_USER_INFORMATIONS,"quick_info_user.png","","",$w3->getWord(398),0,48,48);
     if(wm3User::checkAdminPermission($w3,WM3_cSECTION_PREFERENCES))
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_PREFERENCES,"big_icon_preferences.png","","",$w3->getWord(27),0,48,48);
     if(wm3User::checkAdminPermission($w3,WM3_cSECTION_METATAGS))
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_METATAGS,"big_icon_metatags.png","","",$w3->getWord(1373),0,48,48);
     if(wm3User::checkAdminPermission($w3,WM3_cSECTION_STATISTICS))
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_STATISTICS,"big_icon_statistics.png","","",$w3->getWord(54),0,48,48);
	 // Only superuser can manage database
     if(wm3User::isSuperUser($w3,$w3->getAuthenticateAdminID()) &&
        WM3_cCONFIG_USE_SUPERUSER_DATABASE_MANAGEMENT)
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DATABASE,"big_icon_database.png","","",$w3->getWord(1281),0,48,48);
     if(wm3User::checkAdminPermission($w3,WM3_cSECTION_USERS))
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_USERS."&action=".WM3_cACTION_ADD_USER,"quick_add_user.png","","",$w3->getWord(349),0,48,48);
     if(wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS))
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_NEWS."&action=".WM3_cACTION_ADD_NEWS,"quick_add_news.png","","",$w3->getWord(347),0,48,48);
     if(wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES))
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_PAGES."&action=".WM3_cACTION_ADD_PAGE,"quick_add_page.png","","",$w3->getWord(354),0,48,48);
     $rows = (int)($n / $columns) + 1;

     // Admin home bar
     $_DATA = $_COLSPAN = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
	 $webmatic_info = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_WEBMATIC_INFORMATIONS,"misc_info.png","Webmatic informations","","",0,16,16);
     $user_messages_label = wm3UserMessage::makeNotReadUserMessage($w3,889,$w3->getAuthenticateAdminID());
     $user_messages = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_USER_MESSAGES,"misc_message.png","","",$user_messages_label,0,15,10);
     $_DATA[0]->content = $webmatic_info." $_SEP ".$user_messages."<br><br>"; $_COLSPAN[0] = array(4);

	 // Render quick links
     for($i = 0; $i < $rows; $i++)
      {
       for($j = 0; $j < $columns; $j++)
        {
		 $p = $j + $i * $columns; $quick = "quick$j";
         if($p < $n) $_DATA[$i+1]->$quick = $_QUICK_MENU[$p];
         else        $_DATA[$i+1]->$quick = '';
        }
      }

     // Render List
     $_F['languageID'] = new wm3GUISelect     ('languageID',$w3->getAdminLanguage(),'',wm3Language::selectLanguage($w3));
      $_F['languageID']->setExtraContentBefore($w3->getword(56).' ');
     $_F['send']       = new wm3GUIButton     ('send',      $w3->getWord(29));
     $_F['stage']      = new wm3GUIHiddenField('stage',     WM3_cSTAGE_ADMIN);
     $_F['action']     = new wm3GUIHiddenField('action',    WM3_cACTION_CHANGE_LANGUAGE);
     $form = new wm3GUIForm($w3,WM3_cCONFIG_ADMIN_FILE,'','wm3_form',$_F);
     $form->setUseWasSubmit(false);
     $form->setRenderHeader(false);
     $form->setRenderBottom(false);
     $form->setSimpleRender(true);
     $language_form = $form->render();

	 $_SEP = $w3->getSkinObj()->getSeparator();
     $list = new wm3GUIList($w3,$_DATA,"$welcome $_SEP $previous_login",$_COLSPAN);
     $list->setSearchForm($language_form);
     $list->setColumns($columns);
     $list->setRenderPagesNavigator(false);
     $list->setCaptionLabels(array("Quick link menu"));
     $list->setCaptionWidths(array(25,25,25,25));
     $list->setCaptionColspan(array(4));
     $list->setWidths(array(25,25,25,25));
     $list->setUseColors(false);
     return $list->render();
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_PAGE:
        {
         wm3Page::disablePage($w3,$w3->getVariable('pageID','get'));
         return wm3Page::getPageList($w3,$w3->getVariable('pageID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_PAGE:
        {
         wm3Page::enablePage($w3,$w3->getVariable('pageID','get'));
         return wm3Page::getPageList($w3,$w3->getVariable('pageID','get'));
         break;
        }
       case WM3_cACTION_DELETE_PAGE:
        {
         wm3Page::deletePage($w3,$w3->getVariable('pageID','get'));
         return wm3Page::getPageList($w3);
         break;
        }
       case WM3_cACTION_ADD_PAGE:
        {
         return wm3Page::addPage($w3);
         break;
        }
       case WM3_cACTION_EDIT_PAGE:
        {
         return wm3Page::editPage($w3);
         break;
        }
       case WM3_cACTION_DUPLICATE_PAGE:
        {
         $lastID = wm3Page::duplicatePage($w3);
         // $msg= page duplicated... //TODO
         return wm3Page::getPageList($w3,$lastID);
         break;
        }
       default:
        {
         return wm3Page::getPageList($w3);
        }
      }
    }

   public static function getPageList($w3,$currentID = 0,$admin = true)
    {
     // Get pages list

     // Prepare variables to create the list
     $max_page_items = 12;
     $pg     = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE body LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
     $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY pageID";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'pageID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0 && $admin) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&pageID=$row->pageID";
       if($row->visibility == WM3_cVISIBILITY_ALL)   $visibility_label = $w3->getWord(935);
       if($row->visibility == WM3_cVISIBILITY_USERS) $visibility_label = $w3->getWord(936);
       if($row->visibility == WM3_cVISIBILITY_GROUP) $visibility_label = $w3->getWord(1334);
       $group_label = wm3User::getGroupName($w3,$row->groupID);
       if($row->categoryID == 0) $type_label = $w3->getWord(544); // Custom page
       else                      $type_label = $w3->getLanguageObj()->translate(wm3Page::getPageCategoryName($w3,$row->categoryID));
       $_DATA[$p]->title = wm3Page::makePageLink($row->pageID,$row->title);
       $_DATA[$p]->group = "$type_label<br>(".$w3->getWord(1249).": $group_label)";
       $_DATA[$p]->info  = $w3->getWord(934).": $visibility_label<br>(hits $row->hits)";
       // Buttons
       if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_PAGE,"action_disable.png",$w3->getWord(180));
       else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_PAGE,"action_enable.png",$w3->getWord(181));
       $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_PAGE,"action_edit.png",$w3->getWord(178));
       $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DUPLICATE_PAGE,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1416));
       $_DATA[$p]->b4 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_PAGE,"action_delete.png",$w3->getWord(179),$w3->getWord(712));
       if($row->pageID == $currentID && !$found) {  $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1035));
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE."admin_page_search_form.inc");
     $list->setSearchForm($search_form);
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link.$id_link.$search_link);
     $list->setCaptionLabels(array($w3->getWord(1408),$w3->getWord(1409),$w3->getWord(1407)));
     $list->setCaptionWidths(array(40,30,30));
     $list->setCaptionColspan(array(1,1,1,4));
     $list->setWidths(array(40,30,30));
     return $list->render();
    }

   public static function addPage($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Page::getPageFieldsArray());
	 $action = WM3_cACTION_ADD_PAGE;
     require(WM3_cPATH_INCLUDE.'admin_page_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(164));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
       $_F['left_panels_enabled']->setValue(WM3_cENABLED);
       $_F['right_panels_enabled']->setValue(WM3_cENABLED);
       $_F['body']->setVisible(true);
       $_F['body_editor']->setVisible(true);
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3Page::savePage($w3);
         return wm3Page::getPageList($w3,$lastID);
		}
      }

     // Operation to do before render the form
	 if($_FIELD['categoryID'] == WM3_cPAGE_CATEGORY_EXPANSION) { $_F['expansion']->setVisible(true); $_F['expansion_config']->setVisible(true); }
	 if($_FIELD['categoryID'] == WM3_cPAGE_CATEGORY_CUSTOM)    { $_F['body']->setVisible(true); $_F['body_editor']->setVisible(true); }

     return $form->render();
    }

   public static function editPage($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_PAGE;
	 require(WM3_cPATH_INCLUDE.'admin_page_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit page");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages
                                     WHERE pageID = '".$w3->getVariable('pageID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Page::getPageFieldsArray(),$row);
       
       $_FIELD['expansion'] = $_FIELD['expansion_index'].'_'.$_FIELD['expansion'];
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Page::getPageFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = wm3Page::updatePage($w3);
         return wm3Page::getPageList($w3,$lastID);
		}
      }

     // Operation to do before render the form
     if($_FIELD['categoryID'] == WM3_cPAGE_CATEGORY_EXPANSION) { $_F['expansion']->setVisible(true); $_F['expansion_config']->setVisible(true); }
	 if($_FIELD['categoryID'] == WM3_cPAGE_CATEGORY_CUSTOM)    { $_F['body']->setVisible(true); $_F['body_editor']->setVisible(true); }

     return $form->render();
    }

   public static function savePage($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Page::getPageFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $_FIELD['expansion_index'] = strtok($_FIELD['expansion'],"_");
     $_FIELD['expansion']       = substr($_FIELD['expansion'],strlen($_FIELD['expansion_index']) + 1);
     $w3->getDBObj()->saveAllTableFields('_pages',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updatePage($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Page::getPageFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['expansion_index'] = strtok($_FIELD['expansion'],"_");
     $_FIELD['expansion']       = substr($_FIELD['expansion'],strlen($_FIELD['expansion_index']) + 1);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
                       SET title                = '".$_FIELD['title']."',
                           subtitle             = '".$_FIELD['subtitle']."',
                           head                 = '".$_FIELD['head']."',
                           body                 = '".$_FIELD['body']."',
                           foot                 = '".$_FIELD['foot']."',
						   expansion            = '".$_FIELD['expansion']."',
						   expansion_index      = '".$_FIELD['expansion_index']."',
						   expansion_config     = '".$_FIELD['expansion_config']."',
                           enabled              = '".$_FIELD['enabled']."',
                           categoryID           = '".$_FIELD['categoryID']."',
                           page_type            = '".$_FIELD['page_type']."',
                           visibility           = '".$_FIELD['visibility']."',
                           groupID              = '".$_FIELD['groupID']."',
                           backID               = '".$_FIELD['backID']."',
                           left_panels_enabled  = '".$_FIELD['left_panels_enabled']."',
                           right_panels_enabled = '".$_FIELD['right_panels_enabled']."',
						   render_mode          = '".$_FIELD['render_mode']."'
                       WHERE pageID             = '".$_FIELD['pageID']."'");
     return $_FIELD['pageID'];
    }

   public static function duplicatePage($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages
                             WHERE pageID = '".$w3->getVariable('pageID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Page::getPageFieldsArray(),$row,WM3_cQUOTE_DB);
       $_FIELD['title']   = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['hits']    = 0;
       $_FIELD['ts']      = time();
       $w3->getDBObj()->saveAllTableFields('_pages',$_FIELD);
       return $w3->getDBObj()->getLastInsertID();
      }
    }

   public static function disablePage($w3,$pageID) { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages SET enabled = '".WM3_cDISABLED."' WHERE pageID = '$pageID'"); }

   public static function enablePage($w3,$pageID)  { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages SET enabled = '".WM3_cENABLED."'  WHERE pageID = '$pageID'"); }

   public static function deletePage($w3,$pageID) 
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_pages WRITE");
     $rs = $w3->getDBObj()->query("SELECT backID FROM ".WM3_cCONFIG_DB_PREFIX."_pages WHERE pageID = '$pageID'");
     if($w3->getDBObj()->totalRows($rs) == 1)
      {
       $row = $w3->getDBObj()->fetch($rs);
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages SET backID = '$row->backID' WHERE backID = '$pageID'");
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_pages WHERE pageID = '$pageID'");
      }
	 $w3->getDBObj()->query("UNLOCK TABLES");
	}

   public static function selectPage($w3,$none = false)
    {
     // Return an array of wm3GUIOption objects for pages select
     $array = array();
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages");
     if($none) array_push($array,new wm3GUIOption('No page',0)); // Used for backID
     while($row = $w3->getDBObj()->fetch($rs))
      array_push($array,new wm3GUIOption($row->title,$row->pageID));
     return $array;
    }

   public static function selectPageCategory($w3)
    {
     // Return an array of wm3GUIOption objects for page categories select
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages_categories
                             ORDER BY position DESC, name");
     $array = array();
     while($row = $w3->getDBObj()->fetch($rs))
      {
       array_push($array,new wm3GUIOption($w3->getLanguageObj()->translate($row->name),$row->categoryID));
      }
     return $array;
    }

   public static function selectPageType($w3)
    {
     // Return an array of wm3GUIOption objects for page type select
     $array = array(new wm3GUIOption($w3->getWord(466),WM3_cPAGE_TYPE_CHANNELS),
	                new wm3GUIOption($w3->getWord(467),WM3_cPAGE_TYPE_NORMAL));
     return $array;
    }

   public static function getPageCategoryName($w3,$categoryID)
    {
     $rs = $w3->getDBObj()->query("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_pages_categories
                             WHERE categoryID = '$categoryID'");
     $row = $w3->getDBObj()->fetch($rs);
     return $row->name;
    }

   public static function checkPageAccessError($w3,$pageID)
    {
     // Check access permissions for a page
	 $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages
                                   WHERE pageID = '$pageID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 1; // Page do not exists
	 if(wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES)) return 0; // Access granted
	 $row = $w3->getDBObj()->fetch($rs);
	 if($row->enabled == WM3_cDISABLED) return 2; // Page disabled
	 if($row->visibility == WM3_cVISIBILITY_ALL) return 0; // Access granted
	 if($row->visibility == WM3_cVISIBILITY_USERS && !$w3->getAuthenticateUserID()) return 3; // Access denied
	 if($row->visibility == WM3_cVISIBILITY_GROUP && $row->groupID != wm3User::getGroupID($w3,$w3->getAuthenticateUserID())) return 3; // Access denied
    }

   public static function hitPage($w3)
    {
     $pageID = $w3->getVariable('pageID','get');
	 if(!wm3Session::pageAllowed($w3,$pageID,WM3_cSESSION_HIT)) return;
	 else wm3Session::pageProtect($w3,$pageID,WM3_cSESSION_HIT);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
                       SET    hits = hits + 1
                       WHERE  pageID = '$pageID'");
    }

   public function isColumnEmpty($align) 
    {
     if($align == WM3_cPANEL_LEFT)  return $this->column_empty_left;
     if($align == WM3_cPANEL_RIGHT) return $this->column_empty_right;
    }

   public function hidePanelsActionHome($w3)
    {
	 // Hide left/right panels if an home action its performed (take values from preferences)
     $this->column_empty_left = $w3->getPreferences('hide_left_panels_action_home');
     $w3->getPanelObj()->setColumnEmpty(WM3_cPANEL_LEFT,$this->column_empty_left);
     $this->column_empty_right = $w3->getPreferences('hide_right_panels_action_home');
     $w3->getPanelObj()->setColumnEmpty(WM3_cPANEL_RIGHT,$this->column_empty_right);
	}

   public function existsPage($w3,$pageID)
    {
     // Return true if the page with pageID exists else return false
     $rs = $w3->getDBObj()->query("SELECT pageID FROM ".WM3_cCONFIG_DB_PREFIX."_pages
                             WHERE  pageID = '$pageID'");
     if($w3->getDBObj()->totalRows($rs) == 1) return true;
	 else                                     return false;
	}

   public function getPageID()      { return $this->pageID; }

   public function setPageID($id)   { $this->pageID = $id; }

   public function setTitle($t)     { $this->title = $t; }

   public function setSubTitle($st) { $this->subtitle = $st; }
   
   public function setPageContent($st) { $this->html = $st; }

   public function setRenderHeadFoot($b) { $this->render_head_foot = $b; }

  }

?>
